// FDSrcNames.cpp : implementation file
//

#include "stdafx.h"
#include "FDSrcNames.h"
#include "FileDetails.h"
#include "..\UpDownClient.h"
#include "..\TitleMenu.h"
#include "..\emule.h"

// CFDSrcNames dialog

IMPLEMENT_DYNCREATE(CFDSrcNames, CPropertyPage)

CFDSrcNames::CFDSrcNames() : CPropertyPage(CFDSrcNames::IDD)
{
	//{{AFX_DATA_INIT(CFDSrcNames)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDSrcNames::~CFDSrcNames()
{
}

void CFDSrcNames::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDSrcNames)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_FDS_TAKEOVER, m_ctrlTakeOver);
	DDX_Control(pDX, IDC_CLEANUP, m_ctrlCleanUp);
	DDX_Control(pDX, IDC_RENAME, m_ctrlRename);
	DDX_Control(pDX, IDC_FILENAME, m_ctrlFilename);
}


BEGIN_MESSAGE_MAP(CFDSrcNames, CPropertyPage)
	//{{AFX_MSG_MAP(CFDSrcNames)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RENAME, OnBnClickedRename)
	ON_BN_CLICKED(IDC_CLEANUP, OnBnClickedCleanup)
	ON_BN_CLICKED(IDC_FDS_TAKEOVER, OnBnClickedFdsTakeover)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_SOURCENAMES, OnLvnColumnclick)
	ON_NOTIFY(NM_DBLCLK, IDC_SOURCENAMES, OnNMDblclkList)
	ON_NOTIFY(NM_RCLICK, IDC_SOURCENAMES, OnNMRclickList)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDSrcNames message handlers

void CFDSrcNames::Update()
{
	EMULE_TRY

	if(m_pFile == NULL)
		return;
	
	if(!::IsWindow(GetSafeHwnd()))
		return;

	bool bEnable =	m_pFile->GetStatus() == PS_COMPLETE		||
					m_pFile->GetStatus() == PS_COMPLETING	?	false : true;

	m_ctrlRename.EnableWindow(bEnable);
	m_ctrlCleanUp.EnableWindow(bEnable);
	m_ctrlTakeOver.EnableWindow(bEnable);	

	FillSourcenameList();

	EMULE_CATCH
}

void CFDSrcNames::FillSourcenameList() 
{
	EMULE_TRY

	CUpDownClient* cur_src;
	CListCtrl* pmyListCtrl; 
	LVFINDINFO info; 
	info.flags = LVFI_STRING; 
	int itempos; 
	int namecount;

	CString nameCountStr;
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES); 
	if(pmyListCtrl->GetHeaderCtrl()->GetItemCount() < 2) 
	{
		pmyListCtrl->DeleteColumn(0); 
		pmyListCtrl->InsertColumn(0, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 240, -1); 
		pmyListCtrl->InsertColumn(1, GetResString(IDS_DL_SOURCES), LVCFMT_LEFT, 60, 1); 
	}

	//v- eklmn: bugfix(16): don't show empty string in FileDetails
	CString strFileName; 
	POSITION pos1, pos2;
	pmyListCtrl->DeleteAllItems(); 
	for(int sl=0;sl<SOURCESSLOTS;sl++) 
	{
		if(!m_pFile->m_srcLists[sl].IsEmpty())
		{
			for(pos1 = m_pFile->m_srcLists[sl].GetHeadPosition(); (pos2 = pos1) != NULL;) 
			{
				m_pFile->m_srcLists[sl].GetNext(pos1);
				cur_src = m_pFile->m_srcLists[sl].GetAt(pos2);

				if(cur_src->m_pReqPartFile == m_pFile)
				{
					strFileName = cur_src->GetClientFilename(); 
					if(strFileName.GetLength() != 0) 
					{ 
						info.psz = strFileName;
						if((itempos=pmyListCtrl->FindItem(&info, -1)) == -1) 
						{ 
							pmyListCtrl->InsertItem(0, strFileName); 
							pmyListCtrl->SetItemText(0, 1, _T("1")); 
							pmyListCtrl->SetItemData(0, 1); 
						} 
						else 
						{ 
							namecount = _tstoi(pmyListCtrl->GetItemText(itempos, 1)); 
							namecount ++; 
							nameCountStr.Format(_T("%i"), namecount); 
							pmyListCtrl->SetItemText(itempos, 1, nameCountStr.GetString());
							pmyListCtrl->SetItemData(itempos, namecount); 
						} 
						pmyListCtrl->SortItems(CompareListNameItems, 11); 
						m_bSortAscending[0] =true;
						m_bSortAscending[1] =false;
					}
				}
			} 
		}
	}

	EMULE_CATCH
}

void CFDSrcNames::OnBnClickedRename()
{
	EMULE_TRY

	CString strNewFileName; 
	m_ctrlFilename.GetWindowText(strNewFileName);

	m_pFile->SetFileName(strNewFileName.GetBuffer()); 
	m_pFile->SavePartFile(); 

	CFileDetails* pParent = (CFileDetails*)GetParent();
	if(pParent != NULL)
	{
		pParent->UpdateData();
	}

	EMULE_CATCH
}

void CFDSrcNames::OnBnClickedCleanup()
{
	EMULE_TRY

	CString strFilename = "";
	m_ctrlFilename.ReplaceSel(strFilename.GetBuffer());
	m_ctrlFilename.GetWindowText(strFilename);
	m_ctrlFilename.SetWindowText(CleanupFilename(strFilename));

	EMULE_CATCH
}

void CFDSrcNames::OnBnClickedFdsTakeover()
{
	EMULE_TRY

	CListCtrl* pmyListCtrl; 
	int itemPosition; 

	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	if(pmyListCtrl->GetSelectedCount() > 0) 
	{
		POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition(); 
		itemPosition = pmyListCtrl->GetNextSelectedItem(pos); 
		GetDlgItem(IDC_FILENAME)->SetWindowText(pmyListCtrl->GetItemText(itemPosition,0));
	} 

	EMULE_CATCH
}

void CFDSrcNames::OnLvnColumnclick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	m_bSortAscending[pNMLV->iSubItem] = !m_bSortAscending[pNMLV->iSubItem];
	////SetSortArrow(pNMLV->iSubItem, m_bSortAscending[pNMLV->iSubItem]);

	CListCtrl* pmyListCtrl; 
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);

	pmyListCtrl->SortItems(&CompareListNameItems, pNMLV->iSubItem + ((m_bSortAscending[pNMLV->iSubItem]) ? 0 : 10));

	*pResult = 0;

	EMULE_CATCH
}

void CFDSrcNames::OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	OnBnClickedFdsTakeover();
	*pResult = 0;
}

void CFDSrcNames::OnNMRclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	CListCtrl* pmyListCtrl; 
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);
	POINT point;
	::GetCursorPos(&point);
	CTitleMenu	popupMenu;

	UINT flag;
	flag = MF_STRING;
	if(pmyListCtrl->GetSelectionMark() == -1) 
	{
		flag = MF_GRAYED;
	}

	popupMenu.CreatePopupMenu();
	popupMenu.AppendMenu(flag,MP_MESSAGE, GetResString(IDS_TAKEOVER));
	popupMenu.AppendMenu(MF_STRING, MP_RESTORE, GetResString(IDS_SV_UPDATE));
	popupMenu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	popupMenu.DestroyMenu();

	*pResult = 0;
}

BOOL CFDSrcNames::OnCommand(WPARAM wParam,LPARAM lParam )
{
	CListCtrl* pmyListCtrl; 
	pmyListCtrl = (CListCtrl*)GetDlgItem(IDC_SOURCENAMES);
	
	if(pmyListCtrl->GetSelectionMark() != -1)
	{
		switch (wParam)
		{
			case MP_MESSAGE:
			{
				OnBnClickedFdsTakeover();
				return true;
			}
			case MP_RESTORE: 
			{
				FillSourcenameList();
				return true;
			}
		}
	}

	if(wParam == 2)
	{
		CPropertyPage::OnOK();
		return TRUE;
	}

	return CPropertyPage::OnCommand(wParam, lParam);
}

int CALLBACK CFDSrcNames::CompareListNameItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{ 
	switch(lParamSort)
	{
		case 1: 
			return (lParam1 - lParam2); 
			break;
		
		case 11: 
			return (lParam2 - lParam1); 
			break;
		
		default: 
			return 0;
	}
} 

BOOL CFDSrcNames::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	Localize();
	Update();

	m_ctrlFilename.SetWindowText(m_pFile->GetFileName());

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFDSrcNames::Localize()
{
	if(GetSafeHwnd())
	{
		GetDlgItem(IDC_FDS_TAKEOVER)->SetWindowText(GetResString(IDS_TAKEOVER));
		GetDlgItem(IDC_CLEANUP)->SetWindowText(GetResString(IDS_CLEANUP));
		GetDlgItem(IDC_RENAME)->SetWindowText(GetResString(IDS_RENAME));
	}
}

void CFDSrcNames::OnOK()
{
	OnBnClickedRename();
}
