//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// DownloadListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "DownloadListCtrl.h"
#include "otherfunctions.h" 
#include "updownclient.h"
#include "opcodes.h"
#include ".\\Details\\ClientDetails.h"
#include ".\\Details\\FileDetails.h"
#include "commentdialoglst.h"
#include "KeyboardShortcut.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CDownloadListCtrl

#define DLC_DT_TEXT (DT_LEFT|DT_SINGLELINE|DT_VCENTER|DT_NOPREFIX|DT_END_ELLIPSIS)
#define DLC_BARUPDATE 512

//#region message map
BEGIN_MESSAGE_MAP(CDownloadListCtrl, CMuleListCtrl)
	ON_NOTIFY_REFLECT(LVN_ITEMACTIVATE, OnItemActivate)
	ON_NOTIFY_REFLECT(LVN_ITEMCHANGED, OnListModified)
	ON_NOTIFY_REFLECT(LVN_INSERTITEM, OnListModified)
	ON_NOTIFY_REFLECT(LVN_DELETEITEM, OnListModified)
	ON_WM_CONTEXTMENU()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMDblclkDownloadlist)
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)	
	ON_NOTIFY_REFLECT(LVN_GETDISPINFO, OnGetDispInfo)
	ON_WM_SIZE()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
END_MESSAGE_MAP()
//#endregion

IMPLEMENT_DYNAMIC(CDownloadListCtrl, CListBox)

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CDownloadListCtrl::CDownloadListCtrl() 
{
	m_iCurrentSortItem = DLCOL_FILENAME;
	m_bSortAscending = true;
	m_iSourceSortItem = DLCOL_FILENAME;
	m_bSortSourcesAscending = true;
	m_iSourceSortItem2 = -1;
	m_bSortSourcesAscending2 = true;
	m_bShowSrc = false;
	m_dwLastSortCode = DLCOL_FILENAME;
	m_dwSortTime = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CDownloadListCtrl::~CDownloadListCtrl()
{
	EMULE_TRY

	m_imageList.DeleteImageList();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::Init()
{
	EMULE_TRY

	CImageList		ilDummyImageList;

	ilDummyImageList.Create(1, 17, ILC_COLOR32 | ILC_MASK, 1, 1);
	SetImageList(&ilDummyImageList, LVSIL_SMALL);
	ASSERT((GetStyle() & LVS_SHAREIMAGELISTS) == 0);
	ilDummyImageList.Detach();
	
	SetStyle();
	SetColors();

	m_bSmartFilter = false;

	FilterNoSources();

	ModifyStyle(LVS_SINGLESEL,0);

	for (int i = 0; i < DLCOL_NUMCOLUMNS; i++)
	{
		m_iColumnMaxWidths[i] = 0;
	}
//	Index of the column being measured. -1 for none.
	m_iMeasuringColumn = -1;

	InsertColumn(DLCOL_FILENAME,GetResString(IDS_DL_FILENAME),LVCFMT_LEFT, 260);
	InsertColumn(DLCOL_SIZE,GetResString(IDS_DL_SIZE),LVCFMT_RIGHT, 60);
	InsertColumn(DLCOL_TRANSFERRED,GetResString(IDS_DL_TRANSF),LVCFMT_RIGHT, 65);
	InsertColumn(DLCOL_COMPLETED,GetResString(IDS_SF_COMPLETED),LVCFMT_RIGHT, 65);
	InsertColumn(DLCOL_SPEED,GetResString(IDS_DL_SPEED),LVCFMT_RIGHT, 65);
	InsertColumn(DLCOL_PROGRESS,GetResString(IDS_DL_PROGRESS),LVCFMT_LEFT, 170);
	InsertColumn(DLCOL_NUMSOURCES,GetResString(IDS_DL_SOURCES),LVCFMT_RIGHT, 50);
	InsertColumn(DLCOL_PRIORITY,GetResString(IDS_PRIORITY),LVCFMT_LEFT, 55);
	InsertColumn(DLCOL_STATUS,GetResString(IDS_STATUS),LVCFMT_LEFT, 70);
	InsertColumn(DLCOL_REMAINING,GetResString(IDS_DL_REMAINS),LVCFMT_LEFT, 110);
// PLUS -----------------------------------------------------------------------
	InsertColumn(DLCOL_REMAININGTIME,GetResString(IDS_DLCOL_REMAININGTIME),LVCFMT_LEFT, 110); // should be est. time or ETA
	InsertColumn(DLCOL_ULDLRATIO,GetResString(IDS_DL_ULDL),LVCFMT_RIGHT,60);		//netwolf 05.05.03 (right justified)
	InsertColumn(DLCOL_QLRATING,GetResString(IDS_QL_RATING),LVCFMT_RIGHT,60);	//netwolf 05.05.03 (right justified)
//-----------------------------------------------------------------------------
	CString lsctitle = GetResString(IDS_LASTSEENCOMPL);
	lsctitle.Remove(':');
	InsertColumn(DLCOL_LASTSEENCOMPLETE, lsctitle,LVCFMT_LEFT, 110);
	lsctitle = GetResString(IDS_FD_LASTCHANGE);
	lsctitle.Remove(':');
	InsertColumn(DLCOL_LASTRECEIVED, lsctitle, LVCFMT_LEFT, 220);
	InsertColumn(DLCOL_CATEGORY, GetResString(IDS_CAT), LVCFMT_LEFT, 100);
	InsertColumn(DLCOL_WAITED,GetResString(IDS_WAITED),LVCFMT_LEFT,110);
	InsertColumn(DLCOL_AVGSPEED,GetResString(IDS_DLCOL_AVGSPEED),LVCFMT_RIGHT,100);
	InsertColumn(DLCOL_AVGREMTIME,GetResString(IDS_DLCOL_AVGREMTIME),LVCFMT_RIGHT,100);
	InsertColumn(DLCOL_ETA,GetResString(IDS_DLCOL_ETA),LVCFMT_RIGHT,100);
	InsertColumn(DLCOL_AVGETA,GetResString(IDS_DLCOL_AVGETA),LVCFMT_RIGHT,100);

	m_imageList.Create(16,16,ILC_COLOR32|ILC_MASK,0,10);
	m_imageList.SetBkColor(CLR_NONE);
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_NORMAL),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_COMPROT),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_MLDONKEY),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_EDONKEYHYBRID),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_CREDIT_DOWNESTIMATED),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_FRIEND_ONLY),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_BANNED_ONLY),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_DCS1),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_DCS2),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_DCS3),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_DCS4),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_DCS5),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LISTMINUS),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LISTNONE),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LISTPLUS),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_RATING_NO),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_RATING_EXCELLENT),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_RATING_GOOD),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_RATING_FAIR),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_RATING_POOR),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_RATING_FAKE),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_UNKNOWN),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_CDONKEY),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LMULE),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SHAREAZA),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SECUREHASH),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_A4AFAUTO),16,16));

    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_COMPLETE),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_COMPLETING),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_DOWNLOADING),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_ERRONEOUS),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_HASHING),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_PAUSED),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_STALLED),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_STOPPED),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_WAITING),16,16));
    m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_STATUS_WAITINGHASH),16,16));
	LoadImgLstIcon(NULL,0,0); //Destroy last icon

	LoadSettings(CPreferences::TABLE_DOWNLOAD);
//
//	Sort dialog
	if (g_eMuleApp.m_pGlobPrefs->DoUseSort())
	{	
		SortInit(DL_OVERRIDESORT);
	}
	else 
	{
	//	Barry - Use preferred sort order from preferences
		m_iCurrentSortItem = g_eMuleApp.m_pGlobPrefs->GetColumnSortItem(CPreferences::TABLE_DOWNLOAD);
		m_bSortAscending = g_eMuleApp.m_pGlobPrefs->GetColumnSortAscending(CPreferences::TABLE_DOWNLOAD);
		m_iSourceSortItem = g_eMuleApp.m_pGlobPrefs->GetColumnSortItem(CPreferences::TABLE_DOWNLOAD2);
		m_bSortSourcesAscending = g_eMuleApp.m_pGlobPrefs->GetColumnSortAscending(CPreferences::TABLE_DOWNLOAD2);

		SetSortArrow(m_iCurrentSortItem, m_bSortAscending);
		m_dwLastSortCode = m_iCurrentSortItem + (m_bSortAscending ? MLC_SORTASC : MLC_SORTDESC)
						+ ((m_iSourceSortItem + (m_bSortSourcesAscending ? MLC_SORTASC : MLC_SORTDESC)) << 16);
		SortItems(SortProc, m_dwLastSortCode);
	}

	m_iCurTabIndex = 0; // All tab
	m_eCurTabCat = CAT_ALL;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::Localize() 
{
	EMULE_TRY

	if (GetSafeHwnd())
	{
		CHeaderCtrl	   *pHeaderCtrl = GetHeaderCtrl();
		HDITEM			hdi;

		hdi.mask = HDI_TEXT;

		CString			strRes;

		strRes = GetResString(IDS_DL_FILENAME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(0, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SIZE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(1, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_TRANSF);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(2, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SF_COMPLETED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(3, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SPEED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(4, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_PROGRESS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(5, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SOURCES);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(6, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PRIORITY);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(7, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_STATUS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(8, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_REMAINS);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(9, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_TIME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(10, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_ULDL);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(11, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_QL_RATING);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(12, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_LASTSEENCOMPL);
		strRes.Remove(':');
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(13, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_FD_LASTCHANGE);
		strRes.Remove(':');
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(14, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_CAT);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(15, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_WAITED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(16, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DLCOL_AVGSPEED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(17, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DLCOL_AVGREMTIME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(18, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DLCOL_ETA);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(19, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DLCOL_AVGETA);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(20, &hdi);
		strRes.ReleaseBuffer();

		ShowFilesCount();
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	AddFileItem() adds part file item 'pFileItem' to the display it if it should be visible.
void CDownloadListCtrl::AddFileItem(CPartFileDLItem *pFileItem)
{
	EMULE_TRY

//	TODO: Make this asynchronous

//	If the file belongs to the currently displayed category, add it to the end of the list control (emule .30a)
	if (CCat::FileBelongsToGivenCat(pFileItem->GetFile(),m_eCurTabCat))
	{
		ListInsertFileItem(pFileItem,GetItemCount());
	}

	if (m_bSmartFilter)
	{
		AutoSetSourceFilters(pFileItem);
	}

	ShowFilesCount();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	AddSourceItem() adds source item 'pSourceItem' to the display it if it should be visible.
void CDownloadListCtrl::AddSourceItem(CSourceDLItem *pSourceItem)
{
	EMULE_TRY

	CPartFileDLItem	   *pParentFileItem = pSourceItem->GetParentFileItem();
	
	if (pParentFileItem == NULL || !pParentFileItem->m_bSrcsAreVisible)
		return;

//
//	Find the position of the next file item displayed or the end of the list
//
	int		iItem = ListGetFileItemIndex(pParentFileItem);
	int		iNumListItems = GetItemCount();

	if (iItem < 0)
		iItem = 0;
	while (iItem+1 < iNumListItems)
	{
		CPartFileDLItem	   *pFileItem = dynamic_cast<CPartFileDLItem*>(ListGetItemAt(iItem+1));

		if (pFileItem != NULL)
			break;
		iItem++;
	}

	if (!IsSourceFiltered(pSourceItem))
		ListInsertSourceItem(pSourceItem,iItem+1);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	RemoveSourceItem() removes the source item 'pSourceItem' from the list. If an error occurs,
//		the method does nothing.
void CDownloadListCtrl::RemoveSourceItem(CSourceDLItem *pSourceItem)
{
	EMULE_TRY

	if (pSourceItem != NULL && ::IsWindow(GetSafeHwnd()) && g_eMuleApp.m_pdlgEmule->IsRunning()) 
	{
		int		iItem = ListGetSourceItemIndex(pSourceItem);

		if (iItem != -1)
		{
			pSourceItem->SetVisibility(false);
			DeleteItem(iItem);
		}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	IsSourceFiltered() returns true if the spec'd source should be removed
//		from the DownloadList window according to the current source filter.
bool CDownloadListCtrl::IsSourceFiltered(CSourceDLItem *pSourceItem)
{
#ifdef OLD_SOCKETS_ENABLED
	bool				bShowNewSource = true;
	CPartFileDLItem	   *pFileItem = pSourceItem->GetParentFileItem();

//	If the source item's parent part file isn't expanded, don't show it.
	if (!pFileItem->m_bSrcsAreVisible)
	{
		bShowNewSource = false;
	}
	else
	{
		CUpDownClient	*pSource = pSourceItem->GetSource();

		EnumDLQState	ds = pSource->GetDownloadState();

	//	If we're filtering out uploading sources and the source is uploading...
		if ( !(pFileItem->m_bShowUploadingSources && m_bShowUploadingSources)
		  && ds == DS_DOWNLOADING )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources which have us on their upload queues
	//		and the source has issued us an upload queue rank...
		if ( !(pFileItem->m_bShowOnQueueSources && m_bShowOnQueueSources)
		  && ds == DS_ONQUEUE && pSource->GetRemoteQueueRank() > 0 )
		{
			bShowNewSource = false;
		}
	//	If we're NOT filtering out sources which has us on their upload queues
	//		but we're smart filtering and the source has issued us an upload
	//		rank above 25 (TODO: Make this a pref)...
		if ( m_bSmartFilter
		  && (pFileItem->m_bShowOnQueueSources && m_bShowOnQueueSources)
		  && ds == DS_ONQUEUE && pSource->GetRemoteQueueRank() > 25 )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources which report a full upload queue
	//		and the source returned 0 for our upload queue rank...
		if ( !(pFileItem->m_bShowFullQueueSources && m_bShowFullQueueSources)
		  && ds == DS_ONQUEUE && pSource->GetRemoteQueueRank() == 0 )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources that are connected and this source is connected...
		if ( !(pFileItem->m_bShowConnectedSources && m_bShowConnectedSources)
		  && ds == DS_CONNECTED) 
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources that are connecting and this source is connecting or connecting via server...
		if ( !(pFileItem->m_bShowConnectingSources && m_bShowConnectingSources)
		  && (ds == DS_CONNECTING || ds == DS_WAITCALLBACK) )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources with no needed parts and this source has
	//		no needed parts...
		if ( !(pFileItem->m_bShowNNPSources && m_bShowNNPSources)
		  && ds == DS_NONEEDEDPARTS )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources we couldn't connect to because we didn't
	//		have a free connection and that's the case for this source...
		if ( !(pFileItem->m_bShowTooManyConnSources && m_bShowTooManyConnSources)
		  && ds == DS_TOOMANYCONNS )
		{
			bShowNewSource = false;
		}
	//	If we have a Low ID and we're filtering out sources with a Low ID and
	//		this source does...
		if ( !(pFileItem->m_bShowLowToLowIDSources && m_bShowLowToLowIDSources)
		  && ds == DS_LOWTOLOWIP )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out banned clients and this source has been banned...
		if ( !(pFileItem->m_bShowBannedSources && m_bShowBannedSources)
		  && ds == DS_BANNED )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources with an error condition (?) and this
	//		source has one...
		if ( !(pFileItem->m_bShowErrorSources && m_bShowErrorSources)
		  && ds == DS_ERROR )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out sources for which we have an active request for
	//		a file other than the source item's parent...
		if ( !(pFileItem->m_bShowA4AFSources && m_bShowA4AFSources)
		  && pSourceItem->IsAskedForAnotherFile() )
		{
			bShowNewSource = false;
		}
	//	If we're filtering out unknown (?) sources and this source is unknown...
		if ( !(pFileItem->m_bShowUnknownSources && m_bShowUnknownSources)
		  && ds == DS_NONE )
		{
			bShowNewSource = false;
		}
	}

	return !bShowNewSource;
#else
	return false;
#endif //OLD_SOCKETS_ENABLED
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::RemoveFileItem(CPartFileDLItem *pFileItem)
{
	EMULE_TRY

	if (!g_eMuleApp.m_pdlgEmule->IsRunning() || pFileItem == NULL) 
	{
		return;
	}

//	If the InfoList is displaying this file...
	if ( g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.GetType() == INFOLISTTYPE_FILE
	  && g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.GetFile() == pFileItem->GetFile() )
	{
	//	...Set it to display nothing
		g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.SetList(INFOLISTTYPE_NONE);
	}

	int			iFilePos = ListGetFileItemIndex(pFileItem);

//
//	Remove the file item from the list
	if (iFilePos != -1)
	{
		pFileItem->SetVisibility(false);
		DeleteItem(iFilePos);
	}

	ShowFilesCount();
	
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::UpdateSourceItem(CSourceDLItem *pSourceItem)
{
	EMULE_TRY

	if (pSourceItem != NULL && ::IsWindow(GetSafeHwnd()) && g_eMuleApp.m_pdlgEmule->IsRunning())
	{
		int		iSourcePos = ListGetSourceItemIndex(pSourceItem);

		if (iSourcePos != -1)
		{
			bool	bDontUpdate = false;

			if (pSourceItem != NULL && IsSourceFiltered(pSourceItem))
			{
				HideSourceItem(pSourceItem);
				bDontUpdate = true;
			}
			if (!bDontUpdate)
			{
				if (pSourceItem != NULL)
					pSourceItem->ResetUpdateTimer();
				Update(iSourcePos);
			}
		}
	//	If we didn't find the source item in the list...
		else
		{
		//	If it's a source, check to see if it should be shown now
			if (pSourceItem != NULL)
			{
				if (!IsSourceFiltered(pSourceItem))
				{
					ShowSourceItem(pSourceItem);
				}
			}
		}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::UpdateFileItems()
{
	CDownloadList::PartFileItemVector	*pvecFileItems = g_eMuleApp.m_pDownloadList->GetFileItems();

	for (uint32 i = 0; i < pvecFileItems->size(); i++)
	{
		UpdateFileItem((*pvecFileItems)[i]);
	}

	delete pvecFileItems;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::UpdateSourceItems(CPartFileDLItem *pFileItem/*=NULL*/)
{
	CDownloadList::SourceItemVector	   *pvecSourceItems = NULL;

//	If no part file item was specified, update all source items
	if (pFileItem == NULL)
	{
		pvecSourceItems = g_eMuleApp.m_pDownloadList->GetSourceItems();
	}
	else
	{
		pvecSourceItems = pFileItem->GetSources();
	}

	for (uint32 i = 0; i < pvecSourceItems->size(); i++)
		UpdateSourceItem((*pvecSourceItems)[i]);

	delete pvecSourceItems;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::UpdateFileItem(CPartFileDLItem *pFileItem)
{
	EMULE_TRY

//	MOREVIT - The "running" check is probably superfluous here now that we're checking the window
//	If the file item isn't null and the window hasn't been destroyed (e.g. during shutdown)...
	if (pFileItem != NULL && ::IsWindow(GetSafeHwnd()) && g_eMuleApp.m_pdlgEmule->IsRunning())
	{
		int		iFilePos = ListGetFileItemIndex(pFileItem);

	//	If we found the file item in the list...
		if (iFilePos != -1)
		{
			if (pFileItem != NULL)
				pFileItem->ResetUpdateTimer();
			Update(iFilePos);
			if (m_bSmartFilter)
			{
				AutoSetSourceFilters(pFileItem);
			}
		}
	}
	
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	DrawFileItem() draws column 'nColumn' of the list row for part file 'pFileItem' in the
//		rectangle 'lpRect' in device context 'dc'. If 'm_iMeasuringColumn' is nonzero then
//		the width of drawing is measured and 'm_iColumnMaxWidths' is updated for that column
//		but nothing is drawn.
void CDownloadListCtrl::DrawFileItem(CDC *dc, int nColumn, LPRECT lpRect, CPartFileDLItem *pFileItem) 
{
//	TODO: Put these constants somewhere sensible!
#define OFFSET_PLUSMINUS	18
#define OFFSET_STATUSICON	18
#define OFFSET_FILETYPEICON	19
#define OFFSET_RATINGICON	10
	EMULE_TRY

	RECT	r = *lpRect;
	int		iPadding = dc->GetTextExtent(_T(" "), 1 ).cx * 2;
	int		iWidth = (3 * iPadding)/2;
	bool	bMeasuring = (m_iMeasuringColumn >= 0);
	UINT	iCalcFlag = 0;

	if (bMeasuring)
	{
		iCalcFlag = (DLC_DT_TEXT | DT_CALCRECT) & ~DT_END_ELLIPSIS;
	}
	else
	{
		iCalcFlag = DLC_DT_TEXT;
	}

	if (IsRightToLeftLanguage())
		iCalcFlag |= DT_RTLREADING;

	if (IsColumnHidden(nColumn))
		return;

	if (lpRect->left < lpRect->right) 
	{
		CString			buffer;
		CPartFile		*pPartFile = pFileItem->GetFile();

		switch (nColumn)
		{
			case DLCOL_FILENAME:		// file name
			{
				POINT	ipoint = { r.left, r.top + 1 };
				int		iIcon = 0;

			//	Draw the old-style +/- box
				iIcon = ( pPartFile->GetSourceCount() > 0 || pPartFile->GetSrcA4AFCount() > 0
						  &&  !(pPartFile->GetStatus() == PS_COMPLETING || pPartFile->GetStatus() == PS_COMPLETE || pPartFile->GetStatus() == PS_STOPPED) )
					  ? (pFileItem->m_bSrcsAreVisible ? DL_ICON_LISTMINUS : DL_ICON_LISTPLUS)
					  : DL_ICON_LISTNONE;
				if (!bMeasuring)
					m_imageList.Draw(dc, iIcon, ipoint, ILD_NORMAL);
				else
					iWidth += OFFSET_PLUSMINUS;
				r.left += OFFSET_PLUSMINUS;
				ipoint.x += OFFSET_PLUSMINUS;

				if (g_eMuleApp.m_pGlobPrefs->ShowFullFileStatusIcons())
				{
				//	Draw the status icon
					switch (pPartFile->GetPartfileStatusID())
					{
						case PS_COMPLETING:
							iIcon = DL_ICON_STATUS_COMPLETING;
							break;
						case PS_COMPLETE:
							iIcon = DL_ICON_STATUS_COMPLETE;
							break;
						case PS_DOWNLOADING:
							iIcon = DL_ICON_STATUS_DOWNLOADING;
							break;
						case PS_WAITINGFORSOURCE:
							iIcon = DL_ICON_STATUS_WAITING;
							break;
						case PS_WAITINGFORHASH:
							iIcon = DL_ICON_STATUS_WAITINGHASH;
							break;
						case PS_HASHING:
							iIcon = DL_ICON_STATUS_HASHING;
							break;
						case PS_PAUSED:
							iIcon = DL_ICON_STATUS_PAUSED;
							break;
						case PS_STALLED:
							iIcon = DL_ICON_STATUS_STALLED;
							break;
						case PS_STOPPED:
							iIcon = DL_ICON_STATUS_STOPPED;
							break;
						case PS_ERROR:
							iIcon = DL_ICON_STATUS_ERRONEOUS;
							break;
						default:
							iIcon = DL_ICON_STATUS_ERRONEOUS;
					}
					if (!bMeasuring)
						m_imageList.Draw(dc, iIcon, ipoint, ILD_NORMAL);
					else
						iWidth += OFFSET_STATUSICON;
					r.left += OFFSET_STATUSICON;
				}

			//	DropF START - Show that a file is A4AF auto
				if (pPartFile == g_eMuleApp.m_pDownloadQueue->GetA4AFAutoFile() && !bMeasuring)
					m_imageList.Draw(dc, DL_ICON_A4AFAUTO, ipoint, ILD_TRANSPARENT);
			//	DropF END

			//	File Type
				if (g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
				{
					if (!bMeasuring)
					{
						int		iImage = g_eMuleApp.GetFileTypeSystemImageIdx(pPartFile->GetFileName());

						if (g_eMuleApp.GetSystemImageList() != NULL)
							::ImageList_Draw(g_eMuleApp.GetSystemImageList(), iImage, dc->GetSafeHdc(), r.left, r.top+1, ILD_TRANSPARENT);
						r.left += OFFSET_FILETYPEICON;
					}
					else
						iWidth += OFFSET_FILETYPEICON;
				}

			//	Comments/ratings
			    if (!g_eMuleApp.m_pGlobPrefs->GetDisableRatingIcons())
				{
					if ((pPartFile->HasComment() || pPartFile->HasRating()) && !bMeasuring)
					{
						iIcon = DL_ICON_RATING_NO;

						if (pPartFile->HasRating())
						{
				        	switch (pPartFile->GetRating())
				        	{
									case PF_RATING_NONE:
										iIcon = DL_ICON_RATING_NO;
										break;
									case PF_RATING_FAKE:
										iIcon = DL_ICON_RATING_FAKE;
										break;
									case PF_RATING_POOR:
										iIcon = DL_ICON_RATING_POOR;
										break;
									case PF_RATING_GOOD:
										iIcon = DL_ICON_RATING_GOOD;
										break;
									case PF_RATING_FAIR:
										iIcon = DL_ICON_RATING_FAIR;
										break;
									case PF_RATING_EXCELLENT:
										iIcon = DL_ICON_RATING_EXCELLENT;
										break;
								default:
								iIcon=DL_ICON_RATING_NO;
							}
						}
						POINT	point= {r.left-4,r.top+3};
						
						m_imageList.Draw(dc, iIcon, point, ILD_NORMAL);
					}
					r.left += OFFSET_RATINGICON;
					iWidth += OFFSET_RATINGICON;
				}

			//
			//	Finally, the file title. First set the color
                COLORREF	crOldTxtColor;
				COLORREF	cr = CCat::GetCatColorByID(pPartFile->GetCatID());
				bool		bRestoreColor = true;	// Not restoring the color _may_ make the rest of the
													//	row the same color. Don't count on it.
				cr = (cr > 0) ? cr : (::GetSysColor(COLOR_WINDOWTEXT));

				if (pPartFile->GetStatus()==PS_PAUSED || pPartFile->GetStatus()==PS_STOPPED)
				{
					if (g_eMuleApp.m_pGlobPrefs->ShowPausedGray())
					{
						cr = ::GetSysColor(COLOR_GRAYTEXT);
						bRestoreColor = false;
					}
					else
					{
					//	TODO: This might be worth pulling out into its own function (as I see others have already done)
						uint8		r,g,b;
						const uint8	grayAmount = 0x60;
						const uint8 grayBuffer = 0x40;
						const uint8	grayLimit = 0xFF - grayBuffer;
						uint8		gray = grayAmount;

					//	"gray" the color
						r = GetRValue(cr);
						b = GetBValue(cr);
						g = GetGValue(cr);

					//	Make sure we don't wash the color out TOO much
						if (r + gray >= grayLimit && b + gray >= grayLimit && g + gray >= grayLimit)
						{
							gray -= grayBuffer;
						}
						if (r + gray <= 0xFF)
							r += gray;
						else
							r = 0xFF;
						if (b + gray <= 0xFF)
							b += gray;
						else
							b = 0xFF;
						if (g + gray <= 0xFF)
							g += gray;
						else
							g = 0xFF;

						cr = RGB(r,g,b);
					}
				}

				crOldTxtColor = dc->SetTextColor(cr);
				
			//	Draw the file name
				dc->DrawText(pPartFile->GetFileName(), (int)_tcslen(pPartFile->GetFileName()),&r, iCalcFlag);
				if (bMeasuring)
				{
					iWidth += r.right-r.left+1;
				}
			//	Restore the original color
				if (bRestoreColor)
					dc->SetTextColor(crOldTxtColor);
				break;
			}
			case DLCOL_SIZE:
			{
				buffer = CastItoXBytes(pPartFile->GetFileSize());
				dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_TRANSFERRED:
			{
				buffer = CastItoXBytes(pPartFile->GetTransferred());
				dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
		    case DLCOL_COMPLETED:
			{
			    buffer = CastItoXBytes(pPartFile->GetCompletedSize());
			    dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
			    break;
			}
			case DLCOL_SPEED:
		    {
				buffer.Empty();
				if (pPartFile->GetStatus() != PS_COMPLETING && pPartFile->GetStatus() != PS_COMPLETE)
				{
					uint32		iDataRate = pPartFile->GetDataRate();

			       	if (iDataRate > 10)
						buffer.AppendFormat(_T("%.1f "), iDataRate/1024.0f);
			       	if (g_eMuleApp.m_pGlobPrefs->GetShowAverageDataRate())
			       	{
						iDataRate = pPartFile->GetAvgDataRate(true);
						if (iDataRate > 10)
							buffer.AppendFormat(_T("(%.2f) "), iDataRate/1024.0f);
					}
				}
				else if (g_eMuleApp.m_pGlobPrefs->GetShowAverageDataRate())
					buffer.AppendFormat(_T("[%.2f]"), pPartFile->GetAvgDataRate(false)/1024.0f);
				dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring && buffer.GetLength() != 0)
					iWidth += r.right - r.left + 1;
				break;
			}
			//#region Progress Bar
			case DLCOL_PROGRESS:
			{
				if (!bMeasuring)
				{
					r.bottom--;
					r.top++;

					int		iBarWidth = r.right - r.left;
					int		iBarHeight = r.bottom - r.top;

					if (pFileItem->GetBitmap() == (HBITMAP)NULL)
						VERIFY(pFileItem->GetBitmap().CreateBitmap(1, 1, 1, 8, NULL));

					CDC			cdcStatus;
					HGDIOBJ		hOldBitmap;

					cdcStatus.CreateCompatibleDC(dc);

					int		cx = pFileItem->GetBitmap().GetBitmapDimension().cx;
					DWORD	dwTicks = GetTickCount();

					if (pFileItem->GetUpdateTimer() + DLC_BARUPDATE < dwTicks || cx !=  iBarWidth || pFileItem->GetUpdateTimer() != 0)
					{ 
						pFileItem->GetBitmap().DeleteObject();
						pFileItem->GetBitmap().CreateCompatibleBitmap(dc,  iBarWidth, iBarHeight);
						pFileItem->GetBitmap().SetBitmapDimension(iBarWidth,  iBarHeight);
						hOldBitmap = cdcStatus.SelectObject(pFileItem->GetBitmap());

						RECT rec_status;
						rec_status.left = 0;
						rec_status.top = 0;
						rec_status.bottom = iBarHeight;
						rec_status.right = iBarWidth;
						pPartFile->DrawStatusBar(&cdcStatus,  &rec_status, g_eMuleApp.m_pGlobPrefs->UseFlatBar());

						pFileItem->SetUpdateTimer(dwTicks + (rand() % 128));
					}
					else 
						hOldBitmap = cdcStatus.SelectObject(pFileItem->GetBitmap());

					dc->BitBlt(r.left, r.top, iBarWidth, iBarHeight,  &cdcStatus, 0, 0, SRCCOPY);
					cdcStatus.SelectObject(hOldBitmap);

					if (g_eMuleApp.m_pGlobPrefs->GetUseDwlPercentage())
					{
					//	BEGIN Display percent in progress bar
						COLORREF	crOld = dc->SetTextColor(RGB(255,255,255));
						int			iOldBkMode = dc->SetBkMode(TRANSPARENT);

						buffer.Format(_T("%.4f%%"), pPartFile->GetPercentCompleted());
						int pos1 = buffer.Find(_T(GetLocalDecimalPoint()));
						int pos2 = buffer.Find(_T("%"));
						if ( ( pos1 != -1 ) && ( pos2 != -1 ) && ( pos2 > pos1 ) && ( (pos2 - pos1) > 2) )
						{
							if (buffer.GetAt((pos1 + 1)) == '0')
								buffer.Delete(pos1, (pos2 - pos1));
							else
								buffer.Delete(pos1 + 2,(pos2 - pos1) - 2);
						}

						SIZE TextSize;
						GetTextExtentPoint32(*dc, buffer, buffer.GetLength(), &TextSize);
						
						int			iOldLeft = r.left;

						r.left += ((iBarWidth - TextSize.cx) / 2);

						if (pPartFile->GetStatus() != PS_COMPLETE && pPartFile->GetStatus() != PS_COMPLETING)
						{
							r.top += 3; // Just a little down
						}
						dc->DrawText(buffer, buffer.GetLength(), &r, DLC_DT_TEXT);

						r.left = iOldLeft;
						dc->SetBkMode(iOldBkMode);
						dc->SetTextColor(crOld);
					}
				}
			//	Since the progress bar drawing is conformant, we'll just hardcode a reasonable width
				else
					iWidth += 300;
				break;
			}
			//#endregion
			case DLCOL_NUMSOURCES:
			{
				CString		buffer2;
				uint16		ncsc = pPartFile->GetNotCurrentSourcesCount();

				if (ncsc > 0)
					buffer2.Format(_T("%i/"),pPartFile->GetSourceCount() -ncsc);
				else
					buffer2 = "";
				buffer.Format(_T("%s%i (%i)"),buffer2, pPartFile->GetSourceCount(), pPartFile->GetTransferringSrcCount());
				if (((CKnownFile*)pPartFile)->IsAutoPrioritized())
					((CKnownFile*)pPartFile)->UpdateUploadAutoPriority();
				dc->DrawText(buffer,(int)_tcslen(buffer),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_PRIORITY:
			{
				if (pPartFile->IsAutoPrioritized())
				{
					pPartFile->UpdateDownloadAutoPriority();
	
					switch (pPartFile->GetPriority())
					{
						case PR_LOW:
							dc->DrawText(GetResString(IDS_PRIOAUTOLOW),GetResString(IDS_PRIOAUTOLOW).GetLength(),&r, iCalcFlag);
							break;
						case PR_NORMAL:
							dc->DrawText(GetResString(IDS_PRIOAUTONORMAL),GetResString(IDS_PRIOAUTONORMAL).GetLength(),&r, iCalcFlag);
							break;
						case PR_HIGH:
							dc->DrawText(GetResString(IDS_PRIOAUTOHIGH),GetResString(IDS_PRIOAUTOHIGH).GetLength(),&r, iCalcFlag);
							break;
					}
				}
				else
				{
					switch (pPartFile->GetPriority())
					{
						case PR_LOW:
							dc->DrawText(GetResString(IDS_PRIOLOW),GetResString(IDS_PRIOLOW).GetLength(),&r, iCalcFlag);
							break;
						case PR_NORMAL:
							dc->DrawText(GetResString(IDS_PRIONORMAL),GetResString(IDS_PRIONORMAL).GetLength(),&r, iCalcFlag);
							break;
						case PR_HIGH:
							dc->DrawText(GetResString(IDS_PRIOHIGH),GetResString(IDS_PRIOHIGH).GetLength(),&r, iCalcFlag);
							break;
					}
				}
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_STATUS:
			{
				buffer = pPartFile->GetPartfileStatus();
				dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_REMAINING:
			{
#ifdef TEST
				uint32		remains;

				remains = pPartFile->GetFileSize() - pPartFile->GetCompletedSize();

				if (remains < 0)
					remains = 0;
				buffer = CastItoXBytes(remains);

				if (pPartFile->GetStatus()==PS_COMPLETING || pPartFile->GetStatus()==PS_COMPLETE)
				{
					buffer="";
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				}
				else
				{
					double	saved = 100.0 - pPartFile->GetPercentCompleted();

				//	TODO: This might be faster using tabstops.
					r.right -= (57 + 5);
					dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);

					buffer.Format( _T("[%3.1f%%]"),saved);
					r = *lpRect;
					r.right -= 5;
					r.left = r.right - 57 /*measured*/;
					dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				}
#else
				uint32		iRemaining;

				iRemaining = pPartFile->GetFileSize() - pPartFile->GetCompletedSize();

				if (iRemaining < 0) 
					iRemaining = 0;
				buffer = CastItoXBytes(iRemaining);

				if (pPartFile->GetStatus() == PS_COMPLETING || pPartFile->GetStatus() == PS_COMPLETE)
				{
					buffer="";
				}
				else
				{
					double		dblRemainingPercent = 100.1 - pPartFile->GetPercentCompleted();
					if ( dblRemainingPercent > 100.0 )
						dblRemainingPercent = 100.0;
					else if ( iRemaining == 0 )
						dblRemainingPercent = 0.0;					
					CString		str1 = buffer;
					buffer.Format( _T("%s [%.4f%%]"), str1, dblRemainingPercent);
					int pos1 = buffer.ReverseFind(_T(GetLocalDecimalPoint()));
					int pos2 = buffer.Find(_T("%"));
					if ( ( pos1 != -1 ) && ( pos2 != -1 ) && ( pos2 > pos1 ) && ( (pos2 - pos1) > 2) )
					{
						if (buffer.GetAt((pos1 + 1)) == '0')
							buffer.Delete(pos1, (pos2 - pos1));
						else
							buffer.Delete(pos1 + 2,(pos2 - pos1) - 2);
					}
				}
				dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
#endif TEST
				break;
			}
			case DLCOL_REMAININGTIME:
			{
				sint32		restTime;

				buffer.Empty();
				if (pPartFile->GetStatus() != PS_COMPLETING && pPartFile->GetStatus() != PS_COMPLETE)
				{
					restTime = pPartFile->GetTimeRemaining();
					buffer.AppendFormat(_T("%s"), CastSecondsToHM(restTime));

					if (g_eMuleApp.m_pGlobPrefs->GetShowAverageDataRate())
					{
						restTime = pPartFile->GetTimeRemaining(true);
						buffer.AppendFormat(_T(" (%s)"), CastSecondsToHM(restTime));
					}
				}
				else
				{
					restTime = pPartFile->GetFlushTimeSpan().GetTotalSeconds();
					buffer.AppendFormat(_T("[%s / %s]"), CastItoXBytes(pPartFile->GetSessionTransferred()), CastSecondsToHM(restTime));
				}
				dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_LASTSEENCOMPLETE:
			{
				if (pPartFile->lastseencomplete == NULL)
				{
					buffer = GetResString(IDS_NEVER);
					dc->DrawText(buffer,(int)_tcslen(buffer),&r, iCalcFlag);
				}
				else
				{
					CTime			ctTime(pPartFile->lastseencomplete);
					SYSTEMTIME		st;
					ctTime.GetAsSystemTime(st);
					COleDateTime    odtTime(st);
					dc->DrawText(odtTime.Format(), &r, iCalcFlag);
				}
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_LASTRECEIVED:
			{
				if (pPartFile->GetTransferred() == 0)
				{
					buffer = GetResString(IDS_NEVER);
					dc->DrawText(buffer,(int)_tcslen(buffer),&r, iCalcFlag);
				}
				else
				{
					CTime			ctTime(pPartFile->GetLastDownTransfer());
					SYSTEMTIME		st;
					ctTime.GetAsSystemTime(st);
					COleDateTime    odtTime(st);
					dc->DrawText(odtTime.Format(), &r, iCalcFlag);
				}
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_CATEGORY:
			{
				if (pPartFile->GetCatID() == 0)
				{
					buffer = GetResString(IDS_CAT_UNCATEGORIZED);
				}
				else
				{
					CCat	*pCat = CCat::GetCatByID(pPartFile->GetCatID());

					if (pCat != NULL)
					{
						buffer = pCat->GetTitle();
					}
					else
					{
						pPartFile->SetCatID(CAT_NONE);
						buffer = GetResString(IDS_CAT_UNCATEGORIZED);
					}
				}
				dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_WAITED:
			{
				CTimeSpan	ts = CTime::GetCurrentTime() - pPartFile->GetLastDownTransfer();
				long		lWaitedSeconds = ts.GetTotalSeconds();

				if (lWaitedSeconds < 15)
					buffer = "";
				else
					buffer = ::CastSecondsToHM(lWaitedSeconds);
				dc->DrawText(buffer,(int)_tcslen(buffer),&r, iCalcFlag);
				if (bMeasuring && buffer.GetLength() != 0)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_AVGSPEED:
		    {
				buffer.Empty();
				if (pPartFile->GetStatus() != PS_COMPLETING && pPartFile->GetStatus() != PS_COMPLETE)
				{
					uint32		iDataRate = pPartFile->GetAvgDataRate(true);

					if (iDataRate > 10)
						buffer.Format(_T("%.2f"), iDataRate/1024.0f);
				}
				else
					buffer.Format(_T("%.2f"), pPartFile->GetAvgDataRate(false)/1024.0f);
				dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring && buffer.GetLength() != 0)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_AVGREMTIME:
			{
				sint32		iRemainingTime;

				buffer.Empty();
				if (pPartFile->GetStatus() != PS_COMPLETING && pPartFile->GetStatus() != PS_COMPLETE)
				{
					iRemainingTime = pPartFile->GetTimeRemaining(true);
					buffer.AppendFormat(_T("%s"), CastSecondsToHM(iRemainingTime));
				}
				dc->DrawText(buffer,buffer.GetLength(),&r, DT_RIGHT | iCalcFlag);
				if (bMeasuring)
					iWidth += r.right - r.left + 1;
				break;
			}
			case DLCOL_ETA:
			{
				sint32		iRemainingTime;

				buffer.Empty();
				if (pPartFile->GetStatus() != PS_COMPLETING && pPartFile->GetStatus() != PS_COMPLETE)
				{
					iRemainingTime = pPartFile->GetTimeRemaining();

					if (iRemainingTime != -1)
					{
						CTime			ctTime;
						SYSTEMTIME		st;

						ctTime = CTime::GetCurrentTime();
						ctTime += CTimeSpan(iRemainingTime);
						ctTime.GetAsSystemTime(st);

						COleDateTime	odtTime(st);

						dc->DrawText(odtTime.Format(), &r, DT_RIGHT | iCalcFlag);
						if (bMeasuring)
							iWidth += r.right - r.left + 1;
					}
				}
				else
				{
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				}
				break;
			}
			case DLCOL_AVGETA:
			{
				sint32		iRemainingTime;

				buffer.Empty();
				if (pPartFile->GetStatus() != PS_COMPLETING && pPartFile->GetStatus() != PS_COMPLETE)
				{
					iRemainingTime = pPartFile->GetTimeRemaining(true);

					if (iRemainingTime != -1)
					{
						CTime			ctTime;
						SYSTEMTIME		st;

						ctTime = CTime::GetCurrentTime();
						ctTime += CTimeSpan(iRemainingTime);
						ctTime.GetAsSystemTime(st);

						COleDateTime	odtTime(st);

						dc->DrawText(odtTime.Format(), &r, DT_RIGHT | iCalcFlag);
						if (bMeasuring)
							iWidth += r.right - r.left + 1;
					}
				}
				else
				{
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				}
				break;
			}
			default:
				break;
		}
		if (bMeasuring)
		{
		//	Pin the column widths at some reasonable value
			if (iWidth < 40 && iWidth != 0)
				iWidth = 40;
			if (iWidth > m_iColumnMaxWidths[m_iMeasuringColumn])
				m_iColumnMaxWidths[m_iMeasuringColumn] = iWidth;
		}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	DrawSourceItem() draws column 'nColumn' of the list row for source 'pSourceItem' in the
//		rectangle 'lpRect' in device context 'dc'. If 'm_iMeasuringColumn' is nonzero then
//		the width of drawing is measured and 'm_iColumnMaxWidths' is updated for that column
//		but nothing is drawn.
void CDownloadListCtrl::DrawSourceItem(CDC *dc, int nColumn, LPRECT lpRect, CSourceDLItem *pSourceItem)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	int		iPadding = dc->GetTextExtent(_T(" "), 1 ).cx * 2;
	int		iWidth = (3 * iPadding)/2;
	bool	bMeasuring = (m_iMeasuringColumn >= 0);
	UINT	iCalcFlag = 0;

	if (bMeasuring)
	{
		iCalcFlag = (DLC_DT_TEXT | DT_CALCRECT) & ~DT_END_ELLIPSIS;
	}
	else
	{
		iCalcFlag = DLC_DT_TEXT;
	}

	if (IsColumnHidden(nColumn))
		return;

	if (pSourceItem == NULL)
		return;

	if (lpRect->left < lpRect->right) 
	{
		CString				buffer;
		CUpDownClient	   *pSource = pSourceItem->GetSource();
		CString				sDownloadState = _T("");
		try
		{
			sDownloadState = pSource->GetDownloadStateAsString();
		}
		catch(...)
		{
		}
		uint8				nDownloadState = pSource->GetDownloadState();
		EnumClientTypes		nClientSoft = pSource->GetClientSoft();
		uint32				nVersion;	//Cax2 - version nr bugfix

		switch (nClientSoft)
		{
			case SO_EMULE:
			case SO_LMULE:
			case SO_OLDEMULE:
			case SO_CDONKEY:
			case SO_SHAREAZA:
				nVersion= pSource->GetMuleVersion();
				break;
			default:
				nVersion= pSource->GetVersion();
		}

		bool				bIsBanned = pSource->IsBanned(); //katsyonak 07/07/03
		bool				bIsFriend = pSource->IsFriend();
		double				dblRemoteBaseModifier = pSource->GetRemoteBaseModifier();
		CString				sClientName = _T("");

		if (pSource->GetUserName())
		{
			try
			{
				sClientName = CString(pSource->GetUserName());
			}
			catch(...)
			{
			}
		}
		uint32				nTransferredDown = pSource->GetTransferredDown();
		uint32				nDownloadDataRate = pSource->GetDownloadDataRate();
		bool				bIsEmuleClient = pSource->IsEmuleClient();
		uint16				nRemoteQueueRank = pSource->GetRemoteQueueRank();
		uint16				nDifference = pSource->GetDifference(); //cendre-eau
		bool				bNeverAskedBefore = pSource->GetLastSrcReqTime() == 0;
		bool				bRemoteQueueFull = pSource->IsRemoteQueueFull();
		bool				bIsRemoteInfoAvail = pSource->IsRemoteInfoAvaiable();
		bool				bCredits = pSource->m_pCredits != (CClientCredits*)NULL && pSource->m_pCredits != (CClientCredits*)-1;
		uint16				nRemoteRatio = pSource->GetRemoteRatio();
		bool				bIsA4AF = pSourceItem->IsAskedForAnotherFile();
		RECT				r = *lpRect;

	//	Lord KiRon - just make compiler happy :)
 		POINT		point;
 		CString		status;
		
		switch (nColumn) 
		{
		    case DLCOL_FILENAME:
  			{
/*				if (g_eMuleApp.m_pGlobPrefs->ShowFullFileStatusIcons())
				{
					r.left += OFFSET_STATUSICON;
					iWidth += OFFSET_STATUSICON;
				}
				if (g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
				{
					r.left += OFFSET_FILETYPEICON;
					iWidth += OFFSET_FILETYPEICON;
				}
				if (!g_eMuleApp.m_pGlobPrefs->GetDisableRatingIcons())
				{
					r.left += OFFSET_RATINGICON;
					iWidth += OFFSET_RATINGICON;
				}
*/				r.left += OFFSET_PLUSMINUS;
				iWidth += OFFSET_PLUSMINUS;
				point.x = r.left;
				point.y = r.top+1;
   				status = _T("");
				if (!bMeasuring)
				{
					if (!bIsA4AF)
					{
						switch (nDownloadState)
						{
							case DS_CONNECTING:
							case DS_CONNECTED:
							case DS_WAITCALLBACK:
							case DS_TOOMANYCONNS:
									m_imageList.Draw(dc, DL_ICON_DCS3, point, ILD_NORMAL);
								break;
							case DS_ONQUEUE:
									m_imageList.Draw(dc, DL_ICON_DCS2, point, ILD_NORMAL);
								break;
							case DS_DOWNLOADING:
							case DS_REQHASHSET:
									m_imageList.Draw(dc, DL_ICON_DCS1, point, ILD_NORMAL);
								break;
							case DS_NONEEDEDPARTS:
							case DS_LOWTOLOWIP:
									m_imageList.Draw(dc, DL_ICON_DCS4, point, ILD_NORMAL);
								break;
							default:
									m_imageList.Draw(dc, DL_ICON_DCS5, point, ILD_NORMAL);
						}
					}
					else
					{
               			m_imageList.Draw(dc, DL_ICON_DCS4, point, ILD_NORMAL);
						if (g_eMuleApp.m_pGlobPrefs->IsA4AFStringEnabled())
						{
							//Cax2 - get local file name
							try{ status.Format(_T("(%s)"),pSource->m_pReqPartFile->GetFileName());}catch(...){}
						}
						else
							status = _T("(") + GetResString(IDS_ASKED4ANOTHERFILE) + _T(")");
  					}
				}
	
				r.left += 20;
				iWidth += 20;

                POINT point2= {r.left,r.top+1};

				if (!bMeasuring)
				{
					// Display client icon
					switch (nClientSoft)
					{
						case SO_CDONKEY:
								m_imageList.Draw(dc, DL_ICON_CDONKEY, point2, ILD_NORMAL);
							break;
						case SO_LMULE:
								m_imageList.Draw(dc, DL_ICON_LMULE, point2, ILD_NORMAL);
							break;
						case SO_SHAREAZA:
								m_imageList.Draw(dc, DL_ICON_SHAREAZA, point2, ILD_NORMAL);
							break;
						case SO_EDONKEYHYBRID:
								m_imageList.Draw(dc, DL_ICON_EDONKEYHYBRID, point2, ILD_NORMAL);
							break;
						case SO_MLDONKEY:
								m_imageList.Draw(dc, DL_ICON_MLDONKEY, point2, ILD_NORMAL);
							break;
						case SO_EMULE:
						case SO_OLDEMULE:
							if (pSource->m_pCredits->GetCurrentIdentState(pSource->GetIP()) != IS_IDENTIFIED)
									m_imageList.Draw(dc, DL_ICON_SECUREHASH, point2, ILD_NORMAL);
							else
									m_imageList.Draw(dc, DL_ICON_COMPROT, point2, ILD_NORMAL);
							break;
						case SO_EDONKEY:
								m_imageList.Draw(dc, DL_ICON_NORMAL, point2, ILD_NORMAL);
							break;
						default:
								m_imageList.Draw(dc, DL_ICON_UNKNOWN, point2, ILD_NORMAL);
							break;
					}

				if (!g_eMuleApp.m_pGlobPrefs->GetDisableRatingIcons())
				{
					r.left += OFFSET_RATINGICON;
					iWidth += OFFSET_RATINGICON;
				}

				// Display any Extra Overlay icons
					if (bIsBanned) //katsyonak 07/07/03
							m_imageList.Draw(dc, DL_ICON_BANNED_ONLY, point2, ILD_TRANSPARENT);
					else if (bIsFriend)
							m_imageList.Draw(dc, DL_ICON_FRIEND_ONLY, point2, ILD_TRANSPARENT);
					else if (dblRemoteBaseModifier >= 1.1)
							m_imageList.Draw(dc, DL_ICON_CREDIT_DOWNESTIMATED, point2, ILD_TRANSPARENT);
				}

				r.left += 20;
				iWidth += 20;
				
				//CString sName;
				CString buffer1;
				if (sClientName.IsEmpty())
				{
					buffer1.Format(_T("?  (%s)"),GetResString(IDS_UNKNOWN));
				} else {
					buffer1.Format(_T("%s %s"), sClientName, status);
				}

                // DonGato: different color for A4AF sources
				COLORREF crOldTxtColor;
    
				if(bIsA4AF)
					crOldTxtColor = dc->SetTextColor(GetSysColor(COLOR_GRAYTEXT));
				dc->DrawText(buffer1,buffer1.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
				{
					iWidth += r.right-r.left+1;
				}
                if(bIsA4AF)
                	dc->SetTextColor(crOldTxtColor);
				break;
			}
			case DLCOL_SIZE:
	#ifdef LATER
				{
				//	MOREVIT: - display last part size
				//	TODO: (bug - want the CURRENT part)
					uint16		iLastPart = pSource->GetLastDownPartAsked();
					uint8		ds = pSource->GetDownloadState();
					uint32		iPartSize = 0L;
	    
					if (iLastPart != 0xFFFF && ds==DS_DOWNLOADING)
					{
						iPartSize = pSourceItem->GetFile()->GetPartSize(iLastPart);
						buffer = CastItoXBytes(iPartSize);
					}
					else
					{
						buffer = "";
					}
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
					break;
				//	:MOREVIT
				}
	#endif LATER
			break;

			case DLCOL_TRANSFERRED:
				if (!pSourceItem->IsAskedForAnotherFile() && nTransferredDown && !g_eMuleApp.m_pGlobPrefs->IsTransferredOnCompleted()) {
					buffer = CastItoXBytes(nTransferredDown);
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
					if (bMeasuring)
					{
						iWidth += r.right-r.left+1;
					}
				}
				break;

			case DLCOL_COMPLETED:
				if (!bIsA4AF && nTransferredDown && g_eMuleApp.m_pGlobPrefs->IsTransferredOnCompleted()) {
					buffer = CastItoXBytes(nTransferredDown);
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
					if (bMeasuring)
					{
						iWidth += r.right-r.left+1;
					}
				}
				break;

			case DLCOL_SPEED:		// speed
				if (!pSourceItem->IsAskedForAnotherFile())
				{
					if (nDownloadDataRate==0)
						buffer="";
					else
						buffer.Format(_T("%.1f"), nDownloadDataRate/1024.0f);
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
					if (bMeasuring)
					{
						iWidth += r.right-r.left+1;
					}
				}
				break;

			case DLCOL_PROGRESS:		// file info
			{
				if (!bMeasuring)
				{
					lpRect->bottom--;
					lpRect->top++;

					int iWidth = lpRect->right - lpRect->left;
					int iHeight = lpRect->bottom - lpRect->top;
						if (pSourceItem->GetBitmap() == (HBITMAP)NULL)
							VERIFY(pSourceItem->GetBitmap().CreateBitmap(1, 1, 1, 8, NULL));
					CDC cdcStatus;
					HGDIOBJ hOldBitmap;
					cdcStatus.CreateCompatibleDC(dc);
						int cx = pSourceItem->GetBitmap().GetBitmapDimension().cx;
					DWORD dwTicks = GetTickCount();
						if(pSourceItem->GetUpdateTimer() + DLC_BARUPDATE < dwTicks || cx !=  iWidth  || !pSourceItem->GetUpdateTimer())
					{ 
							pSourceItem->GetBitmap().DeleteObject();
							pSourceItem->GetBitmap().CreateCompatibleBitmap(dc,  iWidth, iHeight);
							pSourceItem->GetBitmap().SetBitmapDimension(iWidth,  iHeight);
							hOldBitmap = cdcStatus.SelectObject(pSourceItem->GetBitmap());

						RECT rec_status;
						rec_status.left = 0;
						rec_status.top = 0;
						rec_status.bottom = iHeight;
						rec_status.right = iWidth;
						try{
							pSource->DrawStatusBar(&cdcStatus,  &rec_status,(pSourceItem->IsAskedForAnotherFile()), g_eMuleApp.m_pGlobPrefs->UseFlatBar());
						}catch(...){} // in case client has been deleted meanwhile

						pSourceItem->SetUpdateTimer(dwTicks + (rand() % 128));
					} else 
						hOldBitmap = cdcStatus.SelectObject(pSourceItem->GetBitmap());

					dc->BitBlt(lpRect->left, lpRect->top, iWidth, iHeight,  &cdcStatus, 0, 0, SRCCOPY);
					cdcStatus.SelectObject(hOldBitmap);

					lpRect->bottom++;
					lpRect->top--;
				}
				else
					iWidth = 300;
			}
			break;

			case DLCOL_NUMSOURCES:		// sources
			{
				CString clientVerString = GetClientNameAndVersionString(pSource);
				// [/Lord KiRon]
				dc->DrawText(clientVerString,clientVerString.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
				{
					iWidth += r.right-r.left+1;
				}
				break;
			}

			case DLCOL_PRIORITY:		// prio
				if ( ( bIsEmuleClient || nRemoteQueueRank)		//now emule v ? display the QR too!
					&& nDownloadState==DS_ONQUEUE && !pSourceItem->IsAskedForAnotherFile() )
				{
					if (bRemoteQueueFull)
					{
						buffer = GetResString(IDS_QUEUEFULL);
						dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
					}
					else
					{
						if (nRemoteQueueRank)
						{
							COLORREF		crOldTxtColor;

							if (nDifference == nRemoteQueueRank)
							{
								crOldTxtColor = dc->SetTextColor((COLORREF)RGB(0,0,0));
								buffer.Format("QR: %u (%u)",nRemoteQueueRank,(nRemoteQueueRank-nDifference));
							}      
							else if (nDifference < nRemoteQueueRank)
							{  
								crOldTxtColor = dc->SetTextColor((COLORREF)RGB(190,60,60));
								buffer.Format("QR: %u (+%u)",nRemoteQueueRank,(nDifference));
								if (nDifference == 0)
								{
									crOldTxtColor = dc->SetTextColor((COLORREF)RGB(5,65,195));
									buffer.Format("QR: %u (%u)",nRemoteQueueRank,(nDifference));
								}
							}
							else
							{
								crOldTxtColor = dc->SetTextColor((COLORREF)RGB(10,160,70));
								buffer.Format("QR: %u (-%u)",nRemoteQueueRank,(65536-nDifference));
							}
							dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
							crOldTxtColor = dc->SetTextColor((COLORREF)RGB(0,0,0));
						}
						else
						{
							dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
						}
					}
					if (bMeasuring)
					{
						iWidth += r.right-r.left+1;
					}
				}
				else
				{
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag);
				}
				break;

		    case DLCOL_STATUS:		// status
				// Lord KiRon
				r.left += 6;
				point.x = r.left;
				point.y = r.top+1;

				dc->DrawText(sDownloadState,sDownloadState.GetLength(),&r, iCalcFlag);
				if (bMeasuring)
				{
					iWidth += r.right-r.left+1 + 6;
				}
			// Lord KiRon - end
			    break;
			
			case DLCOL_REMAINING:		// remaining size
	#ifdef LATER
				{
				//	MOREVIT: - display last part remaining
				//	TODO: (bug - we want the CURRENT part)
					uint16		iLastPart = pSource->GetLastDownPartAsked();
					uint8		ds = pSource->GetDownloadState();
					uint32		iPartSize = 0L;
	    
					if (iLastPart != 0xFFFF && ds==DS_DOWNLOADING)
					{
						iPartSize = pSourceItem->GetFile()->GetBytesInPart(iLastPart,true);
						buffer.Format( _T("%s (Part %i)"),
									static_cast<LPCTSTR>(CastItoXBytes(iPartSize)),
									pSource->GetLastDownPartAsked() );
					}
					else
					{
						buffer = "";
					}
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_LEFT);
					break;
				}
	#endif LATER
				break;
			case DLCOL_REMAININGTIME:	// remaining time
	#ifdef LATER
				{
					uint16		iLastPart = pSource->GetLastDownPartAsked();
					uint8		ds = pSource->GetDownloadState();
					uint32		iPartSize = 0L;
	    
					if (iLastPart != 0xFFFF && ds==DS_DOWNLOADING && nDownloadDataRate != 0)
					{
						iPartSize = pSourceItem->GetFile()->GetBytesInPart(iLastPart,true);
	    
						uint32		seconds = iPartSize / nDownloadDataRate;
	    
						buffer = ::CastSecondsToHM(iPartSize);
					}
					else
					{
						buffer = "";
					}
					break;
				}
	#endif LATER
				break;
			case DLCOL_ULDLRATIO: // UL/DL Ratio Maverick
				if (bIsRemoteInfoAvail || bCredits)
					buffer.Format(_T("%0.1f"), dblRemoteBaseModifier);
				else buffer="";
				dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
				if (bMeasuring)
				{
					iWidth += r.right-r.left+1;
				}
				break;
			case DLCOL_QLRATING: // Ratio total Maverick
				if (bIsRemoteInfoAvail || bCredits)
					buffer.Format(_T("%ld"), nRemoteRatio);
				else
					buffer="";
				dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
				if (bMeasuring && buffer.GetLength() != 0)
				{
					iWidth += r.right-r.left+1;
				}
				break;
			case DLCOL_LASTSEENCOMPLETE:
				break;
			case DLCOL_LASTRECEIVED:
				break;
			case DLCOL_CATEGORY:
				break;
			case DLCOL_WAITED:
				if (!IsColumnHidden(DLCOL_WAITED))
				{
					uint8		ds = pSource->GetDownloadState();
	    
					if (ds == DS_ONQUEUE)
					{
						uint32		iSeconds = pSource->GetQueueWaitTime() / 1000.0;
	    
						buffer = ::CastSecondsToHM(iSeconds);
					}
					else
					{
						buffer = "";
					}
					dc->DrawText(buffer,buffer.GetLength(),&r, iCalcFlag | DT_RIGHT);
					if (bMeasuring && buffer.GetLength() != 0)
					{
						iWidth += r.right-r.left+1;
					}
					break;
				}
			case DLCOL_AVGSPEED:
				break;
			case DLCOL_AVGREMTIME:
				break;
			case DLCOL_ETA:
				break;
			case DLCOL_AVGETA:
				break;
		}
		if (bMeasuring)
		{
		//	Pin the column widths at some reasonable value
			if (iWidth < 40 && iWidth != 0)
				iWidth = 40;
			if (iWidth > m_iColumnMaxWidths[m_iMeasuringColumn])
				m_iColumnMaxWidths[m_iMeasuringColumn] = iWidth;
		}
	}
#endif //OLD_SOCKETS_ENABLED
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	EMULE_TRY

	if (!g_eMuleApp.m_pdlgEmule->IsRunning())
		return;
	if (!lpDrawItemStruct->itemData)
		return;

	if (m_bShowSrc && m_dwSortTime + 1000 < ::GetTickCount())
	{	
		SortInit(false);
	}

	CDC				   *odc = CDC::FromHandle(lpDrawItemStruct->hDC);
	CMuleCtrlItem	   *pItem = reinterpret_cast<CMuleCtrlItem*>(lpDrawItemStruct->itemData);
	CPartFileDLItem	   *pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
	CSourceDLItem	   *pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);
	BOOL				bCtrlFocused = ((GetFocus() == this) || (GetStyle() & LVS_SHOWSELALWAYS));
	RECT				cur_rec;

	if (pFileItem != NULL && (lpDrawItemStruct->itemAction | ODA_SELECT) && (lpDrawItemStruct->itemState & ODS_SELECTED))
	{
		if (bCtrlFocused)
			odc->SetBkColor(m_crHighlight);
		else
			odc->SetBkColor(m_crNoHighlight);
	}
	else
		odc->SetBkColor(GetBkColor());

	CMemDC			dc(odc,&CRect(lpDrawItemStruct->rcItem));
	CFont			*pOldFont = dc->SelectObject(GetFont());
	COLORREF		crOldTextColor = dc->SetTextColor(m_crWindowText);
	CHeaderCtrl		*pHeaderCtrl = GetHeaderCtrl();

	memcpy2(&cur_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

//	If we're just measuring...
	if (m_iMeasuringColumn >= 0)
	{
		if (pFileItem != NULL)
		{
		//	MOREVIT - This is a tough one. We REALLY ought to figure some way
		//		to separate the measuring and drawing routines but as they
		//		require largely the same code and we want to avoid duplication
		//		at all costs, there's no easy way ATM.
			DrawFileItem(dc, m_iMeasuringColumn, &cur_rec, pFileItem);
		}
		else if (pSourceItem != NULL)
		{
			DrawSourceItem(dc, m_iMeasuringColumn, &cur_rec, pSourceItem);
		}
		return;
	}

	BOOL		bNotLast = lpDrawItemStruct->itemID + 1 != GetItemCount();
	BOOL		bNotFirst = lpDrawItemStruct->itemID != 0;
	int			tree_start=0;
	int			tree_end=0;

//	offset was 4, now it's the standard 2 spaces
	int			iOffset = dc->GetTextExtent(_T(" "), 1 ).cx * 2;
	int			iNumColumns = pHeaderCtrl->GetItemCount();

	cur_rec.right = cur_rec.left;
	cur_rec.right -= iOffset;
	cur_rec.left += iOffset/2;

	if (pFileItem != NULL)
	{
		for (int iCurrent = 0; iCurrent < iNumColumns; iCurrent++) 
		{
			int		iColumn = pHeaderCtrl->OrderToIndex(iCurrent);
			int		cx = CListCtrl::GetColumnWidth(iColumn);

			if (iColumn == DLCOL_PROGRESS)
			{
				int		iNextLeft = cur_rec.left + cx;

			//	Set up tree vars
				cur_rec.left = cur_rec.right + iOffset;
				cur_rec.right = cur_rec.left + min(8, cx);
				tree_start = cur_rec.left + 1;
				tree_end = cur_rec.right;

			//	Normal column stuff
				cur_rec.left = cur_rec.right + 1;
				cur_rec.right = tree_start + cx - iOffset;
				DrawFileItem(dc, 5, &cur_rec, pFileItem);
				cur_rec.left = iNextLeft;
			} 
			else 
			{
				cur_rec.right += cx;
				DrawFileItem(dc, iColumn, &cur_rec, pFileItem);
				cur_rec.left += cx;
			}

		}
	} 
	else if (pSourceItem != NULL)
	{
		for (int iCurrent = 0; iCurrent < iNumColumns; iCurrent++)
		{
			int		iColumn = pHeaderCtrl->OrderToIndex(iCurrent);
			int		cx = CListCtrl::GetColumnWidth(iColumn);

			if (iColumn == DLCOL_PROGRESS)
			{
				int		iNextLeft = cur_rec.left + cx;

			//	Set up tree vars
				cur_rec.left = cur_rec.right + iOffset;
				cur_rec.right = cur_rec.left + min(8, cx);
				tree_start = cur_rec.left + 1;
				tree_end = cur_rec.right;
			//	Normal column stuff
				cur_rec.left = cur_rec.right + 1;
				cur_rec.right = tree_start + cx - iOffset;
				DrawSourceItem(dc, 5, &cur_rec, pSourceItem);
				cur_rec.left = iNextLeft;
			} 
			else 
			{
				cur_rec.right += cx;
				DrawSourceItem(dc, iColumn, &cur_rec, pSourceItem);
				cur_rec.left += cx;
			}
		}
	}
//
//	Draw rectangle around selected item(s)
//
	if ( (lpDrawItemStruct->itemAction | ODA_SELECT)
	  && (lpDrawItemStruct->itemState & ODS_SELECTED) && pFileItem != NULL )
	{
		RECT outline_rec;
		memcpy2(&outline_rec,&lpDrawItemStruct->rcItem,sizeof(RECT));

		outline_rec.top--;
		outline_rec.bottom++;
		CBrush brush(GetBkColor());
		CBrush* pOldBrush = dc->SelectObject(&brush);
		dc->FrameRect(&outline_rec, &brush);
		dc->SelectObject(pOldBrush);
		outline_rec.top++;
		outline_rec.bottom--;
		outline_rec.left++;
		outline_rec.right--;

		if (bNotFirst && (GetItemState(lpDrawItemStruct->itemID - 1, LVIS_SELECTED)))
		{
			CMuleCtrlItem	   *pPrevItem = ListGetItemAt(lpDrawItemStruct->itemID - 1);

			if (typeid(*pPrevItem) == typeid(CPartFileDLItem))
				outline_rec.top--;
		} 

		if (bNotLast && (GetItemState(lpDrawItemStruct->itemID + 1, LVIS_SELECTED)))
		{
			CMuleCtrlItem	   *pNextItem = ListGetItemAt(lpDrawItemStruct->itemID + 1);

			if (typeid(*pNextItem) == typeid(CPartFileDLItem))
				outline_rec.bottom++;
		} 

		if (bCtrlFocused)
		{
			CBrush fBrush(m_crFocusLine);
			CBrush* pOldfBrush = dc->SelectObject(&fBrush);	//eklmn: select a new brush
			dc->FrameRect(&outline_rec, &fBrush);
			dc->SelectObject(pOldfBrush);	//eklmn: recover an old brush
		}
		else
		{
			CBrush nfBrush(m_crNoFocusLine);
			CBrush* pOldnfBrush = dc->SelectObject(&nfBrush);	//eklmn: select a new brush
			dc->FrameRect(&outline_rec, &nfBrush);
			dc->SelectObject(pOldnfBrush);	//eklmn: recover an old brush
		}
	}
//	Draw focus rectangle around non-highlightable items when they have the focus
	else if (((lpDrawItemStruct->itemState & ODS_FOCUS) == ODS_FOCUS) && (GetFocus() == this))
	{
		RECT focus_rec;
		focus_rec.top    = lpDrawItemStruct->rcItem.top;
		focus_rec.bottom = lpDrawItemStruct->rcItem.bottom;
		focus_rec.left   = lpDrawItemStruct->rcItem.left + 1;
		focus_rec.right  = lpDrawItemStruct->rcItem.right - 1;
		CBrush nfBrush(m_crNoFocusLine);
		CBrush* pOldnfBrush = dc->SelectObject(&nfBrush);
		dc->FrameRect(&focus_rec, &nfBrush);
		dc->SelectObject(pOldnfBrush);
	}

//	Draw tree last so it draws over selected and focus (looks better)
	if (tree_start < tree_end)
	{
		//set new bounds
		RECT tree_rect;
		tree_rect.top    = lpDrawItemStruct->rcItem.top;
		tree_rect.bottom = lpDrawItemStruct->rcItem.bottom;
		tree_rect.left   = tree_start;
		tree_rect.right  = tree_end;
		dc->SetBoundsRect(&tree_rect, DCB_DISABLE);

		//gather some information
		CMuleCtrlItem	   *pItem2 = ListGetItemAt(lpDrawItemStruct->itemID + 1);
		CSourceDLItem	   *pSourceItem2 = dynamic_cast<CSourceDLItem*>(pItem2);

		BOOL hasNext = bNotLast && pSourceItem2 != NULL;
		BOOL isOpenRoot = hasNext && pFileItem != NULL;
		BOOL isChild = pSourceItem != NULL;
		BOOL isExpandable = !isChild && pItem->GetFile()->GetSourceCount() > 0;
		//might as well calculate these now
		int treeCenter = tree_start + 3;
		int middle = (cur_rec.top + cur_rec.bottom + 1) / 2;

		//set up a new pen for drawing the tree
		CPen pn, *oldpn;
		pn.CreatePen(PS_SOLID, 1, dc->GetTextColor());
		oldpn = dc->SelectObject(&pn);

		if(isChild)
		{
			//draw the line to the status bar
			dc->MoveTo(tree_end, middle);
			dc->LineTo(tree_start + 3, middle);

			//draw the line to the child node
			if(hasNext)
			{
				dc->MoveTo(treeCenter, middle);
				dc->LineTo(treeCenter, cur_rec.bottom + 1);
			}
		} else if(isOpenRoot) {
			//draw circle
			RECT circle_rec;
			COLORREF crBk = dc->GetBkColor();
			circle_rec.top    = middle - 2;
			circle_rec.bottom = middle + 3;
			circle_rec.left   = treeCenter - 2;
			circle_rec.right  = treeCenter + 3;
			CBrush brush(dc->GetTextColor());
			CBrush* pOldBrush = dc->SelectObject(&brush);
			dc->FrameRect(&circle_rec, &brush);
			dc->SelectObject(pOldBrush);
			dc->SetPixelV(circle_rec.left,      circle_rec.top,    crBk);
			dc->SetPixelV(circle_rec.right - 1, circle_rec.top,    crBk);
			dc->SetPixelV(circle_rec.left,      circle_rec.bottom - 1, crBk);
			dc->SetPixelV(circle_rec.right - 1, circle_rec.bottom - 1, crBk);
			//draw the line to the child node
			if(hasNext)
			{
				dc->MoveTo(treeCenter, middle + 3);
				dc->LineTo(treeCenter, cur_rec.bottom + 1);
			}
		}
		//draw the line back up to parent node
		if(bNotFirst && isChild)
		{
			dc->MoveTo(treeCenter, middle);
			dc->LineTo(treeCenter, cur_rec.top - 1);
		}

		//put the old pen back
		dc->SelectObject(oldpn);
		pn.DeleteObject();
	}

	//put the original objects back
	if (pOldFont)
		dc->SelectObject(pOldFont);
	if (crOldTextColor)
		dc->SetTextColor(crOldTextColor);
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::HideSources(CPartFile *pPartFile)
{
	EMULE_TRY

	SetRedraw(false);

//	For each item in the list control...
	for (int i = 0; i < GetItemCount();)
	{
		CMuleCtrlItem		*pItem = ListGetItemAt(i);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

	//	If it's a source item belonging to 'pPartFile'...
		if (pSourceItem != NULL && pSourceItem->GetParentFile() == pPartFile)
		{
			pSourceItem->GetParentFileItem()->m_bSrcsAreVisible = false;
			pSourceItem->ResetUpdateTimer();
			pSourceItem->GetBitmap().DeleteObject();
			pSourceItem->SetVisibility(false);
			DeleteItem(i);
		}
		else
		{
			i++;
		}
	}
	if (m_bShowSrc)
	{
		m_bShowSrc = false;
	//	For each item in the list...
		for (int i = 0; i < GetItemCount(); i++)
		{
			CMuleCtrlItem	   *pItem = ListGetItemAt(i);

		//	If there's a source item left...
			if (typeid(*pItem) == typeid(CSourceDLItem))
			{
				m_bShowSrc = true;
				break;
			}
		}
		
#ifdef OLD
		if (g_eMuleApp.m_pGlobPrefs->DoUseSort() && !m_bShowSrc)	//Cax2 ...& restore the sort index that was there before expanding the files
		{
			m_dwLastSortCode = m_iFilesSortIndex;
			m_iCurrentSortItem = m_dwLastSortCode < MLC_SORTDESC ? m_dwLastSortCode : m_dwLastSortCode - MLC_SORTDESC;
			SetSortArrow(m_iCurrentSortItem, (m_dwLastSortCode < MLC_SORTDESC));
		}
#endif OLD
	}
	SetRedraw(true);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnItemActivate(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	LPNMITEMACTIVATE	pNMIA = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	ExpandCollapseItem(pNMIA->iItem,EXPAND_COLLAPSE);
	*pResult = 0;
	
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ExpandCollapseItem(int iItem,enum EnumExpandType expand,bool bCollapseSource)
{
	EMULE_TRY

	if (iItem == -1) 
	{
		return;
	}

	CMuleCtrlItem	   *pItem = ListGetItemAt(iItem);
	CSourceDLItem	   *pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);
	CPartFileDLItem	   *pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

	bool	isShift = GetAsyncKeyState(VK_SHIFT) < 0;
	bool	isCtrl = GetAsyncKeyState(VK_CONTROL) < 0;
	bool	isAlt = GetAsyncKeyState(VK_MENU) < 0;
	int		iNumAdded = 0;

	if (bCollapseSource && pSourceItem != NULL && pSourceItem->GetParentFileItem() != NULL) 
	{
	//	To collapse/expand files when one of its source is selected
		CPartFileDLItem	   *pParentFileItem = pSourceItem->GetParentFileItem();
		
		iItem = ListGetFileItemIndex(pParentFileItem);

		if (iItem == -1)
			return;

		pFileItem = pParentFileItem;
	}

	if (pFileItem != NULL)
	{
		if (g_eMuleApp.m_pGlobPrefs->DoUseSort() && !m_bShowSrc)		//Cax2 - restore the sort index that was there before opening the files if advanced sort
		{		
			m_iFilesSortIndex = m_dwLastSortCode;
		}
		
		CPartFile		*pPartFile = pFileItem->GetFile();

		if (pPartFile == NULL) 
		{
			return;
		}

	//	If the source branch is disabled and the parent file isn't completing...
		if (pFileItem->m_bSrcsAreVisible == false && pPartFile->GetStatus() != PS_COMPLETING) 
		{
			if (expand == EXPAND_ONLY || expand == EXPAND_COLLAPSE)
			{
				m_bShowSrc = true;

				SetRedraw(false);
				
				pFileItem->m_bSrcsAreVisible = true;

			//	Get the sources items for this file item
				CPartFileDLItem::SourceItemVector	   *pvecSourceItems = pFileItem->GetSources();

				int		iNumSourceItems = pvecSourceItems->size();

				for (int i = 0; i < iNumSourceItems; i++)
				{
					if (!IsSourceFiltered((*pvecSourceItems)[i]))
					{
						iNumAdded++;
						ListInsertSourceItem((*pvecSourceItems)[i],iItem+1);
					}
				}

				delete pvecSourceItems;

				pFileItem->m_bSrcsAreVisible = iNumAdded > 0;

				SetRedraw(true);
			}
		}
	//	If the file is currently showing sources, has no sources, or is completing...
		else 
		{
			if (expand == EXPAND_COLLAPSE || expand == COLLAPSE_ONLY) 
			{
				HideSources(pPartFile);
			}
		}

		SortInit(false);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CDownloadListCtrl::OnWndMsg(UINT iMessage,WPARAM wParam, LPARAM lParam, LRESULT *pResult)
{
	BOOL		bHandled = FALSE;

	EMULE_TRY

	switch (iMessage)
	{
		case WM_DL_REFRESH:
		{
			static DWORD		dwLastRefreshTime = 0;

			if (::GetTickCount() > dwLastRefreshTime + 1000)
			{
				CDownloadList::PartFileItemVector	   *pvecDirtyFileItems = g_eMuleApp.m_pDownloadList->GetDirtyFiles();

				if (pvecDirtyFileItems != NULL)
				{
					int		iNumDirtyFileItems = pvecDirtyFileItems->size();

					for (int i = 0; i < iNumDirtyFileItems; i++)
					{
						UpdateFileItem((*pvecDirtyFileItems)[i]);
					}

					delete pvecDirtyFileItems;
				}

				CDownloadList::SourceItemVector	   *pvecDirtySources = g_eMuleApp.m_pDownloadList->GetDirtySources();

				if (pvecDirtySources != NULL)
				{
					int		iNumDirtySources = pvecDirtySources->size();

					for (int i = 0; i < iNumDirtySources; i++)
					{
						UpdateSourceItem((*pvecDirtySources)[i]);
					}

					delete pvecDirtySources;
				}

				dwLastRefreshTime = ::GetTickCount();
			}
			bHandled = true;
			break;
		}
	}

	EMULE_CATCH

	if (!bHandled)
	{
		bHandled = CMuleListCtrl::OnWndMsg(iMessage,wParam,lParam,pResult);
	}

	return bHandled;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnContextMenu(CWnd *pWnd, CPoint point)
{
	EMULE_TRY

#ifdef OLD_SOCKETS_ENABLED
	CTitleMenu		menuClient;
	CTitleMenu		menuFile;
	CTitleMenu		menuSourceFilter;
	CMenu			menuAdvanced;
	CMenu			menuPriority;
	CMenu			menuED2K;
	CMenu			menuWeb;

//	If at least one item is selected...
	if (!ListSelectionIsEmpty())
	{
		CMuleCtrlItem		*pItem = ListGetOneSelectedItem();
		CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);
		const CPartFile		*cpPartFile = NULL;

	//	If the selected item is a file...
		if (pFileItem != NULL) 
		{
			cpPartFile = pFileItem->GetFile();
		}
		if (cpPartFile != NULL)
		{
			CPartFile			   *pPartFile = const_cast<CPartFile*>(cpPartFile);
			bool					bFileDone = ( pPartFile->GetStatus()==PS_COMPLETE
											   || pPartFile->GetStatus()==PS_COMPLETING );
			bool					bJustOne = (GetSelectedCount()==1);
			EnumPartFileStatuses	eFileStatus = pPartFile->GetStatus();
		//
		//	Switch the info list header to display the selected file.
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.SetList(INFOLISTTYPE_FILE, pPartFile);
		
			UINT		uFlagIfDone  = bFileDone ? MF_GRAYED:MF_ENABLED;
		//
		//	Create the "File" menu
			menuFile.CreatePopupMenu();
			menuFile.AddMenuTitle(GetResString(IDS_DOWNLOADMENUTITLE));
		//
		//	Create/build the priority sub-menu
			menuPriority.CreateMenu();
			menuPriority.AppendMenu(MF_STRING,MP_PRIOLOW, GetResString(IDS_PRIOLOW));
			menuPriority.EnableMenuItem(MP_PRIOLOW,uFlagIfDone);
			menuPriority.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
			menuPriority.EnableMenuItem(MP_PRIONORMAL,uFlagIfDone);
			menuPriority.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
			menuPriority.EnableMenuItem(MP_PRIOHIGH,uFlagIfDone);
			menuPriority.AppendMenu(MF_STRING,MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));
			menuPriority.EnableMenuItem(MP_PRIOAUTO,uFlagIfDone);

			menuPriority.CheckMenuItem(MP_PRIOLOW,(bJustOne && !pPartFile->IsAutoPrioritized() && pPartFile->GetPriority() == PR_LOW)? MF_CHECKED:MF_UNCHECKED);
			menuPriority.CheckMenuItem(MP_PRIONORMAL,(bJustOne && !pPartFile->IsAutoPrioritized() && pPartFile->GetPriority() == PR_NORMAL)? MF_CHECKED:MF_UNCHECKED);
			menuPriority.CheckMenuItem(MP_PRIOHIGH,(bJustOne && !pPartFile->IsAutoPrioritized() && pPartFile->GetPriority() == PR_HIGH)? MF_CHECKED:MF_UNCHECKED);
			menuPriority.CheckMenuItem(MP_PRIOAUTO, (bJustOne && pPartFile->IsAutoPrioritized())? MF_CHECKED:MF_UNCHECKED);
		//
		//	Create/build the ED2K sub-menu
			menuED2K.CreateMenu();
			menuED2K.AppendMenu(MF_STRING,MP_GETED2KLINK, GetResString(IDS_DL_LINK1) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLED2KLink),SSP_TAB_PREFIX));
			menuED2K.AppendMenu(MF_STRING,MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLED2kLinkHtml),SSP_TAB_PREFIX));
			menuED2K.AppendMenu(MF_STRING,MP_GETSOURCEED2KLINK, GetResString(IDS_CREATESOURCELINK) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLED2kLinkSource),SSP_TAB_PREFIX));
		//
		//	Create/build the source filter sub-menu
			menuSourceFilter.CreateMenu();
			menuSourceFilter.AddMenuTitle(GetResString(IDS_SRCFILTERMENU_SHOWING));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowUploadingSources?MF_CHECKED:0),MP_SRCFILTER_UPLOADING,GetResString(IDS_SRCFILTERMENU_UPLOADING));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowOnQueueSources?MF_CHECKED:0),MP_SRCFILTER_ONQUEUE,GetResString(IDS_SRCFILTERMENU_ONQUEUE));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowFullQueueSources?MF_CHECKED:0),MP_SRCFILTER_FULLQUEUE,GetResString(IDS_SRCFILTERMENU_FULLQUEUE));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowConnectedSources?MF_CHECKED:0),MP_SRCFILTER_CONNECTED,GetResString(IDS_SRCFILTERMENU_CONNECTED));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowConnectingSources?MF_CHECKED:0),MP_SRCFILTER_CONNECTING,GetResString(IDS_SRCFILTERMENU_CONNECTING));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowNNPSources?MF_CHECKED:0),MP_SRCFILTER_NNP,GetResString(IDS_SRCFILTERMENU_NONEEDEDPARTS));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowTooManyConnSources?MF_CHECKED:0),MP_SRCFILTER_TOOMANYCONN,GetResString(IDS_SRCFILTERMENU_TOOMANYCONN));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowLowToLowIDSources?MF_CHECKED:0),MP_SRCFILTER_LOWTOLOWID,GetResString(IDS_SRCFILTERMENU_LOWIDTOLOWID));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowBannedSources?MF_CHECKED:0),MP_SRCFILTER_BANNED,GetResString(IDS_SRCFILTERMENU_BANNED));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowErrorSources?MF_CHECKED:0),MP_SRCFILTER_ERROR,GetResString(IDS_SRCFILTERMENU_ERROR));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowA4AFSources?MF_CHECKED:0),MP_SRCFILTER_A4AF,GetResString(IDS_SRCFILTERMENU_A4AF));
			menuSourceFilter.AppendMenu(MF_STRING|(pFileItem->m_bShowUnknownSources?MF_CHECKED:0),MP_SRCFILTER_UNKNOWN,GetResString(IDS_SRCFILTERMENU_UNKNOWN));

			menuSourceFilter.AppendMenu(MF_SEPARATOR);

			menuSourceFilter.AppendMenu(MF_STRING,MP_SRCFILTER_SHOWALL,GetResString(IDS_SRCFILTERMENU_SHOWALL));
			menuSourceFilter.AppendMenu(MF_STRING,MP_SRCFILTER_HIDEALL,GetResString(IDS_SRCFILTERMENU_HIDEALL));
		//
		//	Create/build the advanced sub-menu
			menuAdvanced.CreateMenu();
			menuAdvanced.AppendMenu(MF_STRING,MP_FAKE_CHECK,GetResString(IDS_FAKE_CHECK));
			menuAdvanced.EnableMenuItem(MP_FAKE_CHECK, bJustOne ? MF_ENABLED:MF_GRAYED);
			menuAdvanced.AppendMenu(MF_STRING,MP_FAKE_REPORT,GetResString(IDS_FAKE_REPORT));
			menuAdvanced.EnableMenuItem(MP_FAKE_REPORT, bJustOne ? MF_ENABLED:MF_GRAYED);
			menuAdvanced.AppendMenu(MF_SEPARATOR);
			menuAdvanced.AppendMenu(MF_STRING,MP_DOCLEANUP, GetResString(IDS_DOCLEANUP));
			menuAdvanced.EnableMenuItem(MP_DOCLEANUP, (bJustOne && bFileDone) ? MF_GRAYED:MF_ENABLED);
			menuAdvanced.AppendMenu(MF_STRING,MP_CHANGEDIR, GetResString(IDS_CHANGEDIR));
			menuAdvanced.EnableMenuItem(MP_CHANGEDIR, !bFileDone ? MF_ENABLED:MF_GRAYED);
			menuAdvanced.AppendMenu(MF_STRING,MP_PREALLOCATE, GetResString(IDS_DL_PREALLOCATE) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLPreallocate),SSP_TAB_PREFIX));
			menuAdvanced.EnableMenuItem(MP_PREALLOCATE, ( bJustOne
													   && !pPartFile->IsLastBlockComplete()
													   && !pPartFile->IsPreallocated() ) ? MF_ENABLED : MF_GRAYED );
			menuAdvanced.AppendMenu(MF_STRING,MP_MOVIE, GetResString(IDS_MOVIE));
			if (bJustOne && !pPartFile->PreviewAvailable() && !pPartFile->IsArchive())
			{
				menuAdvanced.CheckMenuItem(MP_MOVIE,(pPartFile->GetMovieMode() != 0)?MF_CHECKED:MF_UNCHECKED);
			}
			else
			{
				menuAdvanced.EnableMenuItem(MP_MOVIE, MF_GRAYED);
			}
			menuAdvanced.AppendMenu(MF_SEPARATOR);
			menuAdvanced.AppendMenu(MF_STRING,MP_DROP_SUPERCOMPRESSED, GetResString(IDS_DROPSUPERCOMPRESSED));
			menuAdvanced.CheckMenuItem(MP_DROP_SUPERCOMPRESSED, pPartFile->GetDiscardSuperCompressed() ? MF_CHECKED : MF_UNCHECKED);
			menuAdvanced.EnableMenuItem(MP_DROP_SUPERCOMPRESSED, (bFileDone ? MF_GRAYED : MF_ENABLED));
			menuAdvanced.AppendMenu(MF_STRING,MP_ALL_A4AF_TO_HERE, GetResString(IDS_ALL_A4AF_TO_HERE) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLA4AF),SSP_TAB_PREFIX));
			menuAdvanced.EnableMenuItem(MP_ALL_A4AF_TO_HERE,(bJustOne && !bFileDone) ? MF_ENABLED : MF_GRAYED);

			CString		strBuffer;

			strBuffer.Format(_T("%s (%s)"), GetResString(IDS_ALL_A4AF_TO_HERE), GetResString(IDS_PRIOAUTO));
			menuAdvanced.AppendMenu(MF_STRING,MP_ALL_A4AF_AUTO,strBuffer + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLA4AFAuto),SSP_TAB_PREFIX));
			if (bJustOne && eFileStatus != PS_COMPLETE && eFileStatus != PS_COMPLETING)
			{
				menuAdvanced.CheckMenuItem(MP_ALL_A4AF_AUTO, (pPartFile == g_eMuleApp.m_pDownloadQueue->GetA4AFAutoFile()) ? MF_CHECKED : MF_UNCHECKED);
				menuAdvanced.EnableMenuItem(MP_ALL_A4AF_AUTO, MF_ENABLED);
			}
			else
			{
				menuAdvanced.CheckMenuItem(MP_ALL_A4AF_AUTO, MF_UNCHECKED);
				menuAdvanced.EnableMenuItem(MP_ALL_A4AF_AUTO, MF_GRAYED);
			}
		//
		//	Create/build the web services sub-menu
			int		iNumWebServiceURLs;

			menuWeb.CreateMenu();
			UpdateURLMenu(menuWeb,iNumWebServiceURLs);

			UINT			iWebServicesEmptyFlag = 0;

			iWebServicesEmptyFlag = (iNumWebServiceURLs == 0) ? MF_GRAYED : MF_STRING;
		//
		//	Create/build the category assignment sub-menu
			UINT			iNoUserCatsFlag = 0;
			CTitleMenu		catMenu;
			int				iNumPredefinedCats = CCat::GetNumPredefinedCats();
			int				iFileCatIndex = CCat::CatIndexToUserCatIndex(CCat::GetCatIndexByID(cpPartFile->GetCatID()));

			catMenu.CreatePopupMenu();
			catMenu.AddMenuTitle(GetResString(IDS_CAT));
			if (CCat::GetNumCats() > iNumPredefinedCats)
			{
				iWebServicesEmptyFlag = MF_STRING;
				for (int i = 0; i < CCat::CatIndexToUserCatIndex(CCat::GetNumCats()); i++)
				{
					catMenu.AppendMenu( MF_STRING | (iFileCatIndex == i ? MF_CHECKED : 0),
										MP_ASSIGNCAT + i,
										(i == 0)
									  ? GetResString(IDS_CAT_UNASSIGN)
									  : CCat::GetCatByIndex(CCat::UserCatIndexToCatIndex(i))->GetTitle() );
				}
			}
			else
			{
			//	If there are only predefined cats, gray the assign menu
				iNoUserCatsFlag = MF_GRAYED;
			}
		//
		//	Build the File menu
			menuFile.AppendMenu(MF_STRING,MP_CLEARCOMPLETED, GetResString(IDS_DL_CLEAR) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLClear),SSP_TAB_PREFIX));
			menuFile.AppendMenu(MF_SEPARATOR);
		//	Add the category sub-menu
			menuFile.AppendMenu(iNoUserCatsFlag|MF_POPUP,(UINT_PTR)catMenu.m_hMenu, GetResString(IDS_CAT_ASSIGN) );
		//	Add the priority sub-menu
			menuFile.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)menuPriority.m_hMenu, GetResString(IDS_PRIORITY));
			menuFile.EnableMenuItem((UINT_PTR)menuPriority.m_hMenu, MF_ENABLED);

			menuFile.AppendMenu(MF_STRING,MP_CANCEL, GetResString(IDS_MAIN_BTN_CANCEL) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLCancel),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_CANCEL,(!bFileDone) ? MF_ENABLED : MF_GRAYED);

			menuFile.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_DL_STOP) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLStop),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_STOP,((eFileStatus != PS_STOPPED && eFileStatus != PS_ERROR && !bFileDone ) ? MF_ENABLED:MF_GRAYED));

			menuFile.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_DL_PAUSE) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLPause),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_PAUSE,((eFileStatus != PS_PAUSED && eFileStatus != PS_STOPPED && eFileStatus != PS_ERROR && !bFileDone) ? MF_ENABLED:MF_GRAYED));

			menuFile.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_DL_RESUME) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLResume),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_RESUME,((eFileStatus == PS_PAUSED || eFileStatus == PS_STOPPED) ? MF_ENABLED:MF_GRAYED));

			if (bJustOne && eFileStatus == PS_ERROR)
				menuFile.AppendMenu(MF_STRING,MP_INITIALIZE, GetResString(IDS_DL_INITIALIZE));

			menuFile.AppendMenu(MF_SEPARATOR);

			menuFile.AppendMenu(MF_STRING,MP_OPEN, GetResString(IDS_DL_OPEN) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLOpen),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_OPEN,((bJustOne && eFileStatus == PS_COMPLETE) ? MF_ENABLED:MF_GRAYED));

			menuFile.AppendMenu(MF_STRING,MP_PREVIEW, GetResString(IDS_DL_PREVIEW) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLPreview),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_PREVIEW,((bJustOne && pPartFile->PreviewAvailable()) ? MF_ENABLED:MF_GRAYED));

			menuFile.AppendMenu(MF_STRING,MP_METINFO, GetResString(IDS_DL_INFO) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLDetails),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_METINFO,(bJustOne)?MF_ENABLED:MF_GRAYED);

			menuFile.AppendMenu(MF_STRING,MP_VIEWFILECOMMENTS, GetResString(IDS_CMT_SHOWALL) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLComments),SSP_TAB_PREFIX));
			menuFile.EnableMenuItem(MP_VIEWFILECOMMENTS,(bJustOne && (pPartFile->HasComment() || pPartFile->HasRating())) /*&& !bFileDone*/ ?MF_ENABLED:MF_GRAYED);

			menuFile.AppendMenu(MF_SEPARATOR);
		//	Add the source-filter sub-menu
			menuFile.AppendMenu(MF_STRING|MF_POPUP,reinterpret_cast<UINT_PTR>(menuSourceFilter.m_hMenu), GetResString(IDS_SRCFILTERMENU_TITLE));
		//	Add the advanced sub-menu
			menuFile.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)menuAdvanced.m_hMenu, GetResString(IDS_PW_ADVANCED));
		//	Add the ED2K sub-menu
			menuFile.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)menuED2K.m_hMenu, GetResString(IDS_ED2KLINKFIX));
		//	Add the web services sub-menu
			menuFile.AppendMenu(iWebServicesEmptyFlag|MF_POPUP,(UINT_PTR)menuWeb.m_hMenu, GetResString(IDS_WEBSERVICES));

			menuFile.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
			menuPriority.DestroyMenu();
			menuED2K.DestroyMenu();
			menuAdvanced.DestroyMenu();
			menuSourceFilter.DestroyMenu();
			menuWeb.DestroyMenu();
			menuFile.DestroyMenu();
		}
	//	If the selected item isn't a file...
		else
		{
			const CUpDownClient		*pSource = pSourceItem->GetSource();

			if (pSource != NULL) 
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.SetList(INFOLISTTYPE_SOURCE, const_cast<CUpDownClient*>(pSource));
		//
		//	Create the client menu
			menuClient.CreatePopupMenu();
			menuClient.AddMenuTitle(GetResString(IDS_CLIENTS));
			
			menuClient.AppendMenu(MF_STRING,MP_DETAIL, GetResString(IDS_SHOWDETAILS) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexULDetails),SSP_TAB_PREFIX));
			if (pSource->IsFriend())
				menuClient.AppendMenu(MF_STRING,MP_REMOVEFRIEND, GetResString(IDS_REMOVEFRIEND) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexULFriend),SSP_TAB_PREFIX));
			else
				menuClient.AppendMenu(MF_STRING,MP_ADDFRIEND, GetResString(IDS_ADDFRIEND) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexULFriend),SSP_TAB_PREFIX));
			menuClient.AppendMenu(MF_STRING,MP_MESSAGE, GetResString(IDS_SEND_MSG) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexULMessage),SSP_TAB_PREFIX));
			menuClient.AppendMenu(MF_STRING,MP_SHOWLIST, GetResString(IDS_VIEWFILES) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexULFiles),SSP_TAB_PREFIX));
			if (pSourceItem->IsAskedForAnotherFile())
				menuClient.AppendMenu(MF_STRING,MP_DOWNNOW, GetResString(IDS_DOWNLOAD_A4AF)); // Ambdribant

			menuClient.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
			menuClient.DestroyMenu();
		}
	}
//	If there's no selection (i.e. right-click on empty space in download list)...
	else
	{
		menuFile.CreatePopupMenu();
		menuFile.AddMenuTitle(GetResString(IDS_DOWNLOADMENUTITLE));

		menuFile.AppendMenu(MF_STRING,MP_CLEARCOMPLETED, GetResString(IDS_DL_CLEAR) + GetStringFromShortcutCode(g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLClear),SSP_TAB_PREFIX));
		menuFile.AppendMenu(MF_SEPARATOR);

	//
	//	Create/build the source filter sub-menu
		menuSourceFilter.CreateMenu();
		menuSourceFilter.AddMenuTitle(GetResString(IDS_SRCFILTERMENU_SHOWING));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowUploadingSources?MF_CHECKED:0),MP_SRCFILTER_UPLOADING,GetResString(IDS_SRCFILTERMENU_UPLOADING));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowOnQueueSources?MF_CHECKED:0),MP_SRCFILTER_ONQUEUE,GetResString(IDS_SRCFILTERMENU_ONQUEUE));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowFullQueueSources?MF_CHECKED:0),MP_SRCFILTER_FULLQUEUE,GetResString(IDS_SRCFILTERMENU_FULLQUEUE));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowConnectedSources?MF_CHECKED:0),MP_SRCFILTER_CONNECTED,GetResString(IDS_SRCFILTERMENU_CONNECTED));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowConnectingSources?MF_CHECKED:0),MP_SRCFILTER_CONNECTING,GetResString(IDS_SRCFILTERMENU_CONNECTING));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowNNPSources?MF_CHECKED:0),MP_SRCFILTER_NNP,GetResString(IDS_SRCFILTERMENU_NONEEDEDPARTS));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowTooManyConnSources?MF_CHECKED:0),MP_SRCFILTER_TOOMANYCONN,GetResString(IDS_SRCFILTERMENU_TOOMANYCONN));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowLowToLowIDSources?MF_CHECKED:0),MP_SRCFILTER_LOWTOLOWID,GetResString(IDS_SRCFILTERMENU_LOWIDTOLOWID));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowBannedSources?MF_CHECKED:0),MP_SRCFILTER_BANNED,GetResString(IDS_SRCFILTERMENU_BANNED));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowErrorSources?MF_CHECKED:0),MP_SRCFILTER_ERROR,GetResString(IDS_SRCFILTERMENU_ERROR));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowA4AFSources?MF_CHECKED:0),MP_SRCFILTER_A4AF,GetResString(IDS_SRCFILTERMENU_A4AF));
		menuSourceFilter.AppendMenu(MF_STRING|(m_bShowUnknownSources?MF_CHECKED:0),MP_SRCFILTER_UNKNOWN,GetResString(IDS_SRCFILTERMENU_UNKNOWN));

		menuSourceFilter.AppendMenu(MF_SEPARATOR);

		menuSourceFilter.AppendMenu(MF_STRING,MP_SRCFILTER_SHOWALL,GetResString(IDS_SRCFILTERMENU_SHOWALL));
		menuSourceFilter.AppendMenu(MF_STRING,MP_SRCFILTER_HIDEALL,GetResString(IDS_SRCFILTERMENU_HIDEALL));

		menuSourceFilter.AppendMenu(MF_SEPARATOR);

		menuSourceFilter.AppendMenu(MF_STRING|(m_bSmartFilter?MF_CHECKED:0),MP_SMARTFILTER,GetResString(IDS_SRCFILTERMENU_SMARTFILTER));
	//	Add the source-filter sub-menu
		menuFile.AppendMenu(MF_STRING|MF_POPUP,reinterpret_cast<UINT_PTR>(menuSourceFilter.m_hMenu), GetResString(IDS_SRCFILTERMENU_TITLE));

		menuFile.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
		menuFile.DestroyMenu();
	}
#endif //OLD_SOCKETS_ENABLED

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CDownloadListCtrl::OnCommand(WPARAM wParam,LPARAM lParam )
{
	EMULE_TRY

	if (!ListSelectionIsEmpty())
	{
		CMuleCtrlItem		*pItem = ListGetOneSelectedItem();
		CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);
	//
	//	Construct a list of all the selected part files
		UINT		iNumSelected = GetSelectedCount();
		int			iIndex = -1;
		POSITION	pos = GetFirstSelectedItemPosition();

		CTypedPtrList<CPtrList, CPartFile*>			selectedList;
		CTypedPtrList<CPtrList, CPartFileDLItem*>	selectedItemList;

		while (pos != NULL) 
		{ 
			iIndex = GetNextSelectedItem(pos);
			if (iIndex > -1) 
			{
				if (typeid(*ListGetItemAt(iIndex)) == typeid(CPartFileDLItem))
				{
					selectedItemList.AddTail(dynamic_cast<CPartFileDLItem*>(ListGetItemAt(iIndex)));
					selectedList.AddTail(ListGetItemAt(iIndex)->GetFile());
				}
			} 
		} 
	//	If there's at least one part file item selected...
		if (pFileItem != NULL)
		{
			CPartFile		*pPartFile = pItem->GetFile();

		//
		//	Web services
			if (wParam >= MP_WEBURL && wParam <= MP_WEBURL + 64) 
			{
				RunURL(pPartFile, g_eMuleApp.m_strWebServiceURLArray.GetAt(wParam - MP_WEBURL));
			}
		//
		//	Assign/Unassign to/from Category
			if (wParam >= MP_ASSIGNCAT && wParam <= MP_LASTASSIGNCAT)
			{
				while (!selectedList.IsEmpty()) 
				{ 
					CPartFile	   *pSelectedFile = selectedList.GetHead();
					uint8			iUserCatIndex = wParam - MP_ASSIGNCAT;

					if (iUserCatIndex != 0)
					{
						uint8		iCatIndex = CCat::UserCatIndexToCatIndex(iUserCatIndex);

						pSelectedFile->SetCatID(CCat::GetCatIDByIndex(iCatIndex));
					}
					else
					{
						pSelectedFile->SetCatID(CAT_NONE);
					}
					selectedList.RemoveHead();
				}				
			//	Hide the pPartFile if it's not in the displayed category
				ChangeCategoryByIndex(m_iCurTabIndex);
			//	Redraw the pPartFile in its new color assuming it is visible
				g_eMuleApp.m_pDownloadList->UpdateFile(pPartFile);
			//	Update the category file counts
				g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateCatTabTitles();
			}

			switch (wParam)
			{
				case MPG_DELETE:
				case MP_CANCEL:
				{
				//	For multiple selections 
					if (iNumSelected > 0)
					{
						CString		strFileList="";
						bool		bIsValidDelete = false;

						for (pos = selectedList.GetHeadPosition(); pos != 0; selectedList.GetNext(pos))
						{
							if (selectedList.GetAt(pos)->GetStatus() != PS_COMPLETING && selectedList.GetAt(pos)->GetStatus() != PS_COMPLETE)
							{
								bIsValidDelete = true;
								if (iNumSelected < 50)	// MOREVIT - Why 50? Who's ass did this come out of?
									strFileList.Append("\n"+CString(selectedList.GetAt(pos)->GetFileName()));
							}
						}

						CString		strQuestion;

						if (iNumSelected == 1)
						{
							strQuestion=GetResString(IDS_Q_CANCELDL2);
						}
						else
						{
							strQuestion=GetResString(IDS_Q_CANCELDL);
						}
						if (bIsValidDelete && AfxMessageBox(strQuestion + strFileList,MB_ICONQUESTION|MB_YESNO) == IDYES)
						{
							SetRedraw(false);
	
							while (!selectedList.IsEmpty())
							{
								HideSources(selectedList.GetHead());
								switch(selectedList.GetHead()->GetStatus())
								{ 
									case PS_WAITINGFORHASH:
									case PS_HASHING:
									case PS_COMPLETING:
									case PS_COMPLETE:
										selectedList.RemoveHead();
										break;
									case PS_STOPPED:
									case PS_PAUSED:
										selectedList.GetHead()->DeleteFile();
										selectedList.RemoveHead();
										break;
									default:
										selectedList.GetHead()->DeleteFile();
										selectedList.RemoveHead();
								}
							}  

							SetRedraw(true);
							g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateCatTabTitles();
						}
					}
					break;
				}
				case MP_PRIOHIGH:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{ 
							selectedList.GetHead()->SetAutoPriority(false);
							selectedList.GetHead()->SetPriority(PR_HIGH);
							selectedList.RemoveHead();
						} 
						SetRedraw(true);
						break;
					} 
					pPartFile->SetAutoPriority(false);
					pPartFile->SetPriority(PR_HIGH);
					break;
				case MP_PRIOLOW:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{ 
							selectedList.GetHead()->SetAutoPriority(false);
							selectedList.GetHead()->SetPriority(PR_LOW);
							selectedList.RemoveHead();
						}
						SetRedraw(true);
						break;
					} 
					pPartFile->SetAutoPriority(false);
					pPartFile->SetPriority(PR_LOW);
					break;
				case MP_PRIONORMAL:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{
							selectedList.GetHead()->SetAutoPriority(false);
							selectedList.GetHead()->SetPriority(PR_NORMAL);
							selectedList.RemoveHead();
						}
						SetRedraw(true);
						break;
					} 
					pPartFile->SetAutoPriority(false);
					pPartFile->SetPriority(PR_NORMAL);
					break;
				case MP_PRIOAUTO:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{
							selectedList.GetHead()->SetAutoPriority(true);
							selectedList.GetHead()->SetPriority(PR_HIGH);
							selectedList.RemoveHead();
						}
						SetRedraw(true);
						break;
					} 
					pPartFile->SetAutoPriority(true);
					pPartFile->SetPriority(PR_HIGH);
					break;
				case MP_PAUSE:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{ 
							selectedList.GetHead()->PauseFile();
							selectedList.RemoveHead();
						} 
						SetRedraw(true);
						break;
					} 
					pPartFile->PauseFile();
					break;
				case MP_RESUME:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{ 
							selectedList.GetHead()->ResumeFile();
							selectedList.RemoveHead();
						}
						SetRedraw(true);
						break;
					} 
					pPartFile->ResumeFile();
					break;
				case MP_INITIALIZE:
					if(iNumSelected > 1)
					{
						break;
					} 
					pPartFile->LoadPartFile(pPartFile->GetTempDir(), pPartFile->GetPartMetFileName());
					if (pPartFile->GetStatus(true) == PS_READY)
						g_eMuleApp.m_pSharedFilesList->SafeAddKnownFile(pPartFile);
					break;
				case MP_PREALLOCATE:
					if(iNumSelected > 1)
					{
						break;
					} 
					if(!pPartFile->IsLastBlockComplete())
						pPartFile->AllocateNeededSpace();
					break;
				case MP_STOP:
					if(iNumSelected > 1)
					{
						SetRedraw(false);
						while(!selectedList.IsEmpty()) 
						{ 
							CPartFile *selected = selectedList.GetHead();
							HideSources(selected);
							selected->StopFile();
							selectedList.RemoveHead();
						}
						SetRedraw(true);
						break;
					} 
					HideSources(pPartFile);
					pPartFile->StopFile();
					break;
				case MP_CLEARCOMPLETED:
					SetRedraw(false);
					g_eMuleApp.m_pDownloadList->ClearCompleted(CAT_NONE);
					SetRedraw(true);
					break;
				case MP_METINFO:
				{
					CFileDetails		dialog(GetResString(IDS_FD_TITLE), pPartFile, this, 0);

					dialog.DoModal();
					SetSortArrow(m_iCurrentSortItem, m_bSortAscending);
					break;
				}
				case MP_GETED2KLINK:
					if(iNumSelected > 1)
					{
						CString str;
						while(!selectedList.IsEmpty()) 
						{ 
							str += selectedList.GetHead()->CreateED2kLink() + "\n";
							selectedList.RemoveHead();
						}
						g_eMuleApp.CopyTextToClipboard(str);
						//AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break;
					} 
					g_eMuleApp.CopyTextToClipboard(pPartFile->CreateED2kLink());
					break;
				case MP_GETHTMLED2KLINK:
					if(iNumSelected > 1)
					{
						CString str;
						while(!selectedList.IsEmpty()) 
						{ 
							str += selectedList.GetHead()->CreateHTMLED2kLink() + "\n";
							selectedList.RemoveHead();
						}
						g_eMuleApp.CopyTextToClipboard(str);
						//AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break;
					} 
					g_eMuleApp.CopyTextToClipboard(pPartFile->CreateHTMLED2kLink());
					break;
				case MP_OPEN:
				{
					if(iNumSelected > 1)
					{	
						break;
					}
					ShellOpenFile(pPartFile->GetFullName());
					break;
				}

				//FakeCheck 
  				case MP_FAKE_REPORT:
				{ 
					if(iNumSelected > 1)
					{
						break;
					} 
					ShellExecute(NULL, NULL, "http://donkeyfakes.gambri.net/report/index.php?link2="+pPartFile->CreateED2kLink(), NULL, g_eMuleApp.m_pGlobPrefs->GetAppDir(), SW_SHOWDEFAULT);
					break;
				}
 				case MP_FAKE_CHECK:
				{ 
					if(iNumSelected > 1)
					{
						break;
					} 
					ShellExecute(NULL, NULL, "http://donkeyfakes.gambri.net/fakecheck/update/fakecheck.php?ed2k="+pPartFile->CreateED2kLink(), NULL, g_eMuleApp.m_pGlobPrefs->GetAppDir(), SW_SHOWDEFAULT);
					break;
				}

				case MP_PREVIEW:
				{
					if(iNumSelected > 1)
					{	
						break;
					}
					pPartFile->PreviewFile();
					break;
				}
				case MP_VIEWFILECOMMENTS:
				{
					CCommentDialogLst dialog(pPartFile);
					dialog.DoModal();
					break;
				}
				case MP_CHANGEDIR: 
				{
					CString dir = pPartFile->GetOutputDir();
					if (dir.GetLength() == 2)
						dir.Format("%s\\", dir);
					CString newpath = BrowseFolder(g_eMuleApp.m_pdlgEmule->m_hWnd, GetResString(IDS_SELECTOUTPUTDIR), dir);
					if (newpath.GetLength() == 3)
						newpath.Replace("\\", "");
					if (newpath.CompareNoCase(dir) != 0)
					{
						if (iNumSelected > 1)
						{
							while (!selectedList.IsEmpty())
							{
								selectedList.GetHead()->SetAlternativeOutputDir(&newpath);
								selectedList.GetHead()->SavePartFile();
								selectedList.RemoveHead();
							}			
						}
						pPartFile->SetAlternativeOutputDir(&newpath);
						pPartFile->SavePartFile();
						pPartFile->GetOutputDir();	//SyruS: for what is this good? It's not in the loop above...
					}
					break;
				}
				case MP_DOCLEANUP:
					while (!selectedList.IsEmpty())
					{ 
						CPartFile* selFile = selectedList.GetHead();
						if (selFile->GetStatus() != PS_COMPLETING && selFile->GetStatus() != PS_COMPLETE)
						{
							selFile->SetFileName(CleanupFilename(selFile->GetFileName()).GetBuffer());
							selFile->SavePartFile();
							selFile->UpdateDisplayedInfo(true);
							g_eMuleApp.m_pSharedFilesList->UpdateItem((CKnownFile*)selFile);
						}
						selectedList.RemoveHead();
					}
					break;
				case MP_ALL_A4AF_TO_HERE:
					{
						pPartFile->DownloadAllA4AF();
					}
					break;
				case MP_ALL_A4AF_AUTO:
					{
						if (g_eMuleApp.m_pDownloadQueue->GetA4AFAutoFile() == pPartFile)
							//current pPartFile is A4AF auto => User want to switch it off
							g_eMuleApp.m_pDownloadQueue->SetA4AFAutoFile(NULL);
						else
							//another pPartFile is A4AF auto => switch to new pPartFile
							g_eMuleApp.m_pDownloadQueue->SetA4AFAutoFile(pPartFile);
					}
					break;

				case MP_MOVIE:
					if (!(pPartFile->GetStatus()==PS_COMPLETE) && !(pPartFile->GetStatus()==PS_COMPLETING))
					{
						if (pPartFile->GetMovieMode())
						{
							pPartFile->SetMovieMode(0);
							pPartFile->SaveSettingsFile();
						} else {
							if (pPartFile->IsAviMovie())
							{
								if (selectedList.GetHead()->GetFileSize() < 209715200)
									pPartFile->SetMovieMode(1);
								else
									pPartFile->SetMovieMode(2);
							}	
							else if (pPartFile->IsMpgMovie())
							{
								if (selectedList.GetHead()->GetFileSize() < 209715200)
									pPartFile->SetMovieMode(4);
								else
									pPartFile->SetMovieMode(5);
							}
							else
								pPartFile->SetMovieMode(0);
							pPartFile->SaveSettingsFile();
						}
					}						
					break;

                case MP_DROP_SUPERCOMPRESSED:
					while(!selectedList.IsEmpty())
					{ 
						CPartFile* selFile = selectedList.GetHead();
						if (!(selFile->GetStatus()==PS_COMPLETE) && !(selFile->GetStatus()==PS_COMPLETING))
						{
							selFile->SetDiscardSuperCompressed(!selFile->GetDiscardSuperCompressed());
							selFile->SaveSettingsFile();
						}
						selectedList.RemoveHead();
					} 
					break;
					
				case MP_GETSOURCEED2KLINK:
				{
					if(iNumSelected > 1)
					{
						CString str;
						while(!selectedList.IsEmpty())
						{ 
							str += selectedList.GetHead()->CreateED2KSourceLink(7, 10);
							selectedList.RemoveHead();
							if(!selectedList.IsEmpty())
								str += "\n";
						}
						g_eMuleApp.CopyTextToClipboard(str);
						AfxMessageBox(GetResString(IDS_COPIED2CB) + str);
						break;
					} 
					g_eMuleApp.CopyTextToClipboard(pPartFile->CreateED2KSourceLink(7, 10));
					break;
				}
				case MP_SRCFILTER_UPLOADING:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowUploadingSources = !selectedItemList.GetHead()->m_bShowUploadingSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_ONQUEUE:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowOnQueueSources = !selectedItemList.GetHead()->m_bShowOnQueueSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_FULLQUEUE:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowFullQueueSources = !selectedItemList.GetHead()->m_bShowFullQueueSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_CONNECTED:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowConnectedSources = !selectedItemList.GetHead()->m_bShowConnectedSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_CONNECTING:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowConnectingSources = !selectedItemList.GetHead()->m_bShowConnectingSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_NNP:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowNNPSources = !selectedItemList.GetHead()->m_bShowNNPSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_TOOMANYCONN:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowTooManyConnSources = !selectedItemList.GetHead()->m_bShowTooManyConnSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_LOWTOLOWID:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowLowToLowIDSources = !selectedItemList.GetHead()->m_bShowLowToLowIDSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_BANNED:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowBannedSources = !selectedItemList.GetHead()->m_bShowBannedSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_ERROR:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowErrorSources = !selectedItemList.GetHead()->m_bShowErrorSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_A4AF:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowA4AFSources = !selectedItemList.GetHead()->m_bShowA4AFSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_UNKNOWN:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->m_bShowUnknownSources = !selectedItemList.GetHead()->m_bShowUnknownSources;
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_HIDEALL:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->FilterAllSources();
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
				case MP_SRCFILTER_SHOWALL:
				{
					if (iNumSelected > 0)
					{
						while (!selectedItemList.IsEmpty()) 
						{ 
							selectedItemList.GetHead()->FilterNoSources();
							selectedItemList.RemoveHead();
						}
						UpdateSourceItems();
					} 
					break;
				}
			}
		}
	//	If a source item is selected...
		else
		{
#ifdef OLD_SOCKETS_ENABLED
			CUpDownClient		*pSource = pSourceItem->GetSource();

			switch (wParam)
			{
				case MP_SHOWLIST:
					pSource->RequestSharedFileList();
					break;
				case MP_MESSAGE:
					g_eMuleApp.m_pdlgEmule->m_wndChat.StartSession(pSource);
					break;
				case MP_ADDFRIEND:
					g_eMuleApp.m_pFriendList->AddFriend(pSource);
					break;
				case MP_REMOVEFRIEND:
					g_eMuleApp.m_pFriendList->RemoveFriend(pSource);
					break;
				case MP_DETAIL:
				{
					CClientDetails		dialog(GetResString(IDS_CD_TITLE), pSource, this, 0);

					dialog.DoModal();
					break;
				}
				case MP_DOWNNOW: 
				{
					CPartFile		*pParentFile = pSourceItem->GetParentFile();

					pSource->SwapToAnotherFile(pParentFile);
					break;
				}				
			}
#endif //OLD_SOCKETS_ENABLED
		}
	//	Cleanup multiselection
		selectedList.RemoveAll();
	}
//	If nothing was selected in the list...
	else
	{
		switch (wParam)
		{
			case MP_CLEARCOMPLETED:
				g_eMuleApp.m_pDownloadList->ClearCompleted(CAT_NONE);
				break;
			case MP_SRCFILTER_UPLOADING:
			{
				m_bShowUploadingSources = !m_bShowUploadingSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_ONQUEUE:
			{
				m_bShowOnQueueSources = !m_bShowOnQueueSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_FULLQUEUE:
			{
				m_bShowFullQueueSources = !m_bShowFullQueueSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_CONNECTED:
			{
				m_bShowConnectedSources = !m_bShowConnectedSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_CONNECTING:
			{
				m_bShowConnectingSources = !m_bShowConnectingSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_NNP:
			{
				m_bShowNNPSources = !m_bShowNNPSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_TOOMANYCONN:
			{
				m_bShowTooManyConnSources = !m_bShowTooManyConnSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_LOWTOLOWID:
			{
				m_bShowLowToLowIDSources = !m_bShowLowToLowIDSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_BANNED:
			{
				m_bShowBannedSources = !m_bShowBannedSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_ERROR:
			{
				m_bShowErrorSources = !m_bShowErrorSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_A4AF:
			{
				m_bShowA4AFSources = !m_bShowA4AFSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_UNKNOWN:
			{
				m_bShowUnknownSources = !m_bShowUnknownSources;
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_HIDEALL:
			{
				FilterAllSources();
				UpdateSourceItems();
				break;
			}
			case MP_SRCFILTER_SHOWALL:
			{
				FilterNoSources();
				UpdateSourceItems();
				break;
			}
			case MP_SMARTFILTER:
			{
				m_bSmartFilter = !m_bSmartFilter;
			//	If we're turning smart filtering on...
				if (m_bSmartFilter)
				{
				//	Just update file items so the appropriate sources are shown.
					UpdateFileItems();
				}
			//	If we're turning smart filtering off...
				else
				{
				//	Reset the source filters on all file items and update them.
					ResetSourceFiltersForAllFiles();
				}
				break;
			}
		}

	}

	return true;
	
	EMULE_CATCH

	return false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CDownloadListCtrl::OnNMDividerDoubleClick(NMHEADER *pHeader, LRESULT *pResult)
{
	EMULE_TRY

	int		iColumn = pHeader->iItem;

	m_iColumnMaxWidths[iColumn] = 0;
	m_iMeasuringColumn = iColumn;
	Invalidate();
	UpdateWindow();
	m_iMeasuringColumn = -1;
	if (m_iColumnMaxWidths[iColumn] != 0)
	{
		SetColumnWidth(iColumn,m_iColumnMaxWidths[iColumn]);
	}
	else
	{
		CMuleListCtrl::OnNMDividerDoubleClick(pHeader,pResult);
	}
	Invalidate();

	EMULE_CATCH

	return *pResult = TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	NM_LISTVIEW		*pNMListView = reinterpret_cast<NM_LISTVIEW*>(pNMHDR);

	bool	bIsCtrl = GetAsyncKeyState(VK_CONTROL) < 0;

	if (!bIsCtrl)
	{
		m_bSortAscending = (m_iCurrentSortItem != pNMListView->iSubItem) ? true : !m_bSortAscending;
		m_iCurrentSortItem = pNMListView->iSubItem;
		SetSortArrow(m_iCurrentSortItem, m_bSortAscending);
	}
	else
	{
		m_bSortSourcesAscending = (m_iSourceSortItem != pNMListView->iSubItem) ? true : !m_bSortSourcesAscending;
		m_iSourceSortItem = pNMListView->iSubItem;
		SetSortArrow(m_iSourceSortItem, m_bSortSourcesAscending);
	}
	m_iSourceSortItem2 = -1;
	m_dwLastSortCode = m_iCurrentSortItem + (m_bSortAscending ? MLC_SORTASC : MLC_SORTDESC)
					+ ((m_iSourceSortItem + (m_bSortSourcesAscending ? MLC_SORTASC : MLC_SORTDESC)) << 16)
					+ (MLC_DONTSORT << 24);
	SortItems(SortProc, m_dwLastSortCode);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortItem(CPreferences::TABLE_DOWNLOAD, m_iCurrentSortItem);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortAscending(CPreferences::TABLE_DOWNLOAD, m_bSortAscending);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortItem(CPreferences::TABLE_DOWNLOAD2, m_iSourceSortItem);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortAscending(CPreferences::TABLE_DOWNLOAD2, m_bSortSourcesAscending);

	EMULE_CATCH

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CDownloadListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSortCode)
{
	EMULE_TRY

	CMuleCtrlItem		*pItem1 = reinterpret_cast<CMuleCtrlItem*>(lParam1);
	CPartFileDLItem		*pFileItem1 = dynamic_cast<CPartFileDLItem*>(pItem1);
	CSourceDLItem		*pSourceItem1 = dynamic_cast<CSourceDLItem*>(pItem1);
	CMuleCtrlItem		*pItem2 = reinterpret_cast<CMuleCtrlItem*>(lParam2);
	CPartFileDLItem		*pFileItem2 = dynamic_cast<CPartFileDLItem*>(pItem2);
	CSourceDLItem		*pSourceItem2 = dynamic_cast<CSourceDLItem*>(pItem2);
	int					iFileSortItem = 0;
	int					iSourceSortItem = 0;
	int					iSourceSortItem2 = -1;
    int					iFileSortMod = 1;
	int					iSourceSortMod = 1;
	int					iSourceSortMod2 = 1;
	DWORD				dwFilesSortCode = lParamSortCode & 0xFF;
	DWORD				dwSourceSortCode = (lParamSortCode >> 16) & 0xFF;
	DWORD				dwSourceSortCode2 = (lParamSortCode >> 24) & 0xFF;
	bool				bSortSourceCol2 = false;
//
//	Extract the sort items and sort flags from the sort code
//
    if ((dwFilesSortCode & MLC_SORTDESC) != 0)
    {
		iFileSortMod = -1;
	}
	iFileSortItem = dwFilesSortCode & MLC_COLUMNMASK;

	if ((dwSourceSortCode & MLC_SORTDESC) != 0)
	{
		iSourceSortMod = -1;
	}
	iSourceSortItem = dwSourceSortCode & MLC_COLUMNMASK;

	if (dwSourceSortCode2 != MLC_DONTSORT)
	{
		bSortSourceCol2 = true;
		if ((dwSourceSortCode2 & MLC_SORTDESC) != 0)
		{
			iSourceSortMod2 = -1;
		}
		iSourceSortItem2 = dwSourceSortCode2 & MLC_COLUMNMASK;
	}

	int		iCompare;

//	Files vs source?
	if (pFileItem1 != NULL && pSourceItem2 != NULL)
	{
		CPartFile	*pPartFile1 = pFileItem1->GetFile();
		CPartFile	*pPartFile2 = pSourceItem2->GetParentFile();

		if (pPartFile1 != pPartFile2)
			iCompare = Compare(pPartFile1, pPartFile2, iFileSortItem) * iFileSortMod;
		else
			iCompare = -1;
	}
	else if (pSourceItem1 != NULL && pFileItem2 != NULL)
	{
		CPartFile	*pPartFile1 = pSourceItem1->GetParentFile();
		CPartFile	*pPartFile2 = pFileItem2->GetFile();

		if (pPartFile1 != pPartFile2)
			iCompare = Compare(pPartFile1, pPartFile2, iFileSortItem) * iFileSortMod;
		else
			iCompare = 1;
	}
	else
	{
	//	Both files? (!)
		if (pFileItem1 != NULL)
		{
			CPartFile	*pPartFile1 = pFileItem1->GetFile();
			CPartFile	*pPartFile2 = pFileItem2->GetFile();

			iCompare = Compare(pPartFile1, pPartFile2, iFileSortItem) * iFileSortMod;
		} 
	//	Both sources...
		else 
		{
			iCompare = Compare(pSourceItem1->GetParentFile(), pSourceItem2->GetParentFile(),iFileSortItem) * iFileSortMod;

		//	If the sources aren't for the same file...
			if (iCompare != 0)
			{ 
				return iCompare;
			}
		//Cax2: A4AF clients kept separate, unless sorting for name
			if ( (pSourceItem1->IsAskedForAnotherFile() || pSourceItem2->IsAskedForAnotherFile())
			  && iSourceSortItem != DLCOL_FILENAME )
			{
				int		n = 0;

				if (pSourceItem1->IsAskedForAnotherFile() && !pSourceItem2->IsAskedForAnotherFile())
				{	
					n = 1;
				}
				if (!pSourceItem1->IsAskedForAnotherFile() && pSourceItem2->IsAskedForAnotherFile())
				{	
					n = -1;
				}
				if (n != 0)			//always at the end, unless sort by source - then bIsA4AF always at the top
				{	
					iCompare = /*(iFileSortItem == DLCOL_PROGRESS) ? -n : n*/ n;
				}
				else
				{
#ifdef OLD_SOCKETS_ENABLED
					iCompare = Compare(pSourceItem1->GetSource(), pSourceItem2->GetSource(), iSourceSortItem, !bSortSourceCol2) * iSourceSortMod;
					if (bSortSourceCol2 && iCompare == 0)
					{
						iCompare = Compare(pSourceItem1->GetSource(), pSourceItem2->GetSource(), iSourceSortItem2) * iSourceSortMod2;
					}
#endif //OLD_SOCKETS_ENABLED
				}
			}
			else
			{
#ifdef OLD_SOCKETS_ENABLED
				iCompare = Compare(pSourceItem1->GetSource(), pSourceItem2->GetSource(), iSourceSortItem, !bSortSourceCol2) * iSourceSortMod;
				if (bSortSourceCol2 && iCompare == 0)
				{
					iCompare = Compare(pSourceItem1->GetSource(), pSourceItem2->GetSource(), iSourceSortItem2) * iSourceSortMod2;
				}
#endif //OLD_SOCKETS_ENABLED
			}
	    }
	}

   	return iCompare;

	EMULE_CATCH

	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::SetStyle() 
{
	EMULE_TRY

	SetExtendedStyle(LVS_EX_FULLROWSELECT);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::SortInit(int override)
{
	EMULE_TRY

	m_dwSortTime = ::GetTickCount();
	if (override)
		override = DL_OVERRIDESORT;
	if (override == DL_OVERRIDESORT) //major override, wipe old sorting order...
	{
		DWORD		dwFilesSortCode = g_eMuleApp.m_pGlobPrefs->GetDownloadSortCol();
		DWORD		dwSourceSortCode = g_eMuleApp.m_pGlobPrefs->GetSrcSortCol1();
		bool		bUseSourceSort2 = g_eMuleApp.m_pGlobPrefs->DoUseSrcSortCol2();
		DWORD		dwSourceSortCode2 = bUseSourceSort2 ? g_eMuleApp.m_pGlobPrefs->GetSrcSortCol2() : MLC_DONTSORT;

		m_dwLastSortCode = (dwSourceSortCode2 << 24) | (dwSourceSortCode << 16) | dwFilesSortCode;
		m_bSortAscending = (dwFilesSortCode & MLC_SORTDESC) == 0;
		m_bSortSourcesAscending = (dwSourceSortCode & MLC_SORTDESC) == 0;
		m_bSortSourcesAscending2 = bUseSourceSort2 ? (dwSourceSortCode2 & MLC_SORTDESC) == 0 : true;
		m_iCurrentSortItem = dwFilesSortCode & MLC_COLUMNMASK;
		m_iSourceSortItem = dwSourceSortCode & MLC_COLUMNMASK;
		m_iSourceSortItem2 = bUseSourceSort2 ? (dwSourceSortCode2 & MLC_COLUMNMASK) : -1;
		SetSortArrow(m_iCurrentSortItem, m_bSortAscending);
	}
	SortItems(&SortProc, m_dwLastSortCode);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnListModified(NMHDR *pNMHDR, LRESULT *pResult) 
{
	EMULE_TRY

	NM_LISTVIEW *pNMListView = (NM_LISTVIEW*)pNMHDR;

	//this works because true is equal to 1 and false equal to 0
	BOOL notLast = pNMListView->iItem + 1 != GetItemCount();
	BOOL notFirst = pNMListView->iItem != 0;

	// Lord KiRon
	CRect rcViewRect;
	GetViewRect(&rcViewRect);
	CRect rcItemRect;
	GetItemRect(pNMListView->iItem,&rcItemRect,LVIR_BOUNDS);
	CRect rcIntersection;
	rcIntersection.IntersectRect(rcViewRect,rcItemRect);
	if (!rcIntersection.IsRectEmpty())
	{
		RedrawItems(pNMListView->iItem - notFirst, pNMListView->iItem + notLast);
	}
	// Lord KiRon - end
	//RedrawItems(pNMListView->iItem - notFirst, pNMListView->iItem + notLast);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	CompareFileNames() compares the names of 'pFile1' and 'pFile2' and returns -1 for <, 0 for ==, and 1 for >
/*static*/ int CDownloadListCtrl::CompareFileNames(CPartFile* pFile1, CPartFile* pFile2)
{
    CString		strFileName1 = pFile1->GetFileName();
    CString		strFileName2 = pFile2->GetFileName();

    if  (strFileName1.IsEmpty() || strFileName2.IsEmpty())
    {   
		return 0;
	}
    else
	{   
		return _tcsicmp(strFileName1,strFileName2);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Compare() compares the two part files 'file1' and 'file2' by column 'lParamSort' and returns
//		-1, 0, or 1 for <, ==, or > respectively.
/*static*/ int CDownloadListCtrl::Compare(CPartFile *file1, CPartFile *file2, LPARAM lParamSort) 
{
	int		iCompare = 0;

	EMULE_TRY

	if (file1 == NULL || file2 == NULL)
	{
		return 0;
	}
	switch (lParamSort)
	{
		case DLCOL_FILENAME: //filename asc
		//	Obaldin: funny, but we might not have a filename yet..
        {
		//	See below
			break;
        }
		case DLCOL_SIZE:
		{
			if (file1->GetFileSize() ==  file2->GetFileSize())
				iCompare = 0;
			else if (file1->GetFileSize() < file2->GetFileSize())
				iCompare = -1;
			else
				iCompare = 1;
			break;
		}
		case DLCOL_TRANSFERRED:
		{
			iCompare = CompareUnsigned(file1->GetTransferred(), file2->GetTransferred());
			break;
		}
	    case DLCOL_COMPLETED:
		{
			iCompare = CompareUnsigned(file1->GetCompletedSize(), file2->GetCompletedSize());
			break;
		}
		case DLCOL_SPEED:
		{
			iCompare = CompareUnsigned(file1->GetDataRate(), file2->GetDataRate());
			if (iCompare == 0)
				iCompare = CompareUnsigned(file1->GetAvgDataRate(), file2->GetAvgDataRate());
			break;
		}
		case DLCOL_PROGRESS:
		{
			double		dblComp = file1->GetPercentCompleted() - file2->GetPercentCompleted();

			if (dblComp < .01 && dblComp > -.01)
				dblComp = 0.0;
			iCompare = (dblComp > 0) ? 1 : ((dblComp < 0) ? -1 : 0);
			break;
		}
		case DLCOL_NUMSOURCES: //sources asc
		{
			iCompare = file1->GetSourceCount() - file2->GetSourceCount();
			break;
		}
		case DLCOL_PRIORITY: //priority asc
		{
			iCompare = file1->GetPriority() - file2->GetPriority();
			break;
		}
		case DLCOL_STATUS: //Status asc 
		{
			iCompare = file1->getPartfileStatusRang() - file2->getPartfileStatusRang();
			break;
		}
		case DLCOL_REMAINING: //Remaining size asc
		{
			int		tmp1 = file1->GetFileSize()-file1->GetCompletedSize();
			int		tmp2 = file2->GetFileSize()-file2->GetCompletedSize();

			iCompare = (tmp1 == tmp2) ? 0 : ((tmp1 < tmp2) ? -1 : 1);
			break;
		}
		case DLCOL_REMAININGTIME: //Remaining Time asc
		{
			int		time1 = file1->GetTimeRemaining();
			int		time2 = file2->GetTimeRemaining();

			time1 = time1 == -1 ? INT_MAX : time1;	// -1 time indicates "unknown". Compare as if "never".
			time2 = time2 == -1 ? INT_MAX : time2;
			iCompare = (time1 > time2) ? 1 : ((time1 < time2) ? -1 : 0);

			int		tmp1 = file1->GetTimeRemaining(true);
			int		tmp2 = file2->GetTimeRemaining(true);

			tmp1 = tmp1 == -1 ? INT_MAX : tmp1;	// -1 time indicates "unknown". Compare as if "never".
			tmp2 = tmp2 == -1 ? INT_MAX : tmp2;
			if (iCompare == 0)
			{
				iCompare = (tmp1 > tmp2) ? 1 : ((tmp1 < tmp2) ? -1 : 0);
			}
			//if no remaining time sort by remaining size asc. Leave completed files last...
			tmp1=(file1->GetStatus()==PS_COMPLETING || file1->GetStatus()==PS_COMPLETE);
			tmp2=(file2->GetStatus()==PS_COMPLETING || file2->GetStatus()==PS_COMPLETE);
			if ((tmp1) && (tmp2))
			{	
				iCompare = 0;
			}
			if (tmp2)
			{	
				iCompare = -1;
			}
			if (tmp1)
			{	
				iCompare = 1;
			}
			break;
		}
		case DLCOL_LASTSEENCOMPLETE: //Last seen complete asc 
		{
		    if (file1->lastseencomplete > file2->lastseencomplete)
			{    
				iCompare = 1;
			}
		    else if(file1->lastseencomplete < file2->lastseencomplete)
			{    
				iCompare = -1;
			}
		    else
			{    
				iCompare = 0;
			}
			break;
		}
		case DLCOL_LASTRECEIVED:
		{
			if (file1->GetFileDate() > file2->GetFileDate())
			{
				iCompare = 1;
			}
			else if (file1->GetFileDate() < file2->GetFileDate())
			{	
				iCompare = -1;
			}
			else
			{
				iCompare = 0;
			}
			break;
		}
		case DLCOL_CATEGORY:
		{
			CCat		*pCat1 = CCat::GetCatByID(file1->GetCatID());
			CCat		*pCat2 = CCat::GetCatByID(file2->GetCatID());
			CString		strFile1CatTitle = pCat1 == NULL ? _T("") : pCat1->GetTitle();
			CString		strFile2CatTitle = pCat2 == NULL ? _T("") : pCat2->GetTitle();

			if (strFile1CatTitle > strFile2CatTitle)
				iCompare = 1;
			else if (strFile1CatTitle < strFile2CatTitle)
				iCompare = -1;
			else
				iCompare = 0;
		}
		case DLCOL_WAITED:
		{
			CTimeSpan	ts1 = CTime::GetCurrentTime() - file1->GetLastDownTransfer();
			CTimeSpan	ts2 = CTime::GetCurrentTime() - file2->GetLastDownTransfer();

			iCompare = (ts1 > ts2) ? 1 : ((ts1 < ts2) ? -1 : 0);
			break;
		}
		case DLCOL_AVGSPEED:
			iCompare = CompareUnsigned(file1->GetAvgDataRate(), file2->GetAvgDataRate());
			if (iCompare == 0)
				iCompare = CompareUnsigned(file1->GetDataRate(), file2->GetDataRate());
			break;
		case DLCOL_AVGREMTIME:
		{
			int		time1 = file1->GetTimeRemaining(true);
			int		time2 = file2->GetTimeRemaining(true);

			time1 = time1 == -1 ? INT_MAX : time1;	// -1 time indicates "unknown". Compare as if "never".
			time2 = time2 == -1 ? INT_MAX : time2;
			iCompare = (time1 > time2) ? 1 : ((time1 < time2) ? -1 : 0);

			int		tmp1 = file1->GetTimeRemaining();
			int		tmp2 = file2->GetTimeRemaining();

			tmp1 = tmp1 == -1 ? INT_MAX : tmp1;	// -1 time indicates "unknown". Compare as if "never".
			tmp2 = tmp2 == -1 ? INT_MAX : tmp2;
			if (iCompare == 0)
			{
				iCompare = (tmp1 > tmp2) ? 1 : ((tmp1 < tmp2) ? -1 : 0);
			}
			//if no remaining time sort by remaining size asc. Leave completed files last...
			tmp1=(file1->GetStatus()==PS_COMPLETING || file1->GetStatus()==PS_COMPLETE);
			tmp2=(file2->GetStatus()==PS_COMPLETING || file2->GetStatus()==PS_COMPLETE);
			if ((tmp1) && (tmp2))
			{	
				iCompare = 0;
			}
			if (tmp2)
			{	
				iCompare = -1;
			}
			if (tmp1)
			{	
				iCompare = 1;
			}
			break;
		}
		case DLCOL_ETA:
		{
			int		time1 = file1->GetTimeRemaining();
			int		time2 = file2->GetTimeRemaining();

			time1 = time1 == -1 ? INT_MAX : time1;	// -1 time indicates "unknown". Compare as if "never".
			time2 = time2 == -1 ? INT_MAX : time2;
			iCompare = (time1 > time2) ? 1 : ((time1 < time2) ? -1 : 0);

			int		tmp1 = file1->GetTimeRemaining(true);
			int		tmp2 = file2->GetTimeRemaining(true);

			if (iCompare == 0)
			{
				tmp1 = tmp1 == -1 ? INT_MAX : tmp1;	// -1 time indicates "unknown". Compare as if "never".
				tmp2 = tmp2 == -1 ? INT_MAX : tmp2;
				iCompare = (tmp1 > tmp2) ? 1 : ((tmp1 < tmp2) ? -1 : 0);
			}
			//if no remaining time sort by remaining size asc. Leave completed files last...
			tmp1=(file1->GetStatus()==PS_COMPLETING || file1->GetStatus()==PS_COMPLETE);
			tmp2=(file2->GetStatus()==PS_COMPLETING || file2->GetStatus()==PS_COMPLETE);
			if ((tmp1) && (tmp2))
			{	
				iCompare = 0;
			}
			if (tmp2)
			{	
				iCompare = -1;
			}
			if (tmp1)
			{	
				iCompare = 1;
			}
			break;
		}
		case DLCOL_AVGETA:
		{
			int		time1 = file1->GetTimeRemaining(true);
			int		time2 = file2->GetTimeRemaining(true);

			time1 = time1 == -1 ? INT_MAX : time1;	// -1 time indicates "unknown". Compare as if "never".
			time2 = time2 == -1 ? INT_MAX : time2;
			iCompare = (time1 > time2) ? 1 : ((time1 < time2) ? -1 : 0);

			int		tmp1 = file1->GetTimeRemaining();
			int		tmp2 = file2->GetTimeRemaining();

			if (iCompare == 0)
			{
				tmp1 = tmp1 == -1 ? INT_MAX : tmp1;	// -1 time indicates "unknown". Compare as if "never".
				tmp2 = tmp2 == -1 ? INT_MAX : tmp2;
				iCompare = (tmp1 > tmp2) ? 1 : ((tmp1 < tmp2) ? -1 : 0);
			}
			//if no remaining time sort by remaining size asc. Leave completed files last...
			tmp1=(file1->GetStatus()==PS_COMPLETING || file1->GetStatus()==PS_COMPLETE);
			tmp2=(file2->GetStatus()==PS_COMPLETING || file2->GetStatus()==PS_COMPLETE);
			if ((tmp1) && (tmp2))
			{	
				iCompare = 0;
			}
			if (tmp2)
			{	
				iCompare = -1;
			}
			if (tmp1)
			{	
				iCompare = 1;
			}
			break;
		}
	}
	
	if (iCompare == 0)
		iCompare = CompareFileNames(file1,file2);

	EMULE_CATCH

	return iCompare;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Compare() compares the two sources 'pClient1' and 'pClient2' by column 'lParamSort' and returns
//		-1, 0, or 1 for <, ==, or > respectively.
/*static*/ int CDownloadListCtrl::Compare( CUpDownClient *pClient1,CUpDownClient *pClient2, LPARAM lParamSort,
										   bool bDisambiguate/*=true*/ )
{
	int		iCompare = 0;

	EMULE_TRY

	if (pClient1==NULL||pClient2==NULL)
		return 0;

	switch (lParamSort)
	{
		case DLCOL_FILENAME:
		{
		//	See below
			break;
		}
		case DLCOL_TRANSFERRED:
		{
			if (!g_eMuleApp.m_pGlobPrefs->IsTransferredOnCompleted())
			    iCompare = CompareUnsigned(pClient1->GetTransferredDown(), pClient2->GetTransferredDown());
			break;
		}
		case DLCOL_COMPLETED:
		{
			if (g_eMuleApp.m_pGlobPrefs->IsTransferredOnCompleted())
			    iCompare = CompareUnsigned(pClient1->GetTransferredDown(), pClient2->GetTransferredDown());
			break;
		}
		case DLCOL_SPEED:
		{
			iCompare = CompareUnsigned(pClient1->GetDownloadDataRate(), pClient2->GetDownloadDataRate());
			break;
		}
		case DLCOL_PROGRESS:
		{
			iCompare = (pClient1->GetAvailablePartCount() - pClient2->GetAvailablePartCount());
			break;
		}
		case DLCOL_NUMSOURCES:
		{
			if (pClient1->GetClientSoft() == SO_UNKNOWN || pClient2->GetClientSoft() == SO_UNKNOWN )
			{
				iCompare = (pClient1->GetClientSoft()-pClient2->GetClientSoft());		//Cax2 append all unknown ones at the end
			}
			else if (pClient1->GetClientSoft() == pClient2->GetClientSoft())
			{
				if (pClient1->IsEmuleClient())
				{
					uint32 plus1=(pClient1->GetPlusVersion()<0x2600)?pClient1->GetPlusVersion():0;
					uint32 plus2=(pClient2->GetPlusVersion()<0x2600)?pClient2->GetPlusVersion():0;
					if (plus1 && plus2) 
						iCompare = plus2 - plus1;
					else if (plus1 || plus2)
						iCompare = (plus1) ? -1 : 1;
					else if (pClient1->GetMuleVersion() == pClient2->GetMuleVersion())
					{
						if (!pClient1->GetModVersion().IsEmpty() && !pClient2->GetModVersion().IsEmpty())
							iCompare = _tcsicmp(pClient1->GetModVersion(), pClient2->GetModVersion());
						else if (!pClient1->GetModVersion().IsEmpty() || !pClient2->GetModVersion().IsEmpty())
							iCompare = (pClient1->GetModVersion().IsEmpty()) ? 1 : -1;
					}
					else
						iCompare = pClient2->GetMuleVersion() - pClient1->GetMuleVersion();
				}
				else
				{
					iCompare = pClient2->GetVersion() - pClient1->GetVersion();
				}
			}
			else
			{
				iCompare = pClient1->GetClientSoft() - pClient2->GetClientSoft();
			}
			break;
		}
		case DLCOL_PRIORITY:
		{
			if (pClient1->GetDownloadState()!=DS_ONQUEUE || pClient2->GetDownloadState()!=DS_ONQUEUE)	//Cax2 QR gaps bugfix
			{
				if (pClient1->GetClientSoft() == SO_UNKNOWN || pClient2->GetClientSoft() == SO_UNKNOWN )		//Cax2 append all unknown ones at the end
				{
					iCompare = (pClient1->GetClientSoft()-pClient2->GetClientSoft());							//Cax2 append all unknown ones at the end
				}
				else if (pClient1->GetDownloadState()==DS_DOWNLOADING || pClient2->GetDownloadState()==DS_DOWNLOADING)		//Cax2 QR gaps bugfix
				{
					iCompare = (pClient1->GetDownloadState()==DS_DOWNLOADING)?((pClient2->GetDownloadState()==DS_DOWNLOADING)?0:-1):2; //Cax2 QR gaps bugfix
				}
				else
				{
					iCompare = (pClient1->GetDownloadState()!=DS_ONQUEUE)?((pClient2->GetDownloadState()!=DS_ONQUEUE)?0:1):-1;		//Cax2 now should show properly...
				}
			}
			else if ((pClient1->GetRemoteQueueRank()>0 && pClient2->GetRemoteQueueRank()>0))
			{
				iCompare = pClient1->GetRemoteQueueRank() - pClient2->GetRemoteQueueRank();   
			}
			else if (pClient1->GetRemoteQueueRank()==0 && pClient2->GetRemoteQueueRank()==0)
			{
				iCompare = (pClient1->IsEmuleClient())?((pClient2->IsEmuleClient())?0:-1):2;	//"queue full" or " " ?
			}
			else
			{
				iCompare = (pClient1->GetRemoteQueueRank()==0)?((pClient2->GetRemoteQueueRank()==0)?0:2):-1;
			}
			break;
		}
		case DLCOL_STATUS: //Status column - Lord KiRon
		{
			iCompare = pClient1->GetDownloadStateAsString().Compare(pClient2->GetDownloadStateAsString());
			break;
		}
		case DLCOL_ULDLRATIO: // UL/DL column - Maverick
		case DLCOL_QLRATING: // Ratio column - Maverick
		{	//Cax2 - faster this way & less code to go wrong...
			if (pClient1->GetClientSoft() == SO_UNKNOWN || pClient2->GetClientSoft() == SO_UNKNOWN )	//Cax2 append all unknown ones at the end
			{
				iCompare = (pClient1->GetClientSoft()-pClient2->GetClientSoft());					//Cax2 append all unknown ones at the end
			}
			else
			{
				bool	isValid1 = (pClient1->IsRemoteInfoAvaiable()|| pClient1->m_pCredits);
				bool	isValid2 = (pClient2->IsRemoteInfoAvaiable()|| pClient2->m_pCredits);

				if ( lParamSort==10 && isValid1 && isValid2)											//Cax2 - bugfix after reCDVst changes 
				{
					iCompare = (pClient1->GetRemoteBaseModifier() <pClient2->GetRemoteBaseModifier())?-1:1;	//Cax2 - has to return an integer!
				}
				else if (isValid1 && isValid2)																//Cax2 - it's got to be lParamSort==11 after reCDVst changes 
				{
					iCompare = pClient1->GetRemoteRatio() - pClient2->GetRemoteRatio();
				}
				else if (isValid1)
				{
					iCompare = 1;
				}
				else if (isValid2)
				{
					iCompare = -1;
				}
				else
				{
					iCompare = 0;
				}
			}
			break;
		}
		case DLCOL_LASTSEENCOMPLETE:
			break;
		case DLCOL_LASTRECEIVED:
			break;
		case DLCOL_CATEGORY:
			break;
		case DLCOL_WAITED:
		{
			uint32		iWaitSeconds1 = pClient1->GetQueueWaitTime();
			uint8		ds1 = pClient1->GetDownloadState();
			uint32		iWaitSeconds2 = pClient2->GetQueueWaitTime();
			uint8		ds2 = pClient2->GetDownloadState();

			if (ds1 != DS_ONQUEUE)
			{
				iWaitSeconds1 = INT_MAX;
			}
			if (ds2 != DS_ONQUEUE)
			{
				iWaitSeconds2 = INT_MAX;
			}
			iCompare = ((iWaitSeconds1 < iWaitSeconds2) ? -1 : ((iWaitSeconds1 > iWaitSeconds2) ? 1 : 0));
			break;
		}
		case DLCOL_AVGSPEED:
			break;
		case DLCOL_AVGREMTIME:
			break;
		case DLCOL_ETA:
			break;
		case DLCOL_AVGETA:
			break;
	}
	
	if (iCompare == 0 && bDisambiguate)
	{
		CString		sName1, sName2;

		try
		{ sName1 = CString(pClient1->GetUserName()); }
		catch(...)
		{ sName1 = _T(""); }
		try
		{ sName2 = CString(pClient2->GetUserName()); }
		catch(...)
		{ sName2 = _T(""); }
		if (sName1.IsEmpty() || sName2.IsEmpty())
			iCompare = (sName1.IsEmpty()) ? ((sName2.IsEmpty()) ? 0 : 1) : -1;	//Cax2 append all unknown ones at the end
		else
			iCompare = _tcsicmp(sName1, sName2);
	}
	EMULE_CATCH
	return iCompare;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	RefreshInfo();

	DWORD pos = GetMessagePos();
	CPoint pt(LOWORD(pos), HIWORD(pos));
	ScreenToClient(&pt);

	// Get indexes of the first and last visible items in 
	// the listview control.
	int index = GetTopIndex();
	int last_visible_index = index + GetCountPerPage();
	if(last_visible_index > GetItemCount())
		last_visible_index = GetItemCount();

	// Loop until number visible items has been reached.
	while(index <= last_visible_index)
	{
		// Get the bounding rectangle of an item. If the mouse
		// location is within the bounding rectangle of the item,
		// you know you have found the item that was being clicked.
		CRect r;
		GetItemRect(index, &r, LVIR_BOUNDS);
		if(r.PtInRect(pt))
		{
			CMuleCtrlItem	*pListItem = ListGetItemAt(index);
			CPartFileDLItem	*pFileItem = dynamic_cast<CPartFileDLItem*>(pListItem);

			if (pFileItem == NULL)			// if it isn't a file we're done
				return;

		// [+]/[-]
			CRect rPlusMinus(r);
			rPlusMinus.left += 2;
			rPlusMinus.top += 2;
			rPlusMinus.right = rPlusMinus.left + OFFSET_PLUSMINUS;
			rPlusMinus.bottom = rPlusMinus.top + 16;
			if(rPlusMinus.PtInRect(pt))
				OnItemActivate(pNMHDR, pResult);

			if (g_eMuleApp.m_pGlobPrefs->ShowFullFileStatusIcons())
			{
			// File Status
				CRect rFileStatus(r);
				rFileStatus.left += 2;
				rFileStatus.left += OFFSET_PLUSMINUS;
				rFileStatus.top += 2;
				rFileStatus.right = rFileStatus.left + OFFSET_STATUSICON;
				rFileStatus.bottom = rFileStatus.top + 16;
				if(rFileStatus.PtInRect(pt))
				{
					CPartFile *pPartFile = pListItem->GetFile();

					if (pPartFile == NULL)
						return;

					if((pPartFile->GetStatus() == PS_PAUSED || pPartFile->GetStatus() == PS_STOPPED))
					{
						pPartFile->ResumeFile();
					}
					else if (pPartFile->GetStatus() == PS_COMPLETE)
					{
						g_eMuleApp.m_pDownloadList->ClearCompleted(pPartFile->GetFileHash());
					}
					else if (pPartFile->GetStatus() == PS_ERROR)
					{
						pPartFile->LoadPartFile(pPartFile->GetTempDir(), pPartFile->GetPartMetFileName());
						if (pPartFile->GetStatus(true) == PS_READY)
							g_eMuleApp.m_pSharedFilesList->SafeAddKnownFile(pPartFile);
					}
				}
			}

		// rating
			CRect rRating(r);
			rRating.left += 2;
			if (g_eMuleApp.m_pGlobPrefs->ShowFullFileStatusIcons())
				rRating.left += OFFSET_STATUSICON;
			rRating.left += OFFSET_PLUSMINUS;
			if (g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
				rRating.left += OFFSET_FILETYPEICON;
			rRating.top += 2;
			rRating.right = rRating.left + OFFSET_RATINGICON;
			rRating.bottom = rRating.top + 16;
			if(rRating.PtInRect(pt))
			{
				CPartFile *pPartFile = pListItem->GetFile();
				if(!pPartFile)
					return;
				if(pPartFile->HasComment()||pPartFile->HasRating())		//Cax2 - bugfix!
				{	
					CCommentDialogLst dlg(pPartFile);
					dlg.DoModal();
				}
            }
			break;
		}

		// Get the next item in listview control.
		index++;
	}
	
	*pResult = 0;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnNMDblclkDownloadlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	int		iSel = GetSelectionMark();

	if (iSel != -1)
	{
		CMuleCtrlItem		*pItem = ListGetOneSelectedItem();
		CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

		if (pFileItem != NULL)		//Cax2: doubleclick opens completed files
		{
			CPartFile		*pPartFile = pFileItem->GetFile();

			if (pPartFile->GetStatus() == PS_COMPLETE)
			{
				CString		strBuffer;

				strBuffer.Format(_T("%s\\%s"),pPartFile->GetPath(),pPartFile->GetFileName());
				AddLogLine(false, _T("%s\\%s"),pPartFile->GetPath(),pPartFile->GetFileName());
				ShellOpenFile(strBuffer);
			}
		}
		else if (pSourceItem != NULL)	//client  options
		{
#ifdef OLD_SOCKETS_ENABLED
			CUpDownClient		*pSource = pSourceItem->GetSource();

			if (g_eMuleApp.m_pGlobPrefs->GetDetailsOnClick())
			{
				CClientDetails		dialog(GetResString(IDS_CD_TITLE), pSource, this, 0);

				dialog.DoModal();
			} 
			else 
			{
				g_eMuleApp.m_pdlgEmule->m_wndChat.StartSession(pSource);
			}
#endif //OLD_SOCKETS_ENABLED
		}
	}
	
	*pResult = 0;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnSize(UINT nType, int cx, int cy)
{
	EMULE_TRY

	CListCtrl::OnSize(nType, cx, cy);
	Invalidate();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Original by deltHF and Rod modified by Tarod
// After that modded by Vorlost too 
void CDownloadListCtrl::RestartWaitingDownloads() 
{ 
	EMULE_TRY

	CTypedPtrList<CPtrList, CPartFile*>		selectedList;

	int			iNumItems = GetItemCount();
	POSITION	pos;

//	Vorlost - get initial sources from server if we dont have our MaxSourcesPerFile Limit reached 
	for (int i = 0; i != iNumItems; i++)
	{
		CMuleCtrlItem		*pItem = ListGetItemAt(i);
		CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

		if ( pFileItem != NULL
		  && pFileItem->GetFile()->GetSourceCount() <= g_eMuleApp.m_pGlobPrefs->GetMaxSourcePerFile() )
		{
			selectedList.AddTail(pFileItem->GetFile());
	   	} 
	}

	iNumItems = selectedList.GetCount();

	for (pos = selectedList.GetHeadPosition(); pos != 0; selectedList.GetNext(pos)) 
		selectedList.GetAt(pos)->GetSourcesAfterServerConnect();
    
	AddLogLine(true,IDS_NEWSERVERCONNECT,g_eMuleApp.m_pGlobPrefs->GetMaxSourcePerFile());

	selectedList.RemoveAll();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	EMULE_TRY

	RefreshInfo();

	if (nChar == VK_CONTROL)
	{
		SetSortArrow(m_iCurrentSortItem, m_bSortAscending);
	}
	CMuleListCtrl::OnKeyUp(nChar, nRepCnt, nFlags);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ShowAllUploadingSources()
{
	EMULE_TRY

	CDownloadList::PartFileItemVector	   *pvecFileItems = g_eMuleApp.m_pDownloadList->GetFileItems();

	for (uint32 i = 0; i < pvecFileItems->size(); i++)
	{
		CPartFileDLItem		*pFileItem = (*pvecFileItems)[i];

		if (pFileItem != NULL)
		{
			pFileItem->m_bSrcsAreVisible = true;
			pFileItem->FilterAllSources();
		//	Unfilter just uploading sources
			pFileItem->m_bShowUploadingSources = true;
			UpdateSourceItems();
		}
	}

	delete pvecFileItems;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	EMULE_TRY

	bool	bHandled = false;

	bool	isShift=GetAsyncKeyState(VK_SHIFT) < 0;
	bool	isCtrl=GetAsyncKeyState(VK_CONTROL) < 0;
	bool	isAlt=GetAsyncKeyState(VK_MENU) < 0;

	CMuleCtrlItem		*pItem = ListGetOneSelectedItem();
	CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
	CPartFile			*pPartFile = NULL;

	if (pFileItem != NULL)
	{
		pPartFile = pFileItem->GetFile();
	}

	if (nChar == VK_CONTROL)
	{
		if (m_iSourceSortItem2 == -1)
		{
			SetSortArrow(m_iSourceSortItem, m_bSortSourcesAscending);
		}
		else
		{
			SetSortArrow(m_iSourceSortItem, m_bSortSourcesAscending,1);
			SetSortArrow(m_iSourceSortItem2, m_bSortSourcesAscending2,2);
		}
	}

	if (isCtrl)
	{
		if (nChar == 'U')
		{
			bHandled = true;

			ShowAllUploadingSources();
		}
		else if (nChar == 'R' && pFileItem != NULL)
		{
			bHandled = true;

			CFileDetails		dialog(GetResString(IDS_FD_TITLE), pPartFile, this, 0);

			dialog.SetActivePage(2);
			dialog.DoModal();
			SetSortArrow(m_iCurrentSortItem, m_bSortAscending);
		}
		else if (nChar == 'S' && g_eMuleApp.m_pGlobPrefs->DoUseSort())
		{
			bHandled = true;

			SortInit(DL_OVERRIDESORT);
		}
	}
	if (!bHandled)
		CMuleListCtrl::OnKeyDown(nChar, nRepCnt, nFlags);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::RefreshInfo(void)
{
	EMULE_TRY

	POSITION		pos = GetFirstSelectedItemPosition();

	if (pos == NULL)
	{			
 		g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.SetList(INFOLISTTYPE_NONE);
	} 
	else 
	{
		CMuleCtrlItem		*pItem = ListGetOneSelectedItem();
		CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

		if (pFileItem != NULL)
		{
			const CPartFile		*pPartFile = pFileItem->GetFile();

 			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.SetList(INFOLISTTYPE_FILE,const_cast<CPartFile*>(pPartFile));
		} 
		else if (pSourceItem != NULL)
		{
#ifdef OLD_SOCKETS_ENABLED
			const CUpDownClient	*pSource = pSourceItem->GetSource();

 			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlInfoList.SetList(INFOLISTTYPE_SOURCE,const_cast<CUpDownClient*>(pSource));
#endif //OLD_SOCKETS_ENABLED
		}	
	}	

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	ShowFilesCount() updates the display of the number of downloading files.
void CDownloadListCtrl::ShowFilesCount() 
{
	g_eMuleApp.m_pdlgEmule->m_wndTransfer.UpdateDownloadHeader();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ShowSelectedFileDetails() 
{
	EMULE_TRY

	POINT		point;

	::GetCursorPos(&point);

	CPoint		p = point;

    ScreenToClient(&p);

    int			it = HitTest(p);

	SetSelectionMark(it);   // display selection mark correctly! 

    if (it == -1)
		return;

	CMuleCtrlItem		*pItem = ListGetOneSelectedItem();
	CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
	CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

	if (pFileItem != NULL)
	{
		CPartFile		*pPartFile = pFileItem->GetFile();

		if ((pPartFile->HasComment() || pPartFile->HasRating()) && p.x < 13) // 13????? FOR SHAME :P
		{
			CCommentDialogLst		dialog(pPartFile);

			dialog.DoModal();
		}
		else 
		{
			CFileDetails		dialog(GetResString(IDS_FD_TITLE), pPartFile, this, 0);
			dialog.DoModal();
		}
	}
	else if (pSourceItem != NULL)
	{
#ifdef OLD_SOCKETS_ENABLED
		CUpDownClient		*pSource = pSourceItem->GetSource();
		CClientDetails		dialog(GetResString(IDS_CD_TITLE), pSource, this, 0);
		dialog.DoModal();
#endif //OLD_SOCKETS_ENABLED
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	ChangeCategory() changes the currently displayed category given a category ID.
void CDownloadListCtrl::ChangeCategoryByID(EnumCategories eNewCatID)
{
	int		iNewCatIndex = 0;

	iNewCatIndex = CCat::GetCatIndexByID(eNewCatID);

	if (iNewCatIndex == -1)
		iNewCatIndex = m_iCurTabIndex;

	ChangeCategoryByIndex(iNewCatIndex);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	ChangeCategoryByIndex() changes the currently displayed category given a category (i.e. tab) index.
void CDownloadListCtrl::ChangeCategoryByIndex(uint8 iNewCatIndex)
{
	SetRedraw(FALSE);

	m_iCurTabIndex = iNewCatIndex;
	m_eCurTabCat = CCat::GetCatIDByIndex(iNewCatIndex);

//	Remove all displayed files with a different cat and show the correct ones
	CDownloadList::PartFileItemVector	*pvecPartFileItems = g_eMuleApp.m_pDownloadList->GetFileItems();
	uint32								iNumFiles = pvecPartFileItems->size();

	for (uint32 i = 0; i < iNumFiles; i++)
	{
		CPartFileDLItem		*pFileItem = (*pvecPartFileItems)[i];

		if (!CCat::FileBelongsToGivenCat(pFileItem->GetFile(),m_eCurTabCat))
			HideFileItem(pFileItem);
		else 
			ShowFileItem(pFileItem);
	}
	delete pvecPartFileItems;

	SetRedraw(TRUE);
	SortInit(false);
	ShowFilesCount();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::HideSourceItem(CSourceDLItem *pSourceItem)
{
//	Find entry in list and update object
	int		iSourceIndex = ListGetSourceItemIndex(pSourceItem);

	if (iSourceIndex != -1)
	{
		pSourceItem->SetVisibility(false);
		DeleteItem(iSourceIndex);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::HideFileItem(CPartFileDLItem *pFileItem)
{
	EMULE_TRY

	HideSources(pFileItem->GetFile());

	int		iFileIndex = ListGetFileItemIndex(pFileItem);

	if (iFileIndex != -1)
	{
		pFileItem->SetVisibility(false);
		DeleteItem(iFileIndex);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ShowFileItem(CPartFileDLItem *pFileItem)
{
	EMULE_TRY

	int		iFileIndex = ListGetFileItemIndex(pFileItem);

	if (iFileIndex == -1)
	{
		ListInsertFileItem(pFileItem,GetItemCount());
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ShowSourceItem(CSourceDLItem *pSourceItem)
{
	EMULE_TRY

	int		iSourceIndex = ListGetSourceItemIndex(pSourceItem);

//	If the source item isn't already in the list...
	if (iSourceIndex == -1)
	{
		CPartFileDLItem	   *pParentFileItem = pSourceItem->GetParentFileItem();
	//	Find the position of the next file item or the end of the list
		int					iParentFileIndex = ListGetFileItemIndex(pParentFileItem);
		int					iInsertionIndex = 0;

		if (iParentFileIndex > 0)
			iInsertionIndex = iParentFileIndex;
	//	Until we hit the end of the list or the next item is a file item...
		while ( iInsertionIndex+1 < GetItemCount()
				&& typeid(*ListGetItemAt(iInsertionIndex+1)) != typeid(CPartFileDLItem))
		{
			iInsertionIndex++;
		}
		ListInsertSourceItem(pSourceItem,iInsertionIndex+1);
	}

	EMULE_CATCH	
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::OnGetDispInfo(NMHDR* pNMHDR, LRESULT* pResult)
{
    NMLVDISPINFO* pDispInfo = (NMLVDISPINFO*)pNMHDR;
	/*TRACE("CDownloadListCtrl::OnGetDispInfo iItem=%d iSubItem=%d", pDispInfo->item.iItem, pDispInfo->item.iSubItem);
	if (pDispInfo->item.mask & LVIF_TEXT)
		TRACE(" LVIF_TEXT");
	if (pDispInfo->item.mask & LVIF_IMAGE)
		TRACE(" LVIF_IMAGE");
	if (pDispInfo->item.mask & LVIF_STATE)
		TRACE(" LVIF_STATE");
	TRACE("\n");*/

	// Although we have an owner drawn listview control we store the text for the primary item in the listview, to be
	// capable of quick searching those items via the keyboard. Because our listview items may change their contents,
	// we do this via a text callback function. The listview control will send us the LVN_DISPINFO notification if
	// it needs to know the contents of the primary item.
	//
	// But, the listview control sends this notification all the time, even if we do not search for an item. At least
	// this notification is only sent for the visible items and not for all items in the list. Though, because this
	// function is invoked *very* often, no *NOT* put any time consuming code here in.

    if (pDispInfo->item.mask & LVIF_TEXT)
	{
        CMuleCtrlItem		*pItem = reinterpret_cast<CMuleCtrlItem*>(pDispInfo->item.lParam);
		CPartFileDLItem		*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

		if (pFileItem != NULL && pFileItem->GetFile() != NULL)
		{
			switch (pDispInfo->item.iSubItem)
			{
				case 0:
					if (pDispInfo->item.cchTextMax > 0)
					{
						_tcsncpy(pDispInfo->item.pszText, pFileItem->GetFile()->GetFileName(), pDispInfo->item.cchTextMax);
						pDispInfo->item.pszText[pDispInfo->item.cchTextMax-1] = _T('\0');
					}
					break;
				default:
					// shouldn't happen
					pDispInfo->item.pszText[0] = _T('\0');
					break;
			}
		}
		else if (pSourceItem != NULL && pSourceItem->GetParentFile() != NULL)
		{
#ifdef OLD_SOCKETS_ENABLED
			switch (pDispInfo->item.iSubItem)
			{
				case 0:
					if (pSourceItem->GetSource()->GetUserName() != "" && pDispInfo->item.cchTextMax > 0)
					{
						_tcsncpy(pDispInfo->item.pszText, pSourceItem->GetSource()->GetUserName(), pDispInfo->item.cchTextMax);
						pDispInfo->item.pszText[pDispInfo->item.cchTextMax-1] = _T('\0');
					}
					break;
				default:
					// shouldn't happen
					pDispInfo->item.pszText[0] = _T('\0');
					break;
			}
#else
			pDispInfo->item.pszText[0] = _T('\0');
#endif //OLD_SOCKETS_ENABLED
		}
		else
		{
			ASSERT(0);
		}
    }
    *pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//	List methods

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ListInsertFileItem(CPartFileDLItem *pFileItem, int iPos)
{
	CMuleCtrlItem		*pItem = dynamic_cast<CMuleCtrlItem*>(pFileItem);

	InsertItem(LVIF_PARAM|LVIF_TEXT,iPos,LPSTR_TEXTCALLBACK,0,0,0,reinterpret_cast<LPARAM>(pItem));
	pFileItem->SetVisibility(true);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ListInsertSourceItem(CSourceDLItem *pSourceItem, int iPos)
{
	CMuleCtrlItem		*pItem = dynamic_cast<CMuleCtrlItem*>(pSourceItem);

	InsertItem(LVIF_PARAM|LVIF_TEXT,iPos,LPSTR_TEXTCALLBACK,0,0,0,reinterpret_cast<LPARAM>(pItem));
	pSourceItem->SetVisibility(true);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	ListGetFileItemIndex() returns the list index of 'pFileItem' or -1 if it isn't in the list.
int CDownloadListCtrl::ListGetFileItemIndex(CPartFileDLItem *pFileItem)
{
	LVFINDINFO		find;

	find.flags = LVFI_PARAM;
	find.lParam = reinterpret_cast<LPARAM>(dynamic_cast<CMuleCtrlItem*>(pFileItem));

	int iItem = FindItem(&find);

	return iItem;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	ListGetSourceItemIndex() returns the list index of 'pSourceItem' or -1 if it isn't in the list.
int CDownloadListCtrl::ListGetSourceItemIndex(CSourceDLItem *pSourceItem)
{
	LVFINDINFO		find;

	find.flags = LVFI_PARAM;
	find.lParam = reinterpret_cast<LPARAM>(dynamic_cast<CMuleCtrlItem*>(pSourceItem));

	int		iItem = FindItem(&find);

	return iItem;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	ListGetItemAt() returns the list item at index 'iIndex'.
CMuleCtrlItem *CDownloadListCtrl::ListGetItemAt(int iIndex)
{
	return reinterpret_cast<CMuleCtrlItem*>(GetItemData(iIndex));
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	PostRefreshMessage() puts a message into the list control's message queue telling it it needs to
//		refresh dirty files and sources and then immediately returns.
void CDownloadListCtrl::PostRefreshMessage()
{
	if (::IsWindow(GetSafeHwnd()) && g_eMuleApp.m_app_state != CEmuleApp::APP_STATE_SHUTINGDOWN)
	{
		MSG		msg;

	//	If there's no refresh message already in the message queue... (don't want to flood it)
		if (!::PeekMessage(&msg,m_hWnd,WM_DL_REFRESH,WM_DL_REFRESH,false))
		{
		//	... then post one with the current time so we know how long the request has been pending when we get it.
			PostMessage(WM_DL_REFRESH,0,static_cast<LPARAM>(::GetCurrentTime()));
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	FilterNoSources() turns off filtering for all source types.
void CDownloadListCtrl::FilterNoSources()
{
	m_bShowUploadingSources = true;
	m_bShowOnQueueSources = true;
	m_bShowFullQueueSources = true;
	m_bShowConnectedSources = true;
	m_bShowConnectingSources = true;
	m_bShowNNPSources = true;
	m_bShowTooManyConnSources = true;
	m_bShowLowToLowIDSources = true;
	m_bShowBannedSources = true;
	m_bShowErrorSources = true;
	m_bShowA4AFSources = true;
	m_bShowUnknownSources = true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	FilterAllSources() turns on filtering for all source types.
void CDownloadListCtrl::FilterAllSources()
{
	m_bShowUploadingSources = false;
	m_bShowOnQueueSources = false;
	m_bShowFullQueueSources = false;
	m_bShowConnectedSources = false;
	m_bShowConnectingSources = false;
	m_bShowNNPSources = false;
	m_bShowTooManyConnSources = false;
	m_bShowLowToLowIDSources = false;
	m_bShowBannedSources = false;
	m_bShowErrorSources = false;
	m_bShowA4AFSources = false;
	m_bShowUnknownSources = false;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CDownloadListCtrl::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN)
	{
		int iMessage = 0;
		short nCode = GetCodeFromPressedKeys(pMsg);
		CMuleCtrlItem *pItem = ListGetOneSelectedItem();
		CPartFileDLItem *pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

		if (pFileItem != NULL)
		{
			CPartFile* pPartFile = pFileItem->GetFile();
			bool bJustOne  = (GetSelectedCount() == 1);
			bool bFileDone = (pPartFile->GetStatus() == PS_COMPLETE || pPartFile->GetStatus() == PS_COMPLETING );
			EnumPartFileStatuses eFileStatus = pPartFile->GetStatus();

			if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLCancel) && !bFileDone)
			{
				iMessage = MP_CANCEL;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLStop) &&
					  eFileStatus != PS_STOPPED && eFileStatus != PS_ERROR && !bFileDone )
			{
				iMessage = MP_STOP;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLPause) &&
					  eFileStatus != PS_PAUSED && eFileStatus != PS_STOPPED && eFileStatus != PS_ERROR && !bFileDone )
			{
				iMessage = MP_PAUSE;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLResume) &&
					  (eFileStatus == PS_PAUSED || eFileStatus == PS_STOPPED) )
			{
				iMessage = MP_RESUME;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLOpen) &&
					  bJustOne && eFileStatus == PS_COMPLETE )
			{
				iMessage = MP_OPEN;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLPreview) &&
					  bJustOne && pPartFile->PreviewAvailable() )
			{
				iMessage = MP_PREVIEW;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLComments) &&
				      bJustOne && (pPartFile->HasComment() || pPartFile->HasRating()) )
			{
				iMessage = MP_VIEWFILECOMMENTS;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLDetails) && bJustOne)
			{
				iMessage = MP_METINFO;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLClear))
			{
				iMessage = MP_CLEARCOMPLETED;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLPreallocate) &&
					  bJustOne && !pPartFile->IsLastBlockComplete() && !pPartFile->IsPreallocated() )
			{
				iMessage = MP_PREALLOCATE;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLA4AF) &&
					  bJustOne && eFileStatus != PS_COMPLETE && eFileStatus != PS_COMPLETING )
			{
				iMessage = MP_ALL_A4AF_TO_HERE;
			}
			else if ( nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLA4AFAuto) &&
					  bJustOne && eFileStatus != PS_COMPLETE && eFileStatus != PS_COMPLETING )
			{
				iMessage = MP_ALL_A4AF_AUTO;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLED2KLink))
			{
				iMessage = MP_GETED2KLINK;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLED2kLinkHtml))
			{
				iMessage = MP_GETHTMLED2KLINK;
			}
			else if (nCode == g_eMuleApp.m_pGlobPrefs->GetShortcutCode(IndexDLED2kLinkSource))
			{
				iMessage = MP_GETSOURCEED2KLINK;
			}
		}

		if (iMessage > 0)
		{
			PostMessage(WM_COMMAND, iMessage);
			return TRUE;
		}
	}

	return __super::PreTranslateMessage(pMsg);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	AutoSetSourceFilters() automatically sets the source filters for a file based on its current state.
//		It is used for the "smart filtering" feature.
void CDownloadListCtrl::AutoSetSourceFilters(CPartFileDLItem *pFileItem)
{
	CPartFile			   *pPartFile = pFileItem->GetFile();
	EnumPartFileStatuses	eStatus = static_cast<_EnumPartFileStatuses>(pPartFile->GetPartfileStatusID());

//	If the file is downloading, show only uploading sources.
	if (eStatus == PS_DOWNLOADING)
	{
		pFileItem->FilterAllSources();
		pFileItem->m_bShowUploadingSources = true;
	}
//	If the file is waiting, show only the sources whose upload queue we're on...
	else if (eStatus == PS_WAITINGFORSOURCE)
	{
		pFileItem->FilterAllSources();
	//	If the file has no "on queue" sources, show only connecting/asking sources
		if (pPartFile->GetOnQueueSrcCount() == 0)
		{
			pFileItem->m_bShowConnectingSources = true;
			pFileItem->m_bShowConnectedSources = true;
		}
		else
		{
			pFileItem->m_bShowOnQueueSources = true;
		}
	}
	else
	{
		pFileItem->FilterNoSources();
	}
	UpdateSourceItems(pFileItem);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CDownloadListCtrl::ResetSourceFiltersForAllFiles()
{
	CDownloadList::PartFileItemVector	*pvecFileItems = g_eMuleApp.m_pDownloadList->GetFileItems();

	for (uint32 i = 0; i < pvecFileItems->size(); i++)
	{
		(*pvecFileItems)[i]->FilterNoSources();
		UpdateFileItem((*pvecFileItems)[i]);
	}

	delete pvecFileItems;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
