//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


/******************************************************************
 *               Based on eMule v0.29c MorphNext 1c               *
 *                      Adaptation by DropF                       *
 ******************************************************************/


#include "StdAfx.h"
#include "fakecheck.h"
#include "emule.h"
#include "otherfunctions.h"
#include "HttpDownloadDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CFakecheck::CFakecheck()
{
	m_sLastHit = "";
	LoadFromDatFile();
}

CFakecheck::~CFakecheck()
{
	RemoveAllFakes();
}

void CFakecheck::AddFake(CString Hash, uint32 Lenght, CString Realtitle)
{
	FakeMap::iterator	it = m_mapFakes.find(Hash);

	if (it == m_mapFakes.end())
	{
		Fakes_Struct	*newFilter = new Fakes_Struct();

		newFilter->Hash = Hash;
		newFilter->Lenght = Lenght;
		newFilter->RealTitle = Realtitle;
		m_mapFakes[Hash] = newFilter;
	}
	else
	{
//		g_eMuleApp.AddDebugLogLine(false,_T("%s: Duplicate hash %s (%s). Not adding."),__FUNCTION__,Hash,Realtitle);
	}
}

int CFakecheck::LoadFromDatFile()
{
	CString sbuffer, sbuffer2, sbuffer3, sbuffer4;
	int pos, fakecounter;
	CString Hash, Title;
	uint32 Lenght;
	char buffer[1024];
	int lenBuf = 1024;
	fakecounter = 0;
	RemoveAllFakes();
	FILE* readFile = fopen(CString(g_eMuleApp.m_pGlobPrefs->GetConfigDir()) + "fakes.dat", "r");
	if (readFile != NULL)
	{
		while (!feof(readFile))
		{
			if (fgets(buffer, lenBuf, readFile) == 0)
				break;
			sbuffer = buffer;
			if (sbuffer.GetAt(0) == '#' || sbuffer.GetAt(0) == '/' || sbuffer.GetLength() < 5)
				continue;
			pos = sbuffer.Find(',');
			if (pos == -1)
				continue;
			Hash = sbuffer.Left(pos).Trim();
			Hash.MakeUpper();
			int pos2 = sbuffer.Find(",", pos + 1);
			if (pos2 == -1)
				continue;
			sbuffer2 = sbuffer.Mid(pos + 1, pos2 - pos - 1).Trim();
			Lenght = atoi(sbuffer2);
			sbuffer2 = sbuffer.Mid(pos2 + 1, sbuffer.GetLength() - pos2 - 2);
			Title = sbuffer2;
			AddFake(Hash, Lenght, Title);
			fakecounter++;
		}
		fclose(readFile);
		return fakecounter;
	}
	else
	{
		return 0;
	}

}

void CFakecheck::RemoveAllFakes()
{
	Fakes_Struct * search;

	map<CString, Fakes_Struct*>::const_iterator it;
	for (it = m_mapFakes.begin(); it != m_mapFakes.end(); ++it)
	{
		search = (*it).second;
		delete search;
	}

	m_mapFakes.clear();
}

CString CFakecheck::IsFake(CString Hash2test, uint32 lenght)
{
	if (m_mapFakes.size() == 0)
		return ""; //MORPH - Modified by IceCream, return a CString
	Fakes_Struct* search;

	map<CString, Fakes_Struct*>::const_iterator it = m_mapFakes.upper_bound(Hash2test);
	it--;
	do
	{
		search = (*it).second;
		if (search->Hash == Hash2test && search->Lenght == lenght)
		{
			m_sLastHit = search->RealTitle;
			return m_sLastHit;
		}
		else
			return "OK";
		it--;
	}
	while (it != m_mapFakes.begin());
	return ""; //MORPH - Modified by IceCream, return a CString
}
bool CFakecheck::DownloadFakeList()
{
	char buffer[5];
	int lenBuf = 5;
	bool forced = false;
	CString sbuffer;
	CString strURL = g_eMuleApp.m_pGlobPrefs->GetFakeListURL() + "fakes.txt";
	CString strTempFilename;
	strTempFilename.Format(CString(g_eMuleApp.m_pGlobPrefs->GetAppDir()) + "fakes.txt");
	FILE* readFile = fopen(strTempFilename, "r");
	if (readFile != NULL)
	{
		fclose(readFile);
		remove(strTempFilename);
	}
//	step2 - try to download server.met
	CHttpDownloadDlg dlgDownload;
	dlgDownload.m_sURLToDownload = strURL;
	dlgDownload.m_sFileToDownloadInto = strTempFilename;
	if (dlgDownload.DoModal() != IDOK)
	{
		g_eMuleApp.m_pdlgEmule->AddLogLine(true, GetResString(IDS_FAKE_CHECKUPERROR));
		return false;
	}
	readFile = fopen(strTempFilename, "r");
	if (fgets(buffer, lenBuf, readFile) == 0)
		return false;
	sbuffer = buffer;
	sbuffer = sbuffer.Trim();
	fclose(readFile);
	remove(strTempFilename);
	strTempFilename.Format(CString(g_eMuleApp.m_pGlobPrefs->GetConfigDir()) + "fakes.dat");
	readFile = fopen(strTempFilename, "r");
	if (readFile == NULL)
		forced = true;
//	Mighty Knife: Some cleanup against these nasty signed-unsigned-conflict messages
	if ((g_eMuleApp.m_pGlobPrefs->GetFakesDatVersion() < (uint32) atoi(sbuffer)) || (forced))
	{
	//	[end] Mighty Knife
		g_eMuleApp.m_pGlobPrefs->SetFakesDatVersion(atoi(sbuffer));
		strURL = g_eMuleApp.m_pGlobPrefs->GetFakeListURL() + "fakes.dat";
		strTempFilename.Format(CString(g_eMuleApp.m_pGlobPrefs->GetConfigDir()) + "fakes.dat");
	//FILE* readFile= fopen(strTempFilename, "r");
		if (readFile != NULL)
		{
			fclose(readFile);
			remove(strTempFilename);
		}
		CHttpDownloadDlg dlgDownload;
		dlgDownload.m_sURLToDownload = strURL;
		dlgDownload.m_sFileToDownloadInto = strTempFilename;
		if (dlgDownload.DoModal() != IDOK)
		{
			g_eMuleApp.m_pdlgEmule->AddLogLine(true, GetResString(IDS_FAKE_CHECKUPERROR));
			return false;
		}
	}
	return(LoadFromDatFile() > 0);
}