#pragma once
#include "afxcmn.h"
#include "KeyboardShortcut.h"
#include "afxwin.h"
#include "resource.h"

// change here the number of actions
//#define NUMBER_OF_ACTIONS (IndexShED2kLinkSource + 1) //((sizeof(enum Indexes))/(sizeof(IndexGalMinimize)))

// define here 1 index for 1 action
// WARNING: the action indexes must follow the same order than in the tree
enum Indexes
{
	IndexGalMinimize,
	IndexGalSwitchWindow,
	IndexGalShowServer,
	IndexGalShowTransfer,
	IndexGalShowSearch,
	IndexGalShowShare,
	IndexGalShowChat,
	IndexGalShowIRC,
	IndexGalShowStats,
	IndexGalShowPrefs,
	IndexDLCancel,
	IndexDLStop,
	IndexDLPause,
	IndexDLResume,
	IndexDLOpen,
	IndexDLPreview,
	IndexDLComments,
	IndexDLDetails,
	IndexDLClear,
	IndexDLPreallocate,
	IndexDLA4AF,
	IndexDLA4AFAuto,
	IndexDLED2KLink,
	IndexDLED2kLinkHtml,
	IndexDLED2kLinkSource,
	IndexULDetails,
	IndexULFriend,
	IndexULMessage,
	IndexULFiles,
	IndexShOpenFolder,
	IndexShComments,
	IndexShED2KLink,
	IndexShED2kLinkHtml,
	IndexShED2kLinkSource,
	NUMBER_OF_ACTIONS	// number of actions in this enum (WARNING: this constant must remain at the end of the enum!)
};

typedef struct
{
	HTREEITEM h_Handle;
	CKeyboardShortcut Shortcut;
	UINT uStringID;
} ShortcutTreeItem;


// CPPgShortcuts dialog

class CPPgShortcuts : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgShortcuts)

public:
	CPPgShortcuts();
	virtual ~CPPgShortcuts();

// Donnes de bote de dialogue
	enum { IDD = IDD_PPG_SHORTCUTS };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // Prise en charge DDX/DDV

	DECLARE_MESSAGE_MAP()
public:
	CTreeCtrl shortcutsTree;
	virtual BOOL OnInitDialog();
private:
	CImageList imagelistShortcutsTree;
	ShortcutTreeItem m_ShortcutTreeItem[NUMBER_OF_ACTIONS];
	HTREEITEM h_general;
	HTREEITEM h_generalShowWindow;
	HTREEITEM h_download;
	HTREEITEM h_downloadAdvanced;
	HTREEITEM h_downloadED2KLinks;
	HTREEITEM h_upload;
	HTREEITEM h_share;
	HTREEITEM h_shareED2KLinks;
	void LoadSettings(void);
	void LoadShortcut(HTREEITEM item);
	void SaveShortcut(HTREEITEM item);

	CButton shortcutsEnableCheck;
	CButton shortcutsAltCheck;
	CButton shortcutsCtrlCheck;
	CButton shortcutsShiftCheck;
	CButton shortcutsWinCheck;
	CStatic shortcutsStaticLbl;
	CComboBox shortcutsKeyCombo;
protected:
	CPreferences *m_pPrefs;

	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	BOOL shortcutsEnable;
	BOOL shortcutsAlt;
	BOOL shortcutsCtrl;
	BOOL shortcutsShift;
	BOOL shortcutsWin;

	CKeyboardShortcut m_GeneralMinimizeWindowToTray;
	CKeyboardShortcut m_GeneralShowServerWnd;
	CKeyboardShortcut m_GeneralShowTransferWnd;
	CKeyboardShortcut m_GeneralShowSearchWnd;
	CKeyboardShortcut m_GeneralShowSharedFilesWnd;
	CKeyboardShortcut m_GeneralShowChatWnd;
	CKeyboardShortcut m_GeneralShowIRCWnd;
	CKeyboardShortcut m_GeneralShowStatisticsWnd;
	CKeyboardShortcut m_GeneralShowPreferencesWnd;
	CKeyboardShortcut m_DownloadViewFileComments;
	CKeyboardShortcut m_DownloadViewFileDetails;
	CKeyboardShortcut m_DownloadClearCompletedFiles;
	CKeyboardShortcut m_UploadViewClientDetails;
	CKeyboardShortcut m_UploadAddClientToFriends;
	CKeyboardShortcut m_UploadSendMessageClient;
	CKeyboardShortcut m_UploadViewClientFiles;
	CKeyboardShortcut m_ShareEditFileComments;

public:
	virtual BOOL OnApply();
	void CreateShortcutsTree(void);
	void RefreshShortcutsTree(void);
	void RefreshKeyCombo(void);
	void SetPrefs(CPreferences* pPrefs)	{ m_pPrefs = pPrefs; }
	void Localize(void);
	int  GetKeyComboIndexFromShortcutKey(char cKey) const;
	char GetShortcutKeyFromKeyComboIndex(int iIndex) const;
	int  GetShortcutTreeItemIndexFromItem(HTREEITEM hItem);
	afx_msg void OnSettingsChange(void);
	afx_msg void OnEnableShortcutClick(void);
	CStatic shortcutsGroupBox;
	void UpdateCheckBoxesState(void);
	afx_msg void OnTvnSelchangingShortcutsTree(NMHDR *pNMHDR, LRESULT *pResult);
};
