//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//	SearchListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "SearchListCtrl.h"
#include "otherfunctions.h"
#include "fakecheck.h" //FakeCheck

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//	CSearchListCtrl

IMPLEMENT_DYNAMIC(CSearchListCtrl, CMuleListCtrl)

BEGIN_MESSAGE_MAP(CSearchListCtrl, CMuleListCtrl)
	ON_NOTIFY_REFLECT (NM_CUSTOMDRAW, OnCustomdraw)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnClick)
	ON_WM_CONTEXTMENU()
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CSearchListCtrl::CSearchListCtrl()
{
	memset2(&m_bSortAscending, 0, 6);
	m_pSearchList = NULL;
	m_dwResultsID = 0;
	m_bSetImageList = false; // katsyonak 05/08/2003
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::Init(CSearchList *pSearchList)
{
	SetExtendedStyle(LVS_EX_FULLROWSELECT);
	ModifyStyle(LVS_SINGLESEL, 0);

	m_pSearchList = pSearchList;

	InsertColumn(SL_COLUMN_FILENAME, GetResString(IDS_DL_FILENAME), LVCFMT_LEFT, 250, 1);
	InsertColumn(SL_COLUMN_SIZE, GetResString(IDS_DL_SIZE), LVCFMT_RIGHT, 100, 2);
	InsertColumn(SL_COLUMN_SOURCES, GetResString(IDS_DL_SOURCES), LVCFMT_RIGHT, 50, 3);
	InsertColumn(SL_COLUMN_TYPE, GetResString(IDS_TYPE), LVCFMT_LEFT, 65, 4);
	InsertColumn(SL_COLUMN_FILEHASH, GetResString(IDS_FILEID), LVCFMT_LEFT, 220, 5);
	InsertColumn(SL_COLUMN_FAKECHECK, GetResString(IDS_FAKE_CHECK_HEADER), LVCFMT_LEFT, 220); //FakeCheck

	for (int i = 0; i < SL_NUMCOLUMNS; i++)
	{
		m_bSortAscending[i] = true;
	}
	LoadSettings(CPreferences::TABLE_SEARCH);
	if (g_eMuleApp.m_pGlobPrefs->DoUseSort())
	{
		m_dwLastSortCode= g_eMuleApp.m_pGlobPrefs->GetSearchSortCol();
		SortInit(g_eMuleApp.m_pGlobPrefs->GetSearchSortCol()); //Cax2 sortdlg
	}
	else
	{
		m_iSortColumn = g_eMuleApp.m_pGlobPrefs->GetColumnSortItem(CPreferences::TABLE_SEARCH);
		m_bSortAscending[m_iSortColumn] = g_eMuleApp.m_pGlobPrefs->GetColumnSortAscending(CPreferences::TABLE_SEARCH);

		m_dwLastSortCode = m_iSortColumn | (m_bSortAscending[m_iSortColumn] ? MLC_SORTASC : MLC_SORTDESC);
		SortInit(m_dwLastSortCode);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CSearchListCtrl::~CSearchListCtrl()
{
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::SortInit(int iSortCode)
{
//	Get the sort column
	int	iSortColumn = (iSortCode & MLC_COLUMNMASK);
//	Get the sort order
	bool	bSortAscending = (iSortCode & MLC_SORTDESC) == 0;

	SetSortArrow(iSortColumn, bSortAscending);
	SortItems(&SortProc, iSortCode);
	m_bSortAscending[iSortColumn] = bSortAscending;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::Localize()
{
	if (GetSafeHwnd())
	{
		CHeaderCtrl		*pHeaderCtrl = GetHeaderCtrl();
		HDITEM			hdi;

		hdi.mask = HDI_TEXT;

		CString			strRes;

		strRes = GetResString(IDS_DL_FILENAME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(0, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SIZE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(1, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DL_SOURCES);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(2, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_TYPE);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(3, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_FILEID);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(4, &hdi);
		strRes.ReleaseBuffer();

	//	FakeCheck
		strRes = GetResString(IDS_FAKE_CHECK_HEADER);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(5, &hdi);
		strRes.ReleaseBuffer();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::AddResult(CSearchFile *pSearchFile)
{
	EMULE_TRY

	uint32		dwFileSize = pSearchFile->GetIntTagValue(FT_FILESIZE);
	uint32		dwNumSources = pSearchFile->GetIntTagValue(FT_SOURCES);

//	If there's at least one search tab...
	if (g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchTabs.GetItemCount() > 0)
	{
	//	Update tab-iWebServiceCounter for the given search pSearchFile
		CString		strName, strSource;
		int			j;
		TCHAR		tstrText[510];

		TCITEM		tabItem;

		tabItem.mask = TCIF_PARAM;

		int		iTabCounter;

		for (iTabCounter = 0; iTabCounter < g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchTabs.GetItemCount(); iTabCounter++)
		{
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchTabs.GetItem(iTabCounter, &tabItem);
			if (tabItem.lParam == pSearchFile->GetSearchID())
				break;
		}

		if (tabItem.lParam == pSearchFile->GetSearchID())
		{
			tabItem.pszText = tstrText;
			tabItem.cchTextMax = 510;
			tabItem.mask = TCIF_TEXT;
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchTabs.GetItem(iTabCounter, &tabItem);

			strName.Format(_T("%s"), tstrText);

			tabItem.mask = TCIF_PARAM;
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchTabs.GetItem(iTabCounter, &tabItem);

			strSource.Format(_T(" (%u)"), m_pSearchList->GetFoundFiles(pSearchFile->GetSearchID()));

			j = strName.ReverseFind( '(' );
			if (j > 0)
				strName = strName.Left(j - 1);
			strName.Append(strSource);

			tabItem.mask = TCIF_TEXT;
			tabItem.pszText = strName.LockBuffer();
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchTabs.SetItem(iTabCounter, &tabItem);
			strName.UnlockBuffer();
		}
	}

	if (pSearchFile->GetSearchID() != m_dwResultsID)
		return ;

	uint32		dwIndex = GetItemCount();

	if (g_eMuleApp.m_pGlobPrefs->ShowFileTypeIcon())
	{
		int		iImage = g_eMuleApp.GetFileTypeSystemImageIdx(pSearchFile->GetFileName());

		if (!m_bSetImageList && g_eMuleApp.GetSystemImageList() != NULL)
		{
		//	ASSERT( GetStyle() & LVS_SHAREIMAGELISTS );
			ApplyImageList(g_eMuleApp.GetSystemImageList());
			m_bSetImageList = true;
		}
		dwIndex = InsertItem(LVIF_TEXT | LVIF_PARAM | LVIF_IMAGE, dwIndex, pSearchFile->GetFileName(), 0, 0, iImage, (LPARAM)pSearchFile);
	}
	else
	{
		ApplyImageList(NULL);
		m_bSetImageList = false;
		dwIndex = InsertItem(LVIF_TEXT | LVIF_PARAM, dwIndex, pSearchFile->GetFileName(), 0, 0, 1, (LPARAM)pSearchFile);
	}

	TCHAR		tstrBuffer[50];

	SetItemText(dwIndex, 1, CastItoXBytes(dwFileSize));
	_itot(dwNumSources, tstrBuffer, 10);
	SetItemText(dwIndex, 2, tstrBuffer);
	SetItemText(dwIndex, 3, pSearchFile->GetFileType(true));
	SetItemText(dwIndex, 4, FileHashToString(pSearchFile->GetFileHash()));
	SetItemText(dwIndex, 5, g_eMuleApp.m_pFakeCheck->IsFake(EncodeBase16(pSearchFile->GetFileHash(), 16), pSearchFile->GetFileSize())); //FakeCheck
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::UpdateSources(CSearchFile *pSearchFile)
{
	EMULE_TRY

	LVFINDINFO		find;

	find.flags = LVFI_PARAM;
	find.lParam = reinterpret_cast<LPARAM>(pSearchFile);

	int		iIndex = FindItem(&find);

	if (iIndex != -1)
	{
		TCHAR		strBuffer[50];

		_itot(pSearchFile->GetSourceCount(), strBuffer, 10);
		SetItemText(iIndex, 2, strBuffer);
		Update(iIndex);
		RedrawItems(iIndex, iIndex); // Lord KiRon
		SortInit(m_dwLastSortCode);
	}
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::RemoveResult(CSearchFile *pSearchFile)
{
	EMULE_TRY

	LVFINDINFO		find;

	find.flags = LVFI_PARAM;
	find.lParam = reinterpret_cast<LPARAM>(pSearchFile);

	sint32		lIndex = FindItem(&find);

	if (lIndex != -1)
		DeleteItem(lIndex);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::ShowResults(uint32 dwResultsID)
{
	EMULE_TRY

	DeleteAllItems();
	m_dwResultsID = dwResultsID;
	if (m_pSearchList != NULL)
		m_pSearchList->ShowResults(m_dwResultsID);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::OnCustomdraw(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	NMLVCUSTOMDRAW		*pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>(pNMHDR);

	*pResult = CDRF_DODEFAULT;

	if (CDDS_PREPAINT == pLVCD->nmcd.dwDrawStage)
	{
		*pResult = CDRF_NOTIFYITEMDRAW;
	}
	else if (CDDS_ITEMPREPAINT == pLVCD->nmcd.dwDrawStage)
	{
		COLORREF	crText = ::GetSysColor(COLOR_WINDOWTEXT);
		uint32		dwRed = GetRValue(crText);
		uint32		dwGreen = GetGValue(crText);
		uint32		dwBlue = GetGValue(crText);

		CSearchFile		*pSearchFile = reinterpret_cast<CSearchFile*>(pLVCD->nmcd.lItemlParam);

		if (pSearchFile == NULL)
			return ;

		CKnownFile		*pKnownFile = g_eMuleApp.m_pSharedFilesList->GetFileByID(pSearchFile->GetFileHash());

	//	If it's not a completed shared file, check to see if it's a part file
		if (pKnownFile == NULL)
			pKnownFile = g_eMuleApp.m_pDownloadQueue->GetFileByID(pSearchFile->GetFileHash());

		if (pKnownFile != NULL)
		{
			if (pKnownFile->IsPartFile())
			{
			//	Already downloading
				dwRed = (pSearchFile->GetSourceCount() + 4) * 20;
				if (dwRed > 255)
					dwRed = 255;
			}
			else
			{
			//	Already downloaded
				dwGreen = 128;
			}
		}
		else
		{
			dwBlue = (pSearchFile->GetSourceCount() - 1) * 20;
			if (dwBlue > 255)
				dwBlue = 255;
		}

		pLVCD->clrText = RGB(dwRed, dwGreen , dwBlue);

		*pResult = CDRF_DODEFAULT;
	}
	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::OnColumnClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	EMULE_TRY

	NM_LISTVIEW		*pNMListView = reinterpret_cast<NM_LISTVIEW*>(pNMHDR);

//	If it's a second click on the same column then reverse the sort order,
//	otherwise sort the new column in ascending order.
	m_iSortColumn = pNMListView->iSubItem;
	m_bSortAscending[m_iSortColumn] = !m_bSortAscending[m_iSortColumn];
	SetSortArrow(m_iSortColumn, m_bSortAscending[m_iSortColumn]);
	m_dwLastSortCode = m_iSortColumn | (m_bSortAscending[m_iSortColumn] ? MLC_SORTASC : MLC_SORTDESC);
	SortItems(&SortProc, m_dwLastSortCode);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortItem(CPreferences::TABLE_SEARCH, m_iSortColumn);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortAscending(CPreferences::TABLE_SEARCH, m_bSortAscending[m_iSortColumn]);

	*pResult = 0;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CSearchListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	EMULE_TRY
	CSearchFile		*pSearchFile1 = reinterpret_cast<CSearchFile*>(lParam1);
	CSearchFile		*pSearchFile2 = reinterpret_cast<CSearchFile*>(lParam2);

	//eklmn: don't sort 
	if (pSearchFile1 == NULL || pSearchFile2 == NULL)
		return 0;

	int				iCompare = 0;
	int				iSortMod = ((lParamSort & MLC_SORTDESC) == 0) ? 1 : -1;
	int				iSortCol = lParamSort & MLC_COLUMNMASK;

	switch (iSortCol)
	{
		case SL_COLUMN_FILENAME:
		{
			iCompare = _tcsicmp(pSearchFile1->GetFileName(), pSearchFile2->GetFileName()) ;
			break;
		}
		case SL_COLUMN_SIZE:
		{
			iCompare = pSearchFile1->GetIntTagValue(FT_FILESIZE) - pSearchFile2->GetIntTagValue(FT_FILESIZE);
			break;
		}
		case SL_COLUMN_SOURCES:
		{
			iCompare = pSearchFile1->GetIntTagValue(FT_SOURCES) - pSearchFile2->GetIntTagValue(FT_SOURCES);
			break;
		}
		case SL_COLUMN_TYPE:
		{
			iCompare = _tcsicmp(pSearchFile1->GetFileType(true), pSearchFile2->GetFileType(true));
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2, SL_COLUMN_FILENAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		case SL_COLUMN_FILEHASH:
		{
			iCompare = memcmp(pSearchFile1->GetFileHash(), pSearchFile2->GetFileHash(), 16);
			break;
		}
		case SL_COLUMN_FAKECHECK:
		{
			CString	strFake1 = g_eMuleApp.m_pFakeCheck->IsFake(EncodeBase16(pSearchFile1->GetFileHash(), 16), pSearchFile1->GetFileSize());
			CString	strFake2 = g_eMuleApp.m_pFakeCheck->IsFake(EncodeBase16(pSearchFile2->GetFileHash(), 16), pSearchFile2->GetFileSize());

			iCompare = ((strFake1 > strFake2) ? 1 : ((strFake1 < strFake2) ? -1 : 0));
			break;
		}
		default:
		{
			return 0;
		}
	}
	return iCompare * iSortMod;

	EMULE_CATCH
	return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CSearchListCtrl::OnContextMenu(CWnd *pWnd, CPoint point)
{
	EMULE_TRY

	UINT		dwMenuFlags = (GetSelectionMark() != (-1) && GetSelectedCount() > 0) ? MF_ENABLED : MF_GRAYED;

	CTitleMenu	menuSearchFile;
	CMenu		menuED2K;

	menuSearchFile.CreatePopupMenu();
	menuSearchFile.AddMenuTitle(GetResString(IDS_FILE));

	menuSearchFile.AppendMenu(MF_STRING, MP_RESUME, GetResString(IDS_DOWNLOAD));
	menuSearchFile.EnableMenuItem(MP_RESUME, dwMenuFlags);
	menuSearchFile.SetDefaultItem(MP_RESUME);

	menuSearchFile.AppendMenu(MF_SEPARATOR);

	menuSearchFile.AppendMenu(MF_STRING, MP_REMOVESELECTED, GetResString(IDS_REMOVESELECTED));
	menuSearchFile.EnableMenuItem(MP_REMOVESELECTED, dwMenuFlags);
	menuSearchFile.AppendMenu(MF_STRING, MP_REMOVE, GetResString(IDS_REMOVESEARCHSTRING));
	menuSearchFile.EnableMenuItem(MP_REMOVE, dwMenuFlags);
	menuSearchFile.AppendMenu(MF_STRING, MP_REMOVEALL, GetResString(IDS_REMOVEALLSEARCH));
	menuSearchFile.EnableMenuItem(MP_REMOVEALL, dwMenuFlags);

	menuSearchFile.AppendMenu(MF_SEPARATOR);

	menuED2K.CreateMenu();
	menuED2K.AppendMenu(MF_STRING, MP_GETED2KLINK, GetResString(IDS_DL_LINK1));
	menuED2K.AppendMenu(MF_STRING, MP_GETHTMLED2KLINK, GetResString(IDS_DL_LINK2));
	menuSearchFile.AppendMenu(MF_STRING | MF_POPUP, (UINT_PTR)menuED2K.m_hMenu, GetResString(IDS_ED2KLINKFIX));
	menuSearchFile.EnableMenuItem((UINT_PTR)menuED2K.m_hMenu, dwMenuFlags);

	int		iWebServiceCounter;
	CMenu	menuWebServices;

	menuWebServices.CreateMenu();
	UpdateURLMenu(menuWebServices, iWebServiceCounter);

	UINT		dwMenuFlags2;

	dwMenuFlags2 = (iWebServiceCounter == 0) ? MF_GRAYED : MF_STRING;

	menuSearchFile.AppendMenu(dwMenuFlags2 | MF_POPUP, (UINT_PTR)menuWebServices.m_hMenu, GetResString(IDS_WEBSERVICES));
	menuSearchFile.EnableMenuItem((UINT_PTR)menuWebServices.m_hMenu, dwMenuFlags);
	if (GetSelectionMark() != ( -1) && GetSelectedCount() > 1)
		menuSearchFile.EnableMenuItem((UINT_PTR)menuWebServices.m_hMenu, MF_GRAYED);

	menuSearchFile.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
	menuWebServices.DestroyMenu();
	menuSearchFile.DestroyMenu();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CSearchListCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	EMULE_TRY

	if (GetSelectionMark() != ( -1))
	{
		CSearchFile		*pSearchFile = reinterpret_cast<CSearchFile*>(GetItemData(GetSelectionMark()));

		if (wParam >= MP_WEBURL && wParam <= MP_WEBURL + 64)
		{
			RunURL(pSearchFile, g_eMuleApp.m_strWebServiceURLArray.GetAt(wParam - MP_WEBURL));
		}
	//	For multiple selections
		UINT		dwNumSelectedFiles = GetSelectedCount();

		CTypedPtrList<CPtrList, CSearchFile*> selectedList;

		int			iIndex = -1;
		POSITION	pos = GetFirstSelectedItemPosition();

		while (pos != NULL)
		{
			iIndex = GetNextSelectedItem(pos);
			if (iIndex > -1)
			{
				selectedList.AddTail(reinterpret_cast<CSearchFile*>(GetItemData(iIndex)));
			}
		}

		switch (wParam)
		{
			case MP_GETED2KLINK:
			{
				CString		str;

				while (!selectedList.IsEmpty())
				{
					str += selectedList.GetHead()->CreateED2kLink();
					selectedList.RemoveHead();
					if (!selectedList.IsEmpty())
						str += "\n";
				}
				g_eMuleApp.CopyTextToClipboard(str);
				break;
			}
			case MP_GETHTMLED2KLINK:
			{
				CString		str;

				while (!selectedList.IsEmpty())
				{
					str += selectedList.GetHead()->CreateHTMLED2kLink();
					selectedList.RemoveHead();
					if (!selectedList.IsEmpty())
						str += "\n";
				}
				g_eMuleApp.CopyTextToClipboard(str);
				break;
			}
			case MP_RESUME:
			{
				g_eMuleApp.m_pdlgEmule->m_dlgSearch.OnBnClickedSdownload();
				break;
			}
			case MP_REMOVEALL:
			{
				g_eMuleApp.m_pdlgEmule->m_dlgSearch.DeleteAllSearchs();
				break;
			}
			case MP_REMOVESELECTED:
			{
				SetRedraw(false);
				while (!selectedList.IsEmpty())
				{
					g_eMuleApp.m_pSearchList->RemoveResults(selectedList.GetHead());
					selectedList.RemoveHead();
				}
				SetRedraw(true);
				break;
			}
		}
		selectedList.RemoveAll();
	}
	switch (wParam)
	{
		case MP_REMOVE:
		{
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.DeleteSearch(m_dwResultsID);
			break;
		}
	}
	EMULE_CATCH
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
