//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// ServerWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerWnd.h"
#include "HttpDownloadDlg.h"
#include "HTRichEditCtrl.h"
#include "NewServerDlg.h"
#include "UpdateServerMetDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CServerWnd dialog

IMPLEMENT_DYNAMIC(CServerWnd, CDialog)
CServerWnd::CServerWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CServerWnd::IDD, pParent) 
{
	m_pctlServerMsgBox = new CHTRichEditCtrl;
	m_dlgNewServer.SetParent(this);
	m_dlgUpdateServerMet.SetParent(this);
}

CServerWnd::~CServerWnd()
{	
	delete m_pctlServerMsgBox;
}

BOOL CServerWnd::OnInitDialog()
{
	CResizableDialog::OnInitDialog();
	logbox.Init(GetResString(IDS_SV_LOG));
	debugbox.Init(GetResString(IDS_SV_DEBUGLOG));
		
	m_ctlServerList.Init(g_eMuleApp.m_pServerList);
	
///////////////////////////////////////////////////

	m_ctrlBoxSwitcher.ModifyStyle(NULL, TCS_OWNERDRAWFIXED);

	m_imageList.Create(16,16,ILC_COLOR32,0,10);
	m_imageList.SetBkColor(RGB(255,0,255));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_LOG),16,16));
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SERVERINFO),16,16));
	LoadImgLstIcon(NULL,0,0); // Delete temp-icon

	CImageList		imageList;

	CBitmap Bitmap, *pOldBitmap;
	CDC *pCtrlDC = GetDC(), TempDC;
	TempDC.CreateCompatibleDC(pCtrlDC);
	Bitmap.CreateCompatibleBitmap(pCtrlDC, 16 * 2, 16);
	pOldBitmap = TempDC.SelectObject(&Bitmap);
	m_imageList.Draw(&TempDC, 0, CPoint( 0,0), ILD_NORMAL);
	m_imageList.Draw(&TempDC, 1, CPoint(16,0), ILD_NORMAL);
	TempDC.SelectObject(pOldBitmap);
	imageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	imageList.Add(&Bitmap, RGB(255,0,255));
	m_ctrlBoxSwitcher.SetImageList(&imageList);
	imageList.Detach();
	// FoRcHa
	//Bitmap.Detach();
	Bitmap.DeleteObject();
	ReleaseDC(pCtrlDC);
///////////////////////////////////////////////////////

	m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 0, GetResString(IDS_SV_LOG), 0,0,0,0);
	m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 1, GetResString(IDS_SV_SERVERINFO), 1,0,0,0);

	CRect rBox;
	GetDlgItem(IDC_LOGBOX)->GetWindowRect(rBox);
	::MapWindowPoints(NULL, m_hWnd, (LPPOINT)&rBox, 2);
	m_pctlServerMsgBox->Create(WS_VISIBLE | WS_CHILD | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE | ES_READONLY, rBox, this, 123);
	m_pctlServerMsgBox->ModifyStyleEx(0, WS_EX_STATICEDGE, SWP_FRAMECHANGED);
	m_pctlServerMsgBox->SetEventMask(m_pctlServerMsgBox->GetEventMask() | ENM_LINK);
	InitFont();	
	oldServerListIcon = GetServerLstStatic()->SetIcon(GetServerLstIcon()); //[TwoBottle Mod]
	m_pctlServerMsgBox->AppendText(CString(CString("eMule Plus v")+CString(CURRENT_VERSION_LONG)+CString("  http://emuleplus.sf.net\n")));
	m_pctlServerMsgBox->AppendText(GetResString(IDS_EMULEW)+_T(" "),false);
	m_pctlServerMsgBox->AppendHyperLink(_T(""),_T(""),GetResString(IDS_EMULEW3),_T(""),false);
	m_pctlServerMsgBox->AppendText(_T(" ")+ GetResString(IDS_EMULEW2)+ _T("\n\n"),false);
	
	m_ctrlNewServerBtn.SetThemeHelper(&g_eMuleApp.m_pdlgEmule->m_themeHelper);
	m_ctrlNewServerBtn.SetIcon(IDI_NEWSERVER);
	m_ctrlNewServerBtn.SetButtonStyle(0,TBBS_AUTOSIZE); // DonGato
	m_ctrlUpdateServerMetBtn.SetThemeHelper(&g_eMuleApp.m_pdlgEmule->m_themeHelper);
	m_ctrlUpdateServerMetBtn.SetIcon(IDI_UPDATESERVERS);
	m_ctrlUpdateServerMetBtn.SetButtonStyle(0,TBBS_AUTOSIZE); // DonGato
	m_ctrlResetLogBtn.SetThemeHelper(&g_eMuleApp.m_pdlgEmule->m_themeHelper);
	m_ctrlResetLogBtn.SetIcon(IDI_RESETLOG);
	m_ctrlResetLogBtn.SetButtonStyle(0,TBBS_AUTOSIZE); // DonGato

	AddAnchor(IDC_SERVLST_ICO, TOP_LEFT);
	AddAnchor(IDC_SERVLIST_TEXT, TOP_LEFT);
	AddAnchor(IDC_SERVLIST, TOP_LEFT, MIDDLE_RIGHT);
	AddAnchor(IDC_TAB1, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(*m_pctlServerMsgBox, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_LOGBOX, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_DEBUG_LOG, MIDDLE_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_NEWSERVER, TOP_RIGHT);
	AddAnchor(IDC_UPDATESERVERMET, TOP_RIGHT);
	AddAnchor(IDC_LOGRESET, MIDDLE_RIGHT);
	debug = false;
	ToggleDebugWindow();
	m_pctlServerMsgBox->ShowWindow(SW_HIDE);
	debugbox.ShowWindow(SW_HIDE);
	logbox.ShowWindow(SW_HIDE);
	if (logbox.m_hWnd)
		logbox.ShowWindow(SW_SHOW);

	Localize();

	return true;
}
void CServerWnd::InitFont()
{
	logbox.SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault);
	m_pctlServerMsgBox->SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault);
	debugbox.SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault);
}

void CServerWnd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SERVLIST, m_ctlServerList);
	DDX_Control(pDX, IDC_LOGBOX, logbox);
	DDX_Control(pDX, IDC_DEBUG_LOG, debugbox);
	DDX_Control(pDX, IDC_NEWSERVER, m_ctrlNewServerBtn);
	DDX_Control(pDX, IDC_UPDATESERVERMET, m_ctrlUpdateServerMetBtn);
	DDX_Control(pDX, IDC_TAB1, m_ctrlBoxSwitcher);
	DDX_Control(pDX, IDC_LOGRESET, m_ctrlResetLogBtn);
}

void CServerWnd::Localize() 
{
	if(m_hWnd)
	{		
		m_ctlServerList.Localize();

		TCHAR buffer[256];
		TCITEM ti;
		ti.mask = TCIF_TEXT;
		ti.pszText = buffer;
		ti.cchTextMax = sizeof(buffer);
        
		m_ctrlBoxSwitcher.GetItem(0, &ti);
		_stprintf(buffer, _T("%s"), GetResString(IDS_SV_LOG));
		m_ctrlBoxSwitcher.SetItem(0, &ti);
		m_ctrlBoxSwitcher.GetItem(1, &ti);
		_stprintf(buffer, _T("%s"), GetResString(IDS_SV_SERVERINFO));
		m_ctrlBoxSwitcher.SetItem(1, &ti);
		if (g_eMuleApp.m_pGlobPrefs->GetVerbose() && debug == true)
		{
		m_ctrlBoxSwitcher.GetItem(2, &ti);
		_stprintf(buffer, _T("%s"), GetResString(IDS_SV_DEBUGLOG));
		m_ctrlBoxSwitcher.SetItem(2, &ti);
		}
		m_ctrlBoxSwitcher.Invalidate();
		logbox.Invalidate();
		debugbox.Invalidate();
		m_pctlServerMsgBox->Invalidate();
		m_ctrlBoxSwitcher.SetWindowPos(&CWnd::wndBottom,0,0,0,0, SWP_NOMOVE | SWP_NOSIZE); // DonGato

		GetDlgItem(IDC_SERVLIST_TEXT)->SetWindowText(GetResString(IDS_SV_SERVERLIST));
		
		m_ctrlNewServerBtn.SetWindowText(GetResString(IDS_SV_NEWSERVER));
		m_ctrlUpdateServerMetBtn.SetWindowText(GetResString(IDS_SV_MET));
		m_ctrlResetLogBtn.SetWindowText(GetResString(IDS_PW_RESET));
	}
}

BEGIN_MESSAGE_MAP(CServerWnd, CResizableDialog)
	ON_BN_CLICKED(IDC_LOGRESET, OnBnClickedResetLog)
	ON_BN_CLICKED(IDC_UPDATESERVERMET, OnBnClickedUpdateservermet)
	ON_BN_CLICKED(IDC_NEWSERVER, OnBnClickedNewserver)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
	ON_WM_CTLCOLOR()
	ON_NOTIFY(EN_LINK, 123, OnEnLinkServerBox)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CServerWnd message handlers
void CServerWnd::OnBnClickedResetLog() 
{	
	switch(m_ctrlBoxSwitcher.GetCurSel())	// clear the visible textbox [FoRcHa]
	{
		case 0:
			g_eMuleApp.m_pdlgEmule->ResetLog();
			break;
		case 1:
			m_pctlServerMsgBox->Reset();
			break;
		case 2:
			g_eMuleApp.m_pdlgEmule->ResetDebugLog();
			break;
		default:
			break;
	}
}

void CServerWnd::OnBnClickedNewserver()
{
	CRect rBtn;
	GetDlgItem(IDC_NEWSERVER)->GetWindowRect(&rBtn);
	m_dlgNewServer.SetInitialPos(CPoint(rBtn.right,rBtn.bottom), 1);
	m_dlgNewServer.DoModal();
}

void CServerWnd::OnBnClickedUpdateservermet()
{
	CRect rBtn;
	GetDlgItem(IDC_UPDATESERVERMET)->GetWindowRect(&rBtn);
	m_dlgUpdateServerMet.SetInitialPos(CPoint(rBtn.right,rBtn.bottom), 1);
	m_dlgUpdateServerMet.DoModal();
}

void CServerWnd::AddServer(CString serveraddr, CString portstr, CString servername)
{	
	if(!serveraddr.GetLength())
	{
		AddLogLine(true, IDS_SRV_ADDR);
		return;
	}

	if(!portstr.GetLength())
	{
		AddLogLine(true, IDS_SRV_PORT);
		return;
	}

	CServer* toadd = new CServer(_tstoi(portstr),serveraddr.GetBuffer());

	// Barry - Default all manually added servers to high priority
	if( g_eMuleApp.m_pGlobPrefs->GetManualHighPrio() )
		toadd->SetPreference(CServer::SERVERPRIORITY_HIGH);

	if(servername.GetLength())
		toadd->SetListName(servername.GetBuffer());
	else
		toadd->SetListName(serveraddr.GetBuffer());
	
	if (!m_ctlServerList.AddServer(toadd,true))
	{
		CServer* update = g_eMuleApp.m_pServerList->GetServerByAddress(toadd->GetAddress(), toadd->GetPort());
		if(update)
		{
			update->SetListName(toadd->GetListName());
			m_ctlServerList.RefreshServer(*update);
		}
		delete toadd;
		AddLogLine(true, IDS_SRV_NOTADDED);
	} 
	else 
		AddLogLine(true,GetResString(IDS_SERVERADDED), toadd->GetListName());
	
	g_eMuleApp.m_pServerList->SaveServerMetToFile();
}

void CServerWnd::UpdateServerMetFromURL(CString strURL)
{
	if(strURL == "")
	{
		g_eMuleApp.m_pServerList->AutoUpdate(); 
		
		// Load Metfile
		CString strPath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("server.met"));
		g_eMuleApp.m_pServerList->AddServerMetToList(strPath, true);	// this merges servers
	
		// insert static servers from textfile
		strPath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("staticservers.dat"));
		g_eMuleApp.m_pServerList->AddServersFromTextFile(strPath);
	}
	else
	{
		if (strURL != "" && strURL.Find(_T("://")) == -1)	// not a valid URL
			{
				AddLogLine(true, IDS_INVALIDURL);
				return;
			}
		CString strTempFilename;
		strTempFilename.Format(_T("%stemp-%d-server.met"), g_eMuleApp.m_pGlobPrefs->GetConfigDir(), ::GetTickCount());
	
		CHttpDownloadDlg dlgDownload;
		dlgDownload.m_sURLToDownload = strURL;
		dlgDownload.m_sFileToDownloadInto = strTempFilename;
		if(dlgDownload.DoModal() != IDOK)
		{
			AddLogLine(true, IDS_ERR_FAILEDDOWNLOADMET, strURL);
			return;
		}
	
	//	m_ctlServerList.Hide();		
		m_ctlServerList.SetRedraw(false);	// FoRcHa
		m_ctlServerList.AddServerMetToList(strTempFilename);

		// insert static servers from textfile
		CString strPath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("staticservers.dat"));
		g_eMuleApp.m_pServerList->AddServersFromTextFile(strPath);

	//	m_ctlServerList.Show();
		m_ctlServerList.SetRedraw(true);
		_tremove(strTempFilename);
		g_eMuleApp.m_pServerList->SaveServerMetToFile();
	}
}

void CServerWnd::OnStnClickedServinfIco()
{
}

void CServerWnd::OnTcnSelchangeTab1(NMHDR *pNMHDR, LRESULT *pResult)
{
	switch(m_ctrlBoxSwitcher.GetCurSel())
	{
		case 0:
			m_ctrlBoxSwitcher.SetItemState(0, TCIS_HIGHLIGHTED, NULL);
			debugbox.ShowWindow(SW_HIDE);
			m_pctlServerMsgBox->ShowWindow(SW_HIDE);
			logbox.ShowWindow(SW_SHOW);
			break;
		case 1:
			m_ctrlBoxSwitcher.SetItemState(1, TCIS_HIGHLIGHTED, NULL);
			debugbox.ShowWindow(SW_HIDE);
			m_pctlServerMsgBox->ShowWindow(SW_SHOW);
			logbox.ShowWindow(SW_HIDE);
			break;
		case 2:
			m_ctrlBoxSwitcher.SetItemState(2, TCIS_HIGHLIGHTED, NULL);
			debugbox.ShowWindow(SW_SHOW);
			m_pctlServerMsgBox->ShowWindow(SW_HIDE);
			logbox.ShowWindow(SW_HIDE);
			break;
		default:
			break;
	}

	*pResult = 0;
}

//used now!
void CServerWnd::ToggleDebugWindow(){
	//AddLogLine(true," get verbose = %i  :: debug = %i",g_eMuleApp.m_pGlobPrefs->GetVerbose() , debug == false);
	int cur_sel = m_ctrlBoxSwitcher.GetCurSel();
	if( g_eMuleApp.m_pGlobPrefs->GetVerbose() && debug == false ){
		//AddLogLine(true,"should switch");
		m_ctrlBoxSwitcher.InsertItem(TCIF_IMAGE | TCIF_TEXT, 2, GetResString(IDS_SV_DEBUGLOG), 0,0,0,0);
		debug = true;
	}
	else if( !g_eMuleApp.m_pGlobPrefs->GetVerbose() && debug == true ) {
		if( cur_sel == 2 ){
			m_ctrlBoxSwitcher.SetCurSel(0);		//log box
			m_ctrlBoxSwitcher.SetFocus();
		}
		debugbox.ShowWindow(SW_HIDE);
		m_pctlServerMsgBox->ShowWindow(SW_HIDE);
		logbox.ShowWindow(SW_SHOW);
		m_ctrlBoxSwitcher.DeleteItem(2);
		debug = false;
	}
}

void CServerWnd::OnCancel()
{
	//CResizableDialog::OnCancel();	// pressing ESC when the focus is on the logbox									// would hide the server-wnd [FoRcHa]
}

void CServerWnd::OnEnLinkServerBox(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
	ENLINK* pEnLink = reinterpret_cast<ENLINK *>(pNMHDR);
	if (pEnLink && pEnLink->msg == WM_LBUTTONDOWN)
	{
		CString strUrl;
		m_pctlServerMsgBox->GetTextRange(pEnLink->chrg.cpMin, pEnLink->chrg.cpMax, strUrl);
		CString sLangUrl = strUrl; // GetTextRange returns '?' for non-english chars :(
		sLangUrl.Remove('?'); sLangUrl.Remove(' ');
		if (strUrl == GetResString(IDS_EMULEW3) || sLangUrl.IsEmpty())
		{
			strUrl.Format(_T("http://emuleplus.sourceforge.net/version_check.php?version=%i&language=%i"),CURRENT_PLUS_VERSION,g_eMuleApp.m_pGlobPrefs->GetLanguageID());
		}
		ShellExecute(NULL, NULL, strUrl, NULL, NULL, SW_SHOWDEFAULT);
		*pResult = 1;
	}
}

HBRUSH CServerWnd::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	if (nCtlColor == CTLCOLOR_STATIC && (pWnd->GetDlgCtrlID() == IDC_LOGBOX || pWnd->GetDlgCtrlID() == IDC_DEBUG_LOG))
	{
		// explicitly set the text color -- needed for some contrast window color schemes
		pDC->SetTextColor(GetSysColor(COLOR_WINDOWTEXT));
		pDC->SetBkColor(GetSysColor(COLOR_WINDOW));
		return GetSysColorBrush(COLOR_WINDOW);
	}
	return CResizableDialog::OnCtlColor(pDC, pWnd, nCtlColor);
}

void CServerWnd::OnDestroy()
{
	CResizableDialog::OnDestroy();

	//Resources cleanup - [TwoBottle Mod]
	DestroyIcon(GetServerLstStatic()->SetIcon(oldServerListIcon));
	m_imageList.DeleteImageList();	// eklmn: bugfix(01): resource cleanup due to ImageLists recreation
}

void CNewTabCtrl::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	EMULE_TRY

	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);

	char pBuf[255];
	int nCurItem = lpDrawItemStruct->itemID;

	TCITEM tcitem;
	tcitem.mask = TCIF_TEXT | TCIF_IMAGE | TCIF_STATE;
	tcitem.pszText = pBuf;
	tcitem.cchTextMax = sizeof(pBuf);
	tcitem.dwStateMask = TCIS_HIGHLIGHTED;
	GetItem(nCurItem,&tcitem);

	CRect rect = lpDrawItemStruct->rcItem;

//	dc.SetBkColor(GetSysColor(COLOR_BTNFACE));
	dc.SetBkMode(TRANSPARENT);

	int nIconShift = 0;
	if(nCurItem == GetCurSel())
		nIconShift += 3;
	CImageList *pImageList = GetImageList();
	if(pImageList)
		pImageList->Draw(&dc, tcitem.iImage, CPoint(rect.left + 4 + nIconShift, rect.top + 2), ILD_TRANSPARENT);

	if(tcitem.dwState & TCIS_HIGHLIGHTED)
		dc.SetTextColor(RGB(196, 0, 0));
	else
		dc.SetTextColor(GetSysColor(COLOR_BTNTEXT));

	rect.OffsetRect(10, 4);
	dc.DrawText(CString(pBuf), rect, DT_CENTER);
	dc.Detach();

	EMULE_CATCH2
}
