//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// emuleDlg.h : Headerdatei
//
#pragma once
#ifdef OLD_SOCKETS_ENABLED
#include "sockets.h"
#endif //OLD_SOCKETS_ENABLED
#include "afxcmn.h"
#include "afxwin.h"
#include "serverlistctrl.h"
#include "knownfilelist.h"
#include "TransferWnd.h"
#include "ServerWnd.h"
#include "Preferencesdlg.h"
#include "SharedFilesWnd.h"
#include "SearchDlg.h"
#include "ChatWnd.h"
#include "traydialog.h"
#include "BtnST.h"
#include "StatisticsDlg.h"
#include "MeterIcon.h"
#include "MuleToolBarCtrl.h"
#include "PreferencesDlg.h"
#include "afxdlgs.h"
#include "aboutdlg.h"
#include "ThemeHelperST.h"
#include "IrcWnd.h"
#include "TaskbarNotifier.h"
#include "WebServer.h" // kuchin
#include "MuleSystrayDlg.h"
#include "loggable.h"

#define MP_RESTORE		4001
#define MP_CONNECT		4002
#define MP_DISCONNECT	4003
#define MP_EXIT			4004

enum EnumStatusBarBoxes
{
	SB_MESSAGETEXT = 0,
	SB_SESSIONTIME,
	SB_MESSAGESTATUS,
	SB_NUMUSERS,
	SB_UPLOADRATE,
	SB_DOWNLOADRATE,
	SB_SERVER,

	SB_NUMSBPARTS,
};

class CKnownFileList; 

class CEngineData;

// CEmuleDlg Dialogfeld
class CEmuleDlg : public CTrayDialog, public CLoggable
{
friend class CMuleToolbarCtrl;
friend class 	CWebServer;
// Construction
public:
	CEmuleDlg(CWnd* pParent = NULL);	// Standard constructor
	~CEmuleDlg();
	enum { IDD = IDD_EMULE_DIALOG };

	void			AddServerMessageLine(LPCTSTR line); //merge from offic. 0.30a - bond006
	void			AddBugReport(LPCTSTR strFunctionName, LPCTSTR sFile, long nLine, CString msg);

//[TwoBottle Mod]
	void			AddLogText(bool addtostatusbar,const CString& txt,bool bDebug=false);
	//void			AddDebugLogText(bool addtostatusbar,const CString& txt);

	void			ShowConnectionState();
	void			ShowConnectionState(bool bConnected);
	void			ShowConnectionState(bool bConnected,CString server,bool iconOnly=false);
	void			ShowNotifier(CString Text, int MsgType, bool ForceSoundOFF = false, bool bMessageEnabled = false); 
	void			ShowUserCount(uint32 users_toshow, uint32 files_toshow);
	void			ShowMessageState(uint8 iconnr);
	void			ShowSessionTime();
	void			SetActiveDialog(CDialog* dlg);
	//eklmn: bugfix(11): crazy output in statusbar (update only tray or window)
	void			ShowTransferRate(bool bUpdateAll = false);
	void			ShowStatistics();
	void			Localize();
	void			ResetLog();
	void			ResetDebugLog();
	CString			GetLastLogEntry();
	CString			GetLastDebugLogEntry();
	CString			GetAllLogEntries();
	CString			GetAllDebugLogEntries();
	void			ResizeStatusBar();
	// Barry - To find out if app is running or shutting/shut down
	bool			IsRunning();
	//N@boleo Backup Feature
	void RunBackupNow(bool automated);

	CTransferWnd		m_wndTransfer;
	CServerWnd			m_wndServer;
	CPreferencesDlg		m_dlgPreferences;
	CSharedFilesWnd		m_wndSharedFiles;
	CSearchDlg			m_dlgSearch;
	CChatWnd			m_wndChat;
	CStatusBarCtrl   	m_ctlStatusBar;
	CMuleToolbarCtrl 	m_ctlToolBar;
#ifdef USE_REBAR
	CReBarCtrl          m_ctlReBar;
#endif
	CDialog			   *m_pdlgActive;
	CStatisticsDlg  	m_dlgStatistics;
	CIrcWnd				m_wndIRC;
	CTaskbarNotifier 	m_wndTaskbarNotifier;
	uint8				m_iStatus;
	CRect				m_rClientRect;
	CThemeHelperST		m_themeHelper;
	CFont				m_fontDefault;
	uint16				m_iFilesToBeHashed;
protected:
	HICON				m_hIcon;

	virtual void		DoDataExchange(CDataExchange* pDX);
	virtual BOOL		OnInitDialog();
	virtual void		OnTrayRButtonUp(CPoint pt); //bond006: systray menu gets stuck (bugfix)
	virtual BOOL		OnCommand(WPARAM wParam, LPARAM lParam);

	afx_msg void		OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void		OnPaint();
	afx_msg HCURSOR		OnQueryDragIcon();
	afx_msg void		OnTimer(UINT_PTR nIDEvent);
	afx_msg void		OnBnClickedButton2();
	afx_msg int			OnCreate(LPCREATESTRUCT lpCreateStruct);
		
	// quick-speed changer -- based on xrmb
	//afx_msg void QuickSpeedUpload(UINT nID);
	//afx_msg void QuickSpeedDownload(UINT nID);
	void QuickSpeedOther(UINT nID);
	// end of quick-speed changer

	afx_msg LRESULT OnProcessTaskUI(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnWebServerConnect(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerRemove(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebSharedFilesReload(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerAddToStatic(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerRemoveFromStatic(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnWebServerClearCompleted(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnTaskbarNotifierClicked(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnWMData(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnFileHashed(WPARAM wParam,LPARAM lParam);
	afx_msg LRESULT OnAreYouEmule(WPARAM, LPARAM);

	virtual void OnSize(UINT nType,int cx,int cy);
	void		 OnOK()			{}
	void		 OnClose();
	void		 OnCancel();
	void		 DisConnect();

	DECLARE_MESSAGE_MAP()
private:
	CMutex 			m_mutexLog; // i_a patch
	CString			m_strLogText;
	CString			m_strDebugLog;
	bool			m_bReady,m_bStartUpMinimized;	
	HICON			m_hiconConn[3];
	HICON			m_hiconTrans[4];
	HICON			m_hiconIM[3];
	HICON			m_hiconMyTray;
	HICON			m_hiconUsers;
	
	CMeterIcon 		m_trayMeterIcon;

public:
	HICON 			m_hiconSourceTray;

#ifdef NEW_SOCKETS
	CEngineData*	m_pEngineData;
#endif //NEW_SOCKETS

private:
	HICON 			m_hiconSourceTrayLowID;
	HICON 			m_hiconSourceTrayGrey;

	uint32			lastuprate;
	uint32			lastdownrate;
	CImageList		m_imageList;
	CTitleMenu		trayPopup;
	CMuleSystrayDlg *m_pSystrayDlg;
	
	UINT_PTR m_hTimer;
	static void CALLBACK Timer(HWND hwnd, UINT uiMsg, UINT idEvent, DWORD dwTime);

	void 			StartConnection();
	void 			CloseConnection();
	void 			RestoreWindow();
	void 			UpdateTrayIcon(int procent);
	void 			AddSpeedSelectorSys(CMenu* addToMenu);
	int  			GetRecMaxUpload();
	
	//N@boleo Backup Feature
	void BackupFromAppDir(LPCSTR extensionToBack,bool automated);
	void BackupFromTempDir(LPCSTR extensionToBack, bool automated);
	void BackupFiles(LPCSTR extensionToBack,bool automated, CString szPath, CString szBackupPath);

public: 
	afx_msg BOOL OnQueryEndSession();
	afx_msg void OnNcDestroy();
	BOOL TrayShow(void);
};
